#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
using namespace std;
struct item
{
    int key,prior;
    item * l;
    item * r;
    item()
    {
        l=NULL;
        r=NULL;
    }
    item(int _key, int _prior)
    {
        key=_key;
        prior=_prior;
        l=NULL;
        r=NULL;
    }
};
typedef item * pitem;
void split(pitem t, int key, pitem & l, pitem & r)
{
    if(!t)
    {
        l=r=NULL;
    }
    else if(key < t->key)
    {
        split(t->l,key,l,t->l);
        r=t;
    }
    else
    {
        split(t->r,key,t->r,r);
        l=t;
    }
}
void insert(pitem & t, pitem it)
{
    if(!t)
    {
        t=it;
    }
    else if(t->prior > it->prior)
    {
        insert(t->key > it->key ? t->l : t->r, it);
    }
    else
    {
        split(t,it->key,it->l,it->r);
        t=it;
    }
}
void merge(pitem & t, pitem l, pitem r)
{
    if(!l||!r)
    {
        t=l ? l : r;
    }
    else if(l->prior < r->prior)
    {
        merge(r->l,l,r->l);
        t=r;
    }
    else
    {
        merge(l->r,l->r,r);
        t=l;
    }
}
void erase(pitem & t, int key)
{
    if(key==t->key)
    {
        merge(t,t->l,t->r);
    }
    else
    {
        erase(t->key > key ? t->l : t->r, key);
    }
}
int find(pitem t, int x)
{
    if(!t)
    {
        return 1e9;
    }
    else
    {
        if(t->key > x)
        {
            return min(t->key,find(t->l,x));
        }
        return find(t->r,x);
    }
}
string s;
int n;
int a[200005];
int used[200005];
vector<int> v[200005];
pitem z,e;
int main()
{
	cin>>s;
	n=s.size();
	a[0]=-1;
    a[n+1]=-1;
    int i,j;
    int br=0;
    pitem nz;
    int idx=0;
	for(i=1;i<=n;i++)
    {
        a[i]=s[i-1]-'0';
        nz = new item(i,rand());
        if(a[i])
        {
            insert(e,nz);
        }
        else
        {
            insert(z,nz);
        }
    }
    int t;
    int nx;
    for(i=1;i<=n;i++)
    {
        if(used[i]) continue;
        idx++;
        if(a[i])
        {
            cout<<-1<<endl;
            return 0;
        }
        t=1;
        for(j=i;j<=n;)
        {
            used[j]=1;
            v[idx].push_back(j);
            nx=find(t ? e : z, j);
            erase(t ? z : e, j);
            if(nx==1e9) break;
            j=nx;
            t^=1;
        }
        if(t==0)
        {
            cout<<-1<<endl;
            return 0;
        }
    }
    cout<<idx<<endl;
    for(i=1;i<=idx;i++)
    {
        int sz=v[i].size();
        cout<<sz<<" ";
        for(j=0;j<sz;j++)
        {
            cout<<v[i][j]<<" ";
        }
        cout<<endl;
    }
	return 0;
}
