#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);

int n, m, h;
int a[MAXN];
vector<int> G[MAXN];

void read()
{
    cin >> n >> m >> h;
    for(int i = 1; i <= n; i++)
        cin >> a[i];

    for(int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;

        if((a[x] + 1) % h == a[y]) G[x].push_back(y);
        if((a[y] + 1) % h == a[x]) G[y].push_back(x);
    }
}

stack<int> st;
vector<vector<int> > scc;
int low[MAXN], disc[MAXN];
int dfs_time;
bool in_stack[MAXN];

void dfs(int u)
{
	low[u] = disc[u] = dfs_time++;
	in_stack[u] = true;
	st.push(u);

	for(int v: G[u])
	{
		if(disc[v] == -1)
		{
			dfs(v);
			low[u] = min(low[u], low[v]);
		}
		else if(in_stack[v] == true)
			low[u] = min(low[u], disc[v]);
	}

	if(low[u] == disc[u])
	{
		scc.push_back(vector<int>());
		while(st.top() != u)
		{
			scc[scc.size() - 1].push_back(st.top());
			in_stack[st.top()] = false;
			st.pop();
		}

		scc[scc.size() - 1].push_back(u);
		in_stack[u] = false;
		st.pop();
	}
}

vector<int> answer;
int comp[MAXN];

void tarjan()
{
	memset(disc, -1, sizeof(disc));
	dfs_time = 0;
	while(!st.empty()) st.pop();
	for(int i = 1; i <= n; i++)
		if(disc[i] == -1) dfs(i);

    for(int i = 0; i < (int)scc.size(); i++)
        for(int x: scc[i]) comp[x] = i;

	for(auto li: scc)
	{
        bool ok = true;
        for(int u: li)
            for(int v: G[u])
                if(comp[v] != comp[u])
                    ok = false;

        if(!ok) continue;

        if(answer.empty()) answer = li;
        else if(li.size() < answer.size())
            answer = li;
	}
}

void solve()
{
	tarjan();

    cout << answer.size() << endl;
    for(int x: answer) cout << x << " ";
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
