#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 1e5 + 1;
vector<int> in[MAX_N], out[MAX_N];
int u[MAX_N];
bool check[MAX_N];

int L[MAX_N];
bool in_queue[MAX_N];
int UF[MAX_N], sz[MAX_N];

int find( int n ) {
    if ( UF[n] == 0 ) {
        UF[n] = n;
        sz[n] = 1;
    }

    if ( UF[n] == n )
        return UF[n] = n;
    else
        return UF[n] = find( UF[n] );
}

bool has_in[MAX_N];
bool is_valid[MAX_N];

void unite( int x, int y ) {
    sz[find( y )] += sz[find( x )];
    UF[find( x )] = UF[find( y )];
}

void dfs( int n, int l = 0 ) {
    in_queue[n] = 1;
    check[n] = 1;
    L[n] = l;

    for ( int x : out[n] ) {
        if ( !check[x] ) {
           dfs( x, l + 1 );
            if ( L[x] <= l ) {
                unite( n, x );
                L[n] = min( L[x], L[n] );
            }
        } else if ( in_queue[x] )
            L[n] = min( L[x], L[n] );
    }

    in_queue[n] = 0;
}

int main() {
    freopen( "input.txt", "r", stdin );
    int n, m, h, x, y;
    cin >> n >> m >> h;

    for ( int i = 1; i <= n; i ++ )
        cin >> u[i];
    for ( int i = 0; i < m; i ++ ) {
        cin >> x >> y;

        if ( ( u[x] + 1 ) % h == u[y] ) {
            out[x].push_back( y );
            in[y].push_back( x );
        }
        if ( ( u[y] + 1 ) % h == u[x] ) {
            out[y].push_back( x );
            in[x].push_back( y );
        }
    }

    int i = 1;
    while ( i <= n && out[i].size() )
        i ++;


    for ( int i = 1; i <= n; i ++ )
        if ( !check[i] )
            dfs( i );

    for ( int i = 1; i <= n; i ++ ) {
        is_valid[find( i )] = 1;
        for ( int x : in[i] )
            if ( find(x) != find( i ) )
                has_in[find( x )] = 1;
        //cout << find( i ) << ' ' << sz[find(i)] << endl;
    }

    int ans = 0;
    sz[0] = 1e9;
    for ( int i = 1; i <= n; i ++ )
        if ( is_valid[i] && !has_in[i] && sz[i] < sz[ans] )
            ans = i;

    cout << sz[ans] << endl;
    for ( int i = 1; i <= n; i ++ )
        if ( find( i ) == ans )
            cout << i << ' ';

    return 0;
}
