#include <iostream>

using namespace std;

const long long MAX_N = 1e5 + 1;
long long aib[MAX_N];

void update( long long pos, long long s ) {
    while ( pos < MAX_N ) {
        aib[pos] += s;
        pos += ( pos & -pos );
    }
}


long long query( long long pos ) {
    pos = min( MAX_N - 1, max( 0LL, pos ) );
    long long ans = 0;
    while ( pos > 0 ) {
        ans += aib[pos];
        pos -= ( pos & -pos );
    }
    return ans;
}

long long sum( long long p1, long long p2 ) {
    return query( p2 ) - query( p1 - 1 );
}

#define getval(x) sum(x, x)

long long cbin( long long s ) {
    long long pos = 0;
    for ( long long i = ( 1 << 16 ); i > 0; i >>= 1 )
        if ( aib[pos + i] <= s ) {
            s -= aib[pos + i];
            pos += i;
        }
    return pos + 1;
}

int main() {
    freopen( "input.txt", "r", stdin );
    long long p, n, d, b, x;
    cin >> p >> n >> d >> b;

    for ( long long i = 1; i <= n; i ++ ) {
        cin >> x;
        update( i, x );
    }

    if ( p == 2 ) {
        long long i = 1, j = n;
        long long zleft = 1, zright = n;
        long long ans = 0;
        while ( i < j ) {
            if ( sum( 1, i + d * i ) >= b ) {
                long long x = cbin( b );
                update( x, sum( 1, x - 1 ) - b );
                while ( zleft < x ) {
                    update( zleft, -getval( zleft ) );
                    zleft ++;
                }
            } else {
                ans ++;
            //    cout << "Catch: " << i << ' ' << query( 0 ) << endl;
            }

            if ( sum ( j - d * i, n ) >= b ) {
                long long x = cbin( sum( 1, n ) - b );
                update( x, sum( x + 1, n ) - b );
                while ( zright > x ) {
                    update( zright, -getval( zright ) );
                    zright --;
                }
            } else {
                ans ++;
            //    cout << "Catch: " << j << endl;
            }

            i ++;
            j --;
        }

        cout << ans;
    } else {
        long long i = 1;
        long long zleft = 1;
        long long ans = 0;
        while ( i < n ) {
            if ( sum( 1, i + d * i ) >= b ) {
                long long x = cbin( b );
                update( x, sum( 1, x - 1 ) - b );
                while ( zleft < x ) {
                    update( zleft, -getval( zleft ) );
                    zleft ++;
                }
            } else {
                ans ++;
            //    cout << "Catch: " << i << ' ' << query( 0 ) << endl;
            }

            i ++;
        }

        cout << ans;
    }

    return 0;
}
