#include <iostream>

using namespace std;

const int MAX_N = 1e5 + 1;
int aib[MAX_N];

void update( int pos, int s ) {
    while ( pos < MAX_N ) {
        aib[pos] += s;
        pos += ( pos & -pos );
    }
}


int query( int pos ) {
    pos = min( MAX_N - 1, max( 0, pos ) );
    int ans = 0;
    while ( pos > 0 ) {
        ans += aib[pos];
        pos -= ( pos & -pos );
    }
    return ans;
}

int sum( int p1, int p2 ) {
    return query( p2 ) - query( p1 - 1 );
}

#define getval(x) sum(x, x)

int cbin( int s ) {
    int pos = 0;
    for ( int i = ( 1 << 16 ); i > 0; i >>= 1 )
        if ( aib[pos + i] <= s ) {
            s -= aib[pos + i];
            pos += i;
        }
    return pos + 1;
}

int main() {
    freopen( "input.txt", "r", stdin );
    int p, n, d, b, x;
    cin >> p >> n >> d >> b;

    for ( int i = 1; i <= n; i ++ ) {
        cin >> x;
        update( i, x );
    }

    if ( p == 2 ) {
        int i = 1, j = n;
        int zleft = 1, zright = n;
        int ans1 = 0, ans2 = 0;
        while ( i < j ) {
            if ( sum( 1, i + d * i ) >= b ) {
                int x = cbin( b );
                update( x, sum( 1, x - 1 ) - b );
                while ( zleft < x ) {
                    update( zleft, -getval( zleft ) );
                    zleft ++;
                }
            } else {
                ans1 ++;
            //    cout << "Catch: " << i << ' ' << query( 0 ) << endl;
            }

            if ( sum ( j - d * i, n ) >= b ) {
                int x = cbin( sum( 1, n ) - b );
                update( x, sum( x + 1, n ) - b );
                while ( zright > x ) {
                    update( zright, -getval( zright ) );
                    zright --;
                }
            } else {
                ans2 ++;
            //    cout << "Catch: " << j << endl;
            }

            i ++;
            j --;
        }

        cout << max( ans1, ans2 );
    } else {
        int i = 1;
        int zleft = 1;
        int ans = 0;
        while ( i < n ) {
            if ( sum( 1, i + d * i ) >= b ) {
                int x = cbin( b );
                update( x, sum( 1, x - 1 ) - b );
                while ( zleft < x ) {
                    update( zleft, -getval( zleft ) );
                    zleft ++;
                }
            } else {
                ans ++;
            //    cout << "Catch: " << i << ' ' << query( 0 ) << endl;
            }

            i ++;
        }

        cout << ans;
    }

    return 0;
}
