#include <cstdio>
#include <algorithm>
#include <utility>

#define x first
#define y second

FILE *fin = fopen("input.txt", "r"), *fout = fopen("output.txt", "w");

#define MAXN 132000
#define LOGN 17

int a[MAXN], lg[MAXN], b[MAXN], cnt[MAXN];
bool viz[2 * MAXN + 9];
std::pair < int, int > r1[MAXN], r2[MAXN];

inline int calc(int x, int v[], int n) {
    int mask = 0;
    for (int i = 0; i < n; i++) {
        int y = v[i];
        while((x & y) != y) {
            int c = (x & y) ^ y;
            mask |= c & (-c);
            y += c & (-c);
        }
    }
    return mask;
}

int main() {
    int u;
    fscanf(fin, "%d", &u);

    for (int i = 1; i < MAXN; i++)
        lg[i] = 1 + lg[i / 2];

    int n = 0, m = 0, amax = 0, bmax = 0, logmax = 0;
    for (int i = 0; i < u; i++) {
        int x;
        fscanf(fin, "%d", &x);

        if (x != 0 && viz[x + MAXN] == 0) {
            viz[x + MAXN] = 1;
            if (x < 0) {
                a[n++] = -x;
                amax = std::max(amax, -x);
                logmax = std::max(logmax, lg[-x - 1]);
            } else {
                b[m++] = x;
                bmax = std::max(bmax, x);
                logmax = std::max(logmax, lg[x - 1]);
            }
        }
    }

    if (m == 0 && n == 0)
        fprintf(fout, "0\n");
    else {
        logmax++;
        int q1 = 0, q2 = 0;
        for (int i = 0; i < (1 << logmax); i++) {
            if (i)
                cnt[i] = 1 + cnt[i - (i & (-i))];
            if (i >= amax)
                r1[q1++] = {i, calc(i, a, n)};
            if (i >= bmax)
                r2[q2++] = {i, calc(i, b, m)};
        }
        int ans = 2 * logmax, c1 = (1 << logmax) - 1, c2 = (1 << logmax) - 1;
        for (int i = 0; i < q1; i++)
            for (int j = 0; j < q2; j++)
                if ((r1[i].x & r2[j].y) == r2[j].y && (r2[j].x & r1[i].y) == r1[i].y && cnt[r1[i].x] + cnt[r2[j].x] < ans)
                    ans =  cnt[r1[i].x] + cnt[r2[j].x], c1 = r1[i].x, c2 = r2[j].x;

        fprintf(fout, "%d\n", ans);
        for (int i = 0; i < logmax; i++)
            if ((1 << i) & c1)
                fprintf(fout, "%d ", -(1 << i));
        for (int i = 0; i < logmax; i++)
            if ((1 << i) & c2)
                fprintf(fout, "%d ", 1 << i);
    }

    fclose(fin);
    fclose(fout);
    return 0;
}
