#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;


const int MAX_N = 100 * 1000 + 5;
int n;
int hs[MAX_N];
vector< vector<int> > g(MAX_N);
vector< vector<int> > revg(MAX_N);
vector< set<int> > gcomp(MAX_N);
int gcomps[MAX_N];
int col[MAX_N];
int mas[MAX_N];
bool used[MAX_N];
int color = 0;
vector<int> topsort;

void dfs(int v){
    used[v] = true;
    for(int u: g[v])
        if(!used[u])
            dfs(u);
    topsort.push_back(v);
}

void revdfs(int v){
    used[v] = true;
    col[v] = color;
    ++gcomps[color];
    for(int u: revg[v]){
        if(!used[u])
            revdfs(u);
        else{
            if(col[u] != color)
                gcomp[col[u]].insert(color);
            //cout << color << ':' << col[u] << '\n';
        }
    }
}

void kosarau(){
    fill(used, used + MAX_N, false);
    for(int i = 0; i < n; i++)
        if(!used[i])
            dfs(i);
    fill(used, used + MAX_N, false);
    fill(gcomps, gcomps + MAX_N, 0);
    for(int i = topsort.size() - 1; i >= 0; i--)
        if(!used[topsort[i]]){
            revdfs(topsort[i]);
            ++color;
        }
}


void dfs_(int v){
    used[v] = true;
    mas[v] = gcomps[v];
    for(int u: gcomp[v]){
        if(!used[u]){
            dfs_(u);
        }
        mas[v] += mas[u];
    }
}

void dfs_out(int v){
    cout << v + 1 << ' ';
    used[v] = true;
    for(int u: g[v])
        if(!used[u])
        dfs_out(u);
}

int main(){
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    int m, h;
    cin >> n >> m >> h;
    for(int i = 0; i < n; i++)
        cin >> hs[i];
    for(int i = 0, c1, c2; i < m; i++){
        cin >> c1 >> c2;
        --c1, --c2;
        if(((hs[c1] - hs[c2] + h) % h) == 1){
            g[c2].push_back(c1);
            revg[c1].push_back(c2);
        }
        if(((hs[c2] - hs[c1] + h) % h) == 1){
            g[c1].push_back(c2);
            revg[c2].push_back(c1);
        }
    }
    kosarau();
    fill(used, used + MAX_N, false);
    for(int i = 0; i < color; i++){
        if(!used[i]){
                fill(used, used + MAX_N, false);
            dfs_(i);
        }
    }
    int minm = 0;
    //for(int i = 0; i < color; i++)
    //    cout << mas[i] << ' ';
    //cout << '\n';
    for(int i = 0; i < color; i++)
        if(mas[minm] > mas[i])
            minm = i;
    cout << mas[minm] << '\n';
    fill(used, used + MAX_N, false);
    int i = 0;
    while(i < n && col[i] != minm)
        ++i;
    //cout << i;
    dfs_out(i);
    return 0;
}
