#include <bits/stdc++.h>
using namespace std;

const long long INF = 1000000000000000000LL;

struct SegTree {
    int sz;
    vector<long long> val;

    SegTree(int sz) : sz(sz) {
        val.resize(sz);
    }

    void add(int l, int r, int v) {
        for (int i = l; i < r; i++) {
            val[i] += v;
        }
    }

    long long getmin(int l, int r) {
        if (r <= l) return INF;

        long long mn = val[l];
        for (int i = l; i < r; i++) {
            mn = min(mn, val[i]);
        }
        return mn;
    }

    // TODO
};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<long long> a(n);
    long long s = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s += a[i];
    }

    if (p == 1) {
        for (int i = 0; i < n; i++) {
            int j = i / (d + 1);
            if (j < i) {
                a[j] += a[i];
                a[i] = 0;
            }
        }
        long long have = 0;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            have += a[i];
            if (have < b) {
                ans++;
            } else {
                have -= b;
            }
        }
        cout << ans << endl;
        return 0;
    }

    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        l[i] = i / (d + 1);
        r[i] = (n - 1) - ((n - 1 - i) / (d + 1));
    }

    int fh = (n + 1) / 2;
    int sh = n - fh;

    vector<long long> need_l(fh + 1, INF);
    int it = 0;
    int took = 0;
    long long tot = 0;
    SegTree st(fh);
    for (int i = 0; i <= fh; i++) {
        st.add(fh - i, fh, -b);
        while (st.getmin(fh - i, fh) < 0 && it < n) {
            while (it < n && took == a[it]) {
                it++;
                took = 0;
            }
            if (it < n) {
                st.add(l[it], fh, 1);
                took++;
                tot++;
            }
        }
        if (st.getmin(fh - i, fh) >= 0) {
            need_l[i] = tot;
        }
    }

    vector<long long> need_r(sh + 1, INF);
    it = n - 1;
    took = 0;
    tot = 0;
    st = SegTree(sh);
    for (int i = 0; i <= sh; i++) {
        st.add(0, i, -b);
        while (st.getmin(0, i) < 0 && it >= 0) {
            while (it >= 0 && took == a[it]) {
                it--;
                took = 0;
            }
            if (it >= 0) {
                st.add(0, r[it] - fh + 1, 1);
                took++;
                tot++;
            }
        }
        if (st.getmin(0, i) >= 0) {
            need_r[i] = tot;
        }
    }

    int mx = 0;
    for (int i = 0; i <= fh; i++) {
        int L = -1;
        int R = sh + 1;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (need_l[i] + need_r[M] <= s) {
                L = M;
            } else {
                R = M;
            }
        }
        if (L != -1) {
            mx = max(mx, i + L);
        }
    }

    cout << n - mx << endl;

    return 0;
}