#include <bits/stdc++.h>
using namespace std;

const long long INF = 1000000000000000000LL;

struct SegTree {
    int sz;
    vector<long long> val;
    vector<long long> it, mod;

    SegTree(int sz) : sz(sz) {
        val.resize(sz);
        it.resize(4 * sz);
        mod.resize(4 * sz);
    }

    void push(int u) {
        it[2 * u + 1] += mod[u];
        it[2 * u + 2] += mod[u];
        mod[2 * u + 1] += mod[u];
        mod[2 * u + 2] += mod[u];
        mod[u] = 0;
    }

    void add1(int u, int L, int R, int l, int r, long long v) {
        if (l >= R || L >= r) {
            return;
        }
        if (l <= L && R <= r) {
            it[u] += v;
            mod[u] += v;
            return;
        }
        push(u);
        int M = (L + R) / 2;
        add1(2 * u + 1, L, M, l, r, v);
        add1(2 * u + 2, M, r, l, r, v);
        it[u] = min(it[2 * u + 1], it[2 * u + 2]);
    }

    void add(int l, int r, long long v) {
        add1(0, 0, sz, l, r, v);
    }

    long long get(int u, int L, int R, int l, int r) {
        if (l >= R || L >= r) {
            return INF;
        }
        if (l <= L && R <= r) {
            return it[u];
        }
        push(u);
        int M = (L + R) / 2;
        return min(get(2 * u + 1, L, M, l, r), get(2 * u + 2, M, R, l, r));
    }

    long long getmin(int l, int r) {
        if (r <= l) return INF;

        return get(0, 0, sz, l, r);
    }
};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<long long> a(n);
    long long s = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s += a[i];
    }

    if (p == 1) {
        for (int i = 0; i < n; i++) {
            int j = i / (d + 1);
            if (j < i) {
                a[j] += a[i];
                a[i] = 0;
            }
        }
        long long have = 0;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            have += a[i];
            if (have < b) {
                ans++;
            } else {
                have -= b;
            }
        }
        cout << ans << endl;
        return 0;
    }

    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        l[i] = i / (d + 1);
        r[i] = n - 1 - ((n - 1 - i) / (d + 1));
    }

    int fh = (n + 1) / 2;
    int sh = n - fh;

    vector<long long> need_l(fh + 1, INF);
    int it = 0;
    long long took = 0;
    long long tot = 0;
    SegTree st(fh);
    for (int i = 0; i <= fh; i++) {
        st.add(fh - i, fh, -b);
        while (st.getmin(fh - i, fh) < 0 && it < n) {
            while (it < n && took == a[it]) {
                it++;
                took = 0;
            }

            // try to add all
            st.add(l[it], fh, a[it] - took);
            if (st.getmin(fh - i, fh) >= 0) {
                st.add(l[it], fh, took - a[it]);
                long long v = -st.getmin(fh - i, fh);
                st.add(l[it], fh, v);
                if (st.getmin(fh - i, fh) < 0) {
                    exit(239);
                }
                took += v;
                tot += v;
            } else {
                tot += a[it] - took;
                took = a[it];
            }
        }

        if (st.getmin(fh - i, fh) >= 0) {
            need_l[i] = tot;
        }
    }

    vector<long long> need_r(sh + 1, INF);
    it = n - 1;
    took = 0;
    tot = 0;
    st = SegTree(sh);
    for (int i = 0; i <= sh; i++) {
        st.add(0, i, -b);
        while (st.getmin(0, i) < 0 && it >= 0) {
            while (it >= 0 && took == a[it]) {
                it--;
                took = 0;
            }

            // try to add all
            st.add(0, r[it] - fh + 1, a[it] - took);
            if (st.getmin(0, i) >= 0) {
                st.add(0, r[it] - fh + 1, took - a[it]);
                long long v = -st.getmin(0, i);
                st.add(0, r[it] - fh + 1, v);
                if (st.getmin(0, i) < 0) {
                    exit(228);
                }
                took += v;
                tot += v;
            } else {
                tot += a[it] - took;
                took = a[it];
            }
        }

        if (st.getmin(0, i) >= 0) {
            need_r[i] = tot;
        }
    }

    int mn = n;
    for (int i = 0; i <= fh; i++) {
        int L = -1;
        int R = sh + 1;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (need_l[i] + need_r[M] <= s) {
                L = M;
            } else {
                R = M;
            }
        }
        if (L != -1) {
            mn = min(mn, max(fh - i, sh - L));
        }
    }

    cout << mn << endl;

    return 0;
}
