#include <bits/stdc++.h>

#define mp make_pair

typedef std::pair<int, int> pii;





const int N = 100000;
int cl[N];

std::set<int> edg[N];
std::stack<int> st;
int yk[N];
int par[N];
int deep[N];

void init()
{
    for (int i = 0; i < N; ++i)
    {
        par[i] = i;
        deep[i] = 0;
        cl[i] = 0;
        edg[i].clear();
    }
}


int get(int v)
{
    if (par[v] == v)
        return v;
    int res = get(par[v]);
    par[v] = res;
    return res;
}

int mrg(int v1, int v2)
{
    v1 = get(v1);
    v2 = get(v2);
    if (deep[v1] > deep[v2])
        std::swap(v1, v2);
    par[v1] = v2;
    if (deep[v1] == deep[v2])
        ++deep[v2];
    if (edg[yk[v1]].size() <= edg[yk[v2]].size())
    {
        for (int i : edg[yk[v1]])
            edg[yk[v2]].insert(i);
    }
    else
    {
        for (int i : edg[yk[v2]])
            edg[yk[v1]].insert(i);
        yk[v2] = yk[v1];
    }
    return v2;
}           

pii dfs(int v)
{
    if (cl[v] == 1)
    {
        int now = v;
        while (st.top() != v)
        {
            now = mrg(now, st.top());
            st.pop();
        }
        return std::mp(v, now);
    }
    cl[v] = 1;
    st.push(v);
    while (edg[yk[v]].size() > 0)
    {
        int nxt = *edg[yk[v]].begin();
        nxt = get(nxt);
        if (nxt == v || cl[nxt] == 2)
            edg[yk[v]].erase(edg[yk[v]].begin());
        else if (cl[nxt] != 2)
        {
            pii res = dfs(nxt);
            if (res.first != -1)
            {
                if (res.first == v)
                {
                    st.pop();
                    cl[v] = 2;
                    v = res.second;
                    cl[v] = 1;
                    st.push(v);        
                }    
                else
                {
                    cl[v] = 2;
                    return res;
                }
            }
            else
            {
                edg[yk[v]].erase(edg[yk[v]].begin());    
            }
        }
    }
    st.pop();
    cl[v] = 2;        
    return std::mp(-1, -1);
}


void get_ans(int n, int m, int h)
{
    init();
    int u[n];
    for (int i = 0; i < n; ++i)
        scanf("%d", u + i);
    int mem1[m], mem2[m];
    for (int i = 0; i < m; ++i)
    {
        int c1, c2;
        scanf("%d %d", &c1, &c2);
        --c1, --c2;
        mem1[i] = c1;
        mem2[i] = c2;
        if ((u[c1] + 1) % h == u[c2])
            edg[c1].insert(c2);
        if ((u[c2] + 1) % h == u[c1])
            edg[c2].insert(c1);
    }
    for (int i = 0; i < n; ++i)
        yk[i] = i;            
    for (int i = 0; i < n; ++i)
        if (cl[i] == 0)
            dfs(i);
    int cnt[n];
    int is_good[n];
    for (int i = 0; i < n; ++i)
    {
        cnt[i] = 0;
        is_good[i] = 1;
    }
    for (int i = 0; i < n; ++i)
        ++cnt[get(i)];
    for (int i = 0; i < m; ++i)
    {
        int c1 = mem1[i], c2 = mem2[i];
        if ((u[c1] + 1) % h == u[c2] && get(c1) != get(c2))
            is_good[c1] = 0;
        if ((u[c2] + 1) % h == u[c1] && get(c2) != get(c1))
            is_good[c2] = 0;
    }
    int ans_yk = -1;
    for (int i = 0; i < n; ++i)
        if (cnt[i] > 0 && is_good[i] && (ans_yk == -1 || cnt[i] < cnt[ans_yk]))
            ans_yk = i;
    std::vector<int> ans;
    for (int i = 0; i < n; ++i)
        if (get(i) == ans_yk)
            ans.push_back(i + 1);
    printf("%d\n", ans.size());
    for (int i : ans)
        printf("%d ", i);
    printf("\n");
}

int main()
{
    int n, m, h;
    while (scanf("%d %d %d", &n, &m, &h) == 3)
        get_ans(n, m, h);
    return 0;
}