#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef long double ld;

#define endl "\n"
#define mp make_pair
#define pb push_back

const int mod = 1000000007;
const int INF = 1000000000;

int n, m, h, u[100005], used[100005], V, compSize[100005], compV[100005], compLen = 0;
vector <int> e[100005], re[100005], comp[100005], order;
unordered_set <int> compE[100005];
vector <int> result;

void getOrder(int v);
void dfs1Comp(int v);
void dfs2Comp(int v);
void dfsComp(int v);
void findStrong();

int main()
{
    //ifstream cin("input.txt");

    int a, b;

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n >> m >> h;

    for (int i = 1; i <= n; i++)
        cin >> u[i];

    for (int i = 0; i < m; i++) {
        cin >> a >> b;

        if (((u[a] + 1) % h) == u[b]) {
            e[a].push_back(b);
            re[b].push_back(a);
        }

        if (((u[b] + 1) % h) == u[a]) {
            e[b].push_back(a);
            re[a].push_back(b);
        }
    }

    findStrong();

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < e[i].size(); j++) {
            if (compV[i] != compV[e[i][j]])
                compE[compV[i]].insert(compV[e[i][j]]);
        }
    }

    V = 1;

    for (int i = 1; i <= compLen; i++) {
        if (!used[i])
            dfsComp(i);

        if (compSize[i] < compSize[compV[V]])
            V = comp[i][0];
    }

    getOrder(V);

    cout << result.size() << endl;

    for (int i = 0; i < result.size(); i++)
        cout << result[i] << " ";

    return 0;
}

void dfsComp(int v) {
    compSize[v] = comp[v].size();

    for (auto i : compE[v]) {
        if (!used[i])
            dfsComp(i);

        compSize[v] += compSize[i];
    }
}

void getOrder(int v) {
    result.push_back(v);
    used[v] = 1;

    for (int i = 0; i < e[v].size(); i++) {
        if (!used[e[v][i]])
            getOrder(e[v][i]);
    }
}

void dfs1Comp(int v) {
    used[v] = 1;

    for (int i = 0; i < e[v].size(); i++) {
        if (!used[e[v][i]])
            dfs1Comp(e[v][i]);
    }

    order.push_back(v);
}

void dfs2Comp(int v) {
    used[v] = 1;
    compV[v] = compLen;
    comp[compLen].push_back(v);

    for (int i = 0; i < re[v].size(); i++) {
        if (!used[re[v][i]])
            dfs2Comp(re[v][i]);
    }
}

void findStrong() {
    for (int i = 1; i <= n; i++) {
        if (!used[i])
            dfs1Comp(i);
    }

    for (int i = 1; i <= n; i++)
        used[i] = 0;

    for (int i = order.size() - 1; i > -1; i--) {
        if (!used[order[i]]) {
            compLen++;
            dfs2Comp(order[i]);
        }
    }

    for (int i = 1; i <= n; i++)
        used[i] = 0;
}
