#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <functional>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <bitset>
#include <cinttypes>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define sqr(x) ((x)*(x))
#define cube(x) (sqr(x)*(x))
#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vii vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvii vector<vii>
#define vvll vector<vll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define forn(i,n) for(int i=0;i<n;i++)
#define forab(i,a,b) for(int i=a;i<=b;i++)
#define fornout(i,n,c) for(int i=0;i<n;i++,cout<<c)

const ld PI = acos(-1);
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const int MAXN = 1e5;

vvii graph, backs, backs2;
vector <set <int> > graph2;
vector <set <int> > graph3;
vii used, color, used2, sz, used3, used4, color2, sz2;

void dfs(int v, set <int> &cols) {
    used[v] = 1;

    cols.insert(v);
    forn(i, graph[v].size()) {
        int to = graph[v][i];
        if (used[to] == 1) {
            color[v] = to;
        }
        else if (used[to] == 0) {
            dfs(to, cols);
            if (color[to] != to && color[to] != v && color[v] == v)
                color[v] = color[to];
        }
        else if (used[to] == 2) {
            if (cols.find(color[to]) != cols.end())
                color[v] = color[to];
        }
    }

    cols.erase(v);
    used[v] = 2;
}

void dfs2(int v) {
    used2[v] = 1;
    color[v] = color[color[v]];
    forn(i, graph[v].size()) {
        int to = graph[v][i];
        if (!used2[to])
            dfs2(to);
    }
}

void dfs3(int v, set <int> &cols) {
    used3[v] = 1;

    cols.insert(v);
    for (auto to : graph2[v]) {
        if (used3[to] == 1) {
            color2[v] = to;
        }
        else if (used3[to] == 0) {
            dfs3(to, cols);
            if (color2[to] != to && color2[to] != v && color2[v] == v)
                color2[v] = color2[to];
        }
        else if (used3[to] == 2) {
            if (cols.find(color2[to]) != cols.end())
                color2[v] = color2[to];
        }
    }

    cols.erase(v);
    used3[v] = 2;
}

void dfs4(int v) {
    used4[v] = 1;
    color2[v] = color2[color2[v]];
    for (auto to : graph2[v]) {
        if (!used4[to])
            dfs4(to);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    graph.resize(n);
    graph2.resize(n);
    graph3.resize(n);
    backs.resize(n);
    backs2.resize(n);
    used.resize(n, 0);
    used2.resize(n, 0);
    used3.resize(n, 0);
    used4.resize(n, 0);
    color.resize(n);
    color2.resize(n);
    sz.resize(n, 0);
    sz2.resize(n, 0);

    vii f(n);
    forn(i, n) color[i] = i, cin >> f[i];

    forn(i, m) {
        int x, y;
        cin >> x >> y;
        x--, y--;

        if ((f[x] + 1) % h == f[y]) graph[x].pb(y);
        if ((f[y] + 1) % h == f[x]) graph[y].pb(x);
    }

    set <int> jgh;
    forn(i, n) if (!used[i]) dfs(i, jgh);
    forn(i, n) if (!used2[i]) dfs2(i);

    forn(i, n) {
        sz[color[i]]++;
        backs[color[i]].push_back(i);
        for (auto to : graph[i])
            graph2[color[i]].insert(color[to]);
    }
    forn(i, n) {
        graph2[i].erase(i);
        color2[i] = color[i];
    }

    forn(i, n) if (!used3[i]) dfs3(i, jgh);
    forn(i, n) if (!used4[i]) dfs4(i);

    forn(i, n) {
        sz2[color2[i]]++;
        backs2[color2[i]].push_back(i);
        for (auto to : graph2[i])
            graph3[color2[i]].insert(color2[to]);
    }
    forn(i, n) {
        graph3[i].erase(i);
    }

    int mn = n, ans;
    forn(i, n) {
        if (graph3[i].size() == 0)
            if (mn >= sz2[i] && sz2[i] > 0)
                mn = sz2[i], ans = i;
    }

    cout << mn << '\n';
    fornout(i, backs2[ans].size(), ' ') cout << backs2[ans][i] + 1;

    return 0;
}