#include <iostream>
#include <vector>
#include <stack>
using namespace std;

const int MAXN = 100005;

int n, m, h, a[MAXN];
vector<int> gp[MAXN], gr[MAXN], gn[MAXN];
vector<int> comp[MAXN];

int vis[MAXN], lar[MAXN];
stack<int> st;
bool b[MAXN];

void Init()
{
    cin >> n >> m >> h;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
    for (int i = 1; i <= m; ++ i)
    {
        int x, y;
        cin >> x >> y;
        if (a[y] == a[x] + 1 or (a[y] == 0 and a[x] == h - 1))
        {
            gp[x].push_back(y);
            //cout << x << ' ' << y << endl;
            gr[y].push_back(x);
        }
        if (a[x] == a[y] + 1 or (a[x] == 0 and a[y] == h - 1))
        {
            gp[y].push_back(x);
            //cout << y << ' ' << x << endl;
            gr[x].push_back(y);
        }
    }
    //cout << "---" << endl;
}

void toZero()
{
    for (int i = 0; i < MAXN; ++ i)
    {
        vis[i] = 0;
    }
}

void DFS1(int u)
{
    if (vis[u] != 0) return;
    else vis[u] = 1;

    for (int v : gp[u])
    {
        DFS1(v);
    }
    st.push(u);
}

void DFS2(int u, int c)
{
    if (vis[u] != 0) return;
    else vis[u] = c;

    for (int v : gr[u])
    {
        DFS2(v, c);
    }
}

void DFS3(int u)
{
    if (lar[u] != 0) return;
    else lar[u] = comp[u].size();

    for (int v : gn[u])
    {
        DFS3(v);
        lar[u] += lar[v];
    }
}

vector<int> ans;

void DFS4(int u)
{
    for (int i = 0; i < comp[u].size(); ++ i)
    {
        ans.push_back(comp[u][i]);
    }

    for (int v : gn[u])
    {
        DFS4(v);
    }
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        DFS1(i);
    }

    toZero();
    while (!st.empty())
    {
        //cout << st.top() << endl;
        DFS2(st.top(), st.top());
        st.pop();
    }

    for (int i = 1; i <= n; ++ i)
    {
        comp[vis[i]].push_back(i);
        for (int j = 0; j < gp[i].size(); ++ j)
        {
            if (vis[i] != vis[gp[i][j]])
            {
                //cout << vis[i] << " -> " << vis[gp[i][j]] << endl;
                gn[vis[i]].push_back(vis[gp[i][j]]);
                b[vis[gp[i][j]]] = true;
            }
        }
    }

    int vert = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (comp[i].size() == 0) continue;
        //if (!b[i])
        {
            DFS3(i);
            //cout << i << ' ' << lar[i] << endl;
            if (vert == 0 or lar[i] < lar[vert]) vert = i;
        }
    }

    toZero();
    DFS4(vert);

    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++ i)
    {
        cout << ans[i] << ' ';
    }

    cout << endl;
    return 0;
}

/*
3 3 5
4 4 0
1 3
3 2
3 1
----------
4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
