#include <iostream>
#include <vector>
#include <stack>
using namespace std;

const int MAXN = 100005;

int n, m, h, a[MAXN];
vector<int> gp[MAXN], gr[MAXN], gn[MAXN];
vector<int> comp[MAXN];

int vis[MAXN], siz[MAXN];
stack<int> st;

void Init()
{
    cin >> n >> m >> h;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
    for (int i = 1; i <= m; ++ i)
    {
        int x, y;
        cin >> x >> y;
        if (a[y] == a[x] + 1 or (a[y] == 0 and a[x] == h - 1))
        {
            gp[x].push_back(y);
            gr[y].push_back(x);
        }
        if (a[x] == a[y] + 1 or (a[x] == 0 and a[y] == h - 1))
        {
            gp[y].push_back(x);
            gr[x].push_back(y);
        }
    }
}

void toZero()
{
    for (int i = 0; i < MAXN; ++ i)
    {
        vis[i] = 0;
    }
}

void DFS1(int u)
{
    if (vis[u] != 0) return;
    else vis[u] = 1;

    for (int v : gp[u])
    {
        DFS1(v);
    }
    st.push(u);
}

void DFS2(int u, int c)
{
    if (vis[u] != 0) return;
    else vis[u] = c;

    for (int v : gr[u])
    {
        DFS2(v, c);
    }
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        DFS1(i);
    }

    toZero();
    while (!st.empty())
    {
        DFS2(st.top(), st.top());
        st.pop();
    }

    for (int i = 1; i <= n; ++ i)
    {
        comp[vis[i]].push_back(i);
        for (int j = 0; j < gp[i].size(); ++ j)
        {
            if (vis[i] != vis[gp[i][j]])
            {
                gn[vis[i]].push_back(vis[gp[i][j]]);
            }
        }
    }

    int vert = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (comp[i].size() == 0 or gn[i].size() != 0) continue;
        if (vert == 0 or comp[i].size() < comp[vert].size()) vert = i;
    }

    cout << comp[vert].size() << endl;
    for (int i = 0; i < comp[vert].size(); ++ i)
    {
        cout << comp[vert][i] << ' ';
    }

    cout << endl;
    return 0;
}

/*
3 3 5
4 4 0
1 3
3 2
3 1
---------
4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/

