#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100001;

int a[MAXN];

long long tree[MAXN];
int val[MAXN];

const int NaN = -1;
void push(int v, int l, int r) {
	if(val[v] != NaN) {
		if(l != r) {
			val[2 * v] = val[v];
			val[2 * v + 1] = val[v];
		}
		tree[v] = 1ll * (r - l + 1) * val[v];
		val[v] = NaN;
	}
}

long long get(int i, int l, int r, int ql, int qr) {
	if(l > r)
		return 0;

	push(i, l, r);
	if(l == ql && r == qr)
		return tree[i];

	int m = (l + r) / 2;

	int res = 0;
	if(ql <= m)
		res += get(i * 2, l, m, ql, min(qr, m));
	if(qr > m)
		res += get(i * 2 + 1, m + 1, r, max(qr, m + 1), qr);
	return res;
}

void setVal(int i, int l, int r, int ql, int qr, int x) {
	if(l > r)
		return;
	
	push(i, l, r);
	if(l == ql && r == qr) {
		val[i] = x;
		push(i, l, r);
	} else {
		int m = (l + r) / 2;
		if(ql <= m)
			setVal(i * 2, l, m, ql, min(qr, m), x);
		if(qr > m)
			setVal(i * 2 + 1, m + 1, r, max(ql, m + 1), qr, x);
		tree[i] = tree[i * 2] + tree[i * 2 + 1]; 
	}
}

void build(int i, int l, int r) {
	val[i] = NaN;
	if(l == r) {
		tree[i] = a[l];
	} else {
		int m = (l + r) / 2;
		build(i * 2, l, m);
		build(i * 2 + 1, m + 1, r);
		tree[i] = tree[i * 2] + tree[i * 2 + 1]; 
	}
}

// >= 
int prefLen(long long sum, int n) {
	int i = 1, l = 1, r = n;
	long long cur = 0;
	while(l != r) {
		if(cur + tree[i * 2] >= sum) {
			r = (l + r) / 2;
			i = i * 2;
		} else {
			cur += tree[i * 2];
			l = (l + r) / 2 + 1;
			i = i * 2 + 1;
		}
	}
	return r;
}

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    int p, n, d, b;
    cin >> p >> n >> d >> b;

    for(int i = 1; i <= n; ++i)
        cin >> a[i];

	build(1, 1, n);

    int res = 0;
    for(int i = 1; i <= n; ++i) {
//		for(int j = 1; j <= n; ++j)
//			cout << get(1, 1, n, j, j) << " ";
//		cout << "\n";

		a[i] = get(1, 1, n, i, i);
    	if(a[i] >= b) {
			setVal(1, 1, n, i, i, a[i] - b);
    	} else {
			setVal(1, 1, n, i, i, 0);
    		long long need = b - a[i];
    		int l = max(1, i - d * i);
    		int r = min(n, i + d * i);
    		if(get(1, 1, n, l, r) >= need) {
    			if(l > 1)
    				need += get(1, 1, n, 1, l - 1);
    			int last = prefLen(need, n);
    			long long left = get(1, 1, n, l, last - 1);
    			if(last != l)
					setVal(1, 1, n, l, last - 1, 0);

				need -= left;
				setVal(1, 1, n, last, last, int(get(1, 1, n, last, last) - need));
    		} else {
    			res++;
				setVal(1, 1, n, i, i, a[i]);
    		}
    	}
    }

    cout << res;
}







