#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 1e5;
int n;

int a[MAX_N] = {};

vector <int64_t> tree;

void build(int v, int tl, int tr) {
	if (tl == tr) {
		tree[v] = a[tl];
		return;
	}
	int tm = tl + (tr - tl) / 2;
	build (v * 2 + 1, tl, tm);
	build (v * 2 + 2, tm + 1, tr);
	tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
	return;
}

void build(int n) {
	tree.assign(n * 4 + 10, 0);
	build(0, 0, n - 1);
}

int get(int v, int l, int r, int tl, int tr) {
	if (l > r) return 0;
	if ((tl == l && tr == r)) return tree[v];
	int tm = tl + (tr - tl) / 2;
	return 
		get(v * 2 + 1, l, min(r, tm) ,tl, tm) + get(v * 2 + 2, max(l, tm + 1), r ,tm + 1, tr);
}

void update(int v, int tl, int tr, int pos, int val) {
	if (tl > tr) return;
	if ((tl == tr) && (tl == pos)) {
		tree[v] = val;
		a[pos] = val;
		return;
	}
	int tm = tl + (tr - tl) / 2;
	if (pos <= tm) {
		update(v * 2 + 1, tl, tm, pos, val);
	} else {
		update(v * 2 + 2, tm + 1, tr, pos, val);
	}
	tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

int get(int l, int r) {
	return get(0, l, r, 0, n - 1);
}

int main() {
	int p, b, d;
	cin >> p >> n >> d >> b;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (p == 1) {
		build(n);
		//cout << "BUILD\n";
		int good = 0;
		for (int i = 0; i < n; i++) {
			int right = min(n - 1, i + (i + 1) * d);
			//cout << right << ' ' << get(0, right) << endl;
			if (get(0, right) - good * b >= b) {
				good++;
			}
		}
		cout << (n - good);
	}
}