#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 2e5, INF = 1e9;

struct segTree {
    int n;
    vector<int> t;
    segTree(vector<int> &a) : n(sz(a)), t(4 * sz(a)) { build(0, 0, sz(a) - 1, a); }
    void build(int v, int l, int r, vector<int> &a) {
        if(l == r) t[v] = a[l];
        else {
            int m = (l + r) >> 1;
            build(v * 2 + 1, l, m, a);
            build(v * 2 + 2, m + 1, r, a);
            t[v] = t[v * 2 + 1] + t[v * 2 + 2];
        }
    }
    /*int sum(int v, int l, int r, int l1, int r1) {
        if(r < l1 || r1 < l) return 0;
        if(l1 <= l && r <= r1) return t[v];
        int m = (l + r) >> 1;
        return sum(v * 2 + 1, l, m, l1, r1) + sum(v * 2 + 2, m + 1, r, l1, r1);
    }*/
    int get(int v, int l, int r, int l1, int r1) {
        if(r < l1 || r1 < l) return -1;
        if(l1 <= l && r <= r1 && t[v] == 0) return -1;
        if(l == r) return l;
        int m = (l + r) >> 1;
        int x = get(v * 2 + 1, l, m, l1, r1);
        if(x != -1) return x;
        return get(v * 2 + 2, m + 1, r, l1, r1);
    }
    void upd(int v, int l, int r, int pos) {
        if(l == r) t[v] = 0;
        else {
            int m = (l + r) >> 1;
            if(pos <= m) upd(v * 2 + 1, l, m, pos);
            else upd(v * 2 + 2, m + 1, r, pos);
            t[v] = t[v * 2 + 1] + t[v * 2 + 2];
        }
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    string s; cin >> s; int n = sz(s);
    vector<int> nul(n, 0), one(n, 0);
    for(int i = 0; i < n; i++) {
        nul[i] = (s[i] == '0');
        one[i] = (s[i] == '1');
    }
    segTree tnul(nul), tone(one);
    vector<vector<int>> ans;
    bitset<maxn> tok;
    //cout << tnul.get(0, 0, n - 1, 6, n - 1) << endl;
    for(int i = 0; i < n; i++) if(!tok[i] && s[i] == '1') return cout << -1, 0;
    else if(!tok[i]) {
        ans.emplace_back();
        ans.back().push_back(i);
        tnul.upd(0, 0, n - 1, i);
        tok[i] = 1;
        int lb = i, rb = n - 1;
        while(true) {
            int i1 = tone.get(0, 0, n - 1, lb, rb);
            //cout << "!! " << i1 << endl;
            if(i1 == -1) break;
            int i2 = tnul.get(0, 0, n - 1, i1, rb);
            //cout << "!! " << i2 << endl;
            if(i2 == -1) break;
            ans.back().push_back(i1);
            ans.back().push_back(i2);
            tone.upd(0, 0, n - 1, i1);
            tnul.upd(0, 0, n - 1, i2);
            tok[i1] = 1;
            tok[i2] = 1;
            lb = i2;
        }
    }
    cout << sz(ans) << '\n';
    for(int i = 0; i < sz(ans); i++, cout << '\n') {
        cout << sz(ans[i]) << ' ';
        for(int x : ans[i]) cout << x + 1 << ' ';
    }
}
