#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;

int p , n , d , b , pl , pr;
vector < int > a;

struct segtree{

    vector < int > t;
    int n;

    void build(vector < int > &v){
        for (int i = 0 ; i < n ; i++)
            t[i + n] = v[i];
        for (int i = n - 1 ; i > 0 ; i--)
            t[i] = t[i << 1] + t[i << 1 | 1];
    }

    void modify(int p , int value){
        for (t[p += n] = value ; p > 1 ; p >>= 1){
            t[p >> 1] = t[p] + t[p ^ 1];
        }
    }

    void inc(int p , int value){
        for (t[p += n] += value ; p > 1 ; p >>= 1){
            t[p >> 1] = t[p] + t[p ^ 1];
        }
    }

    int query(int l , int r){
        int res = 0;
        for (l += n , r += n ; l < r ; l >>= 1 , r >>= 1){
            if (l & 1)
                res += t[l++];
            if (r & 1)
                res += t[--r];
        }
        return res;
    }

    segtree(vector < int > &v){
        n = v.size();
        t.resize(n << 1);
        build(v);
    }

};

void push_left(int l , int r){
    for (int i = l + 1 ; i <= r ; i++){
        a[max(i - d , l)] += a[i];
        a[i] = 0;
    }
}

int main(){
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt" , "r" , stdin);
    freopen("output.txt" , "w" , stdout);
#endif // LOCAL
    cin >> p >> n >> d >> b;
    for (int i = 0 ; i < n ; i++){
        int x;
        cin >> x;
        a.push_back(x);
    }
    if (p == 1){
        pl = 0;
        int ans = 0;
        for (int i = 0 ; i < n ; i++){
            push_left(pl , n - 1);
            if (a[pl] < b){
                //cerr << pl << endl;
                ans++;
            } else {
                a[pl] -= b;
            }
            a[pl + 1] += a[pl];
            a[pl] = 0;
            pl++;
        }
        cout << ans;
    }
    return 0;
}

