#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;

ll p , n , d , b , pl , pr;
ll a[100005][2];

struct segtree{

    vector < ll > t;
    ll n;

    void build(vector < ll > &v){
        for (ll i = 0 ; i < n ; i++)
            t[i + n] = v[i];
        for (ll i = n - 1 ; i > 0 ; i--)
            t[i] = t[i << 1] + t[i << 1 | 1];
    }

    void modify(ll p , ll value){
        for (t[p += n] = value ; p > 1 ; p >>= 1){
            t[p >> 1] = t[p] + t[p ^ 1];
        }
    }

    void inc(ll p , ll value){
        for (t[p += n] += value ; p > 1 ; p >>= 1){
            t[p >> 1] = t[p] + t[p ^ 1];
        }
    }

    ll query(ll l , ll r){
        ll res = 0;
        for (l += n , r += n ; l < r ; l >>= 1 , r >>= 1){
            if (l & 1)
                res += t[l++];
            if (r & 1)
                res += t[--r];
        }
        return res;
    }

    segtree(vector < ll > &v){
        n = v.size();
        t.resize(n << 1);
        build(v);
    }

};

void push_left(ll l , ll r){
    for (ll i = l + 1 ; i <= r ; i++){
        a[max(i - d , l)][0] += a[i][0];
        a[i][0] = 0;
    }
}

void push_right(ll l , ll r){
    for (ll i = r - 1 ; i >= l ; i--){
        a[min(i + d , r)][1] += a[i][1];
        a[i][1] = 0;
    }
}

int main(){
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt" , "r" , stdin);
    freopen("output.txt" , "w" , stdout);
#endif // LOCAL
    cin >> p >> n >> d >> b;
    ll cn = 0;
    ll need = (n + 1) / 2 * b;
    if (p == 1)
        need = 1e9;
    for (ll i = 0 ; i < n ; i++){
        ll x;
        cin >> x;
        if (need >= x)
            need -= x;
        else {
            a[i][0] = need;
            x -= need;
            cn = 1;
        }
        a[i][cn] = x;
    }
    if (p == 1){
        ll ans = 0;
        pl = 0;
        for (ll i = 0 ; i < n ; i++){
            push_left(pl , n - 1);
            if (a[pl][0] < b)
                ans++;
            else
                a[pl][0] -= b;
            a[i + 1][0] += a[i][0];
            pl++;
        }
        cout << ans;
    } else {
        pl = 0;
        pr = n - 1;
        ll ans1 = 0;
        ll ans2 = 0;
        while (pl <= pr){
            push_left(pl , n - 1);
            push_right(0 , pr);
            /*cerr << pl << " " << pr << endl;
            for (int i = 0 ; i < n ; i++)
                cerr << a[i][0] << " " ;
            cerr << endl;
            for (int i = 0 ; i < n ; i++)
                cerr << a[i][1] << " " ;
            cerr << endl;*/
            if (a[pl][0] < b)
                ans1++;
            else
                a[pl][0] -= b;
            a[pl + 1][0] += a[pl][0];
            a[pl][0] = 0;
            if (pl != pr && a[pr][1] < b)
                ans2++;
            else if (pl != pr)
                a[pr][1] -= b;
            if (pl != pr){
                a[pr - 1][1] += a[pr][1];
                a[pr][1] = 0;
            }
            pl++;
            pr--;
            //cerr << ans1 << " " << ans2 << endl;
        }
        cout << max(ans1 , ans2);
    }
    return 0;
}

