#include <fstream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

int n, m, h;
vector <vector <int> > g;
vector <int> t;
vector <int> used;
vector <int> ans;

pair<int, int> dfs(int v, int s, int par) {
    used[v] = 1;
    int k = 1;
    for (int i = 0; i < g[v].size(); i++) {
		if (g[v][i] == par)
			continue;
        if ((t[v] + 1) % h == t[g[v][i]]) {
			if (used[g[v][i]] == 0) {
				pair<int, int> y = dfs(g[v][i], s, v);
				if (y.second == -1)
					ans[v] = -1;
				else if (y.second == -2 && s != v)
					ans[v] = -2;
				k += y.first;
			}
			else if (used[g[v][i]] == 2) {
				if (ans[g[v][i]] != -1)
					k += ans[g[v][i]];
				else
					ans[v] = -1;
			}
			else 
				ans[v] = -2;
		}
		else {
			if (used[g[v][i]] == 1 && t[v] == t[g[v][i]])
				ans[v] = -1;
		}
    }
    if (ans[v] != -1 && ans[v]!=-2)
        ans[v] = k;
    used[v] = 2;
	return { k, ans[v] };
}

vector <bool> us;

void dfs_ans(int v) {
	us[v] = false;
	cout << v + 1 << " ";
	for (int i = 0; i < g[v].size(); i++) {
		if ((t[v] + 1) % h == t[g[v][i]] && us[g[v][i]]) 
				dfs_ans(g[v][i]);
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> h;
    g.resize(n);
    t.resize(n);
    used.resize(n, 0);
    ans.resize(n, 0);
	us.resize(n, true);
    for (int i = 0; i < n; i++)
        cin >> t[i];
    set <pair <int, int> > a;
    for (int i = 0; i < m; i++) {
        int y, u;
        cin >> y >> u;
        y--, u--;
        if (y > u)
            swap(y, u);
        a.insert({ y, u });
    }
    for (auto it = a.begin(); it != a.end(); it++) {
        g[it->first].push_back(it->second);
        g[it->second].push_back(it->first);
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0)
            dfs(i, i, -1);
		for (int j = 0; j < n; j++) {
			if (ans[j] == -2)
				ans[j] = ans[i];
		}
    }
	int an = n*2, st = 0;
    for (int i = 0; i < n; i++) {
		if (ans[i] > -1 && ans[i] < an)
			an = ans[i], st = i;
    }
    cout << an<<"\n";
	dfs_ans(st);
    return 0;
}

