#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 300000 + 10;

int a[N];
vector<int> g[N], rg[N];
bool used[N];
int color[N];
int sz[N];
int deg[N];
vector<int> cur;

void dfs(int v)
{
	if (used[v])
	{
		return;
	}
	used[v] = true;
	for (int to : rg[v]) dfs(to);
	cur.push_back(v);
}

void dfs2(int v, int clr)
{
	if (color[v] != 0)
	{
		return;
	}
	sz[clr]++;
	color[v] = clr;
	for (int to : g[v]) dfs2(to, clr);
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, h;
	cin >> n >> m >> h;
	vector<pair<int, int>> edg;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < m; i++)
	{
		int x, y;
		cin >> x >> y;
		--x, --y;
		if ((a[x] + 1) % h == a[y])
		{
			g[x].push_back(y);
			rg[y].push_back(x);
			edg.push_back({ x, y });
		}
		if ((a[y] + 1) % h == a[x])
		{
			g[y].push_back(x);
			rg[x].push_back(y);
			edg.push_back({ y, x });
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(i);
		}
	}

	reverse(all(cur));

	int clr = 1;

	for (int i : cur)
	{
		if (color[i] == 0)
		{
			dfs2(i, clr);
			++clr;
		}
	}

	for (auto e : edg) if (color[e.first] != color[e.second])
	{
		deg[color[e.first]]++;
	}

	int best = -1;

	for (int i = 0; i < n; i++)
	{
		if (deg[color[i]] == 0 && (best == -1 || sz[color[i]] < sz[color[best]]))
		{
			best = i;
		}
	}

	vector<int> ans;
	for (int i = 0; i < n; i++)
	{
		if (color[i] == color[best])
		{
			ans.push_back(i);
		}
	}

	cout << ans.size() << "\n";
	for (int i : ans)
	{
		cout << i + 1 << " ";
	}


#ifdef _DEBUG
	while (1);
#endif
}