#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define sz(x) ((int)(x).size())

namespace pbds = __gnu_pbds;

template <class K>
using ordered_set = pbds::tree <K,
                                pbds::null_type,
                                std::less<K>,
                                pbds::rb_tree_tag,
                                pbds::tree_order_statistics_node_update>;

int n, m, h;
vector< vector<int> > g;
vector< set<int> > g_set;
vector< char > used;
void dfs(int v, int &cnt) {
    cnt++;
    used[v] = true;
    for(int i = 0; i < sz(g[v]); ++i) {
        if(!used[g[v][i]])
            dfs(g[v][i], cnt);
    }
}

void dfs_ans(int v) {
    used[v] = true;
    cout << v + 1 << " ";
    for(int i = 0; i < sz(g[v]); ++i) {
        if(!used[g[v][i]])
            dfs_ans(g[v][i]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> h;

    g.resize(h);
    g_set.resize(h);

    vector<int> u(h);

    for(int i = 0; i < n; ++i)
        cin >> u[i];
    for(int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        if(abs(u[x] - u[y]) == 1) {
            if(u[x] > u[y]) swap(x, y);
            g_set[x].insert(y);
            if(h == 2)
                g_set[y].insert(x);
        }
        else if(abs(u[x] - u[y]) + 1 == h) {
            if(u[x] < u[y]) swap(x, y);
            g_set[x].insert(y);
        }
    }

    for(int i = 0; i < h; ++i)
        for(auto p = g_set[i].begin(); p != g_set[i].end(); ++p)
            g[i].push_back(*p);

    /*
    for(int i = 0; i < n; ++i) {
        cout << i << ": ";
        for(int j = 0; j < sz(g[i]); ++j)
            cout << g[i][j] << " ";
        cout << endl;
    }
    */

    for(int i = 0; i < h; ++i) {
        if(sz(g[i]) == 0) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }
    }

    pair<int, int> ans = {1228228228, 0};
    used.assign(n, false);

    for(int i = 0; i < h; ++i) {
        int cnt = 0;
        if(!used[i]) {
            dfs(i, cnt);
            ans = {min(cnt, ans.first), i};
        }
    }

    used.assign(h, false);
    cout << ans.first << endl;
    dfs_ans(ans.second);
    cout << endl;

    return 0;
}
