#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define sz(x) ((int)(x).size())

namespace pbds = __gnu_pbds;

template <class K>
using ordered_set = pbds::tree <K,
                                pbds::null_type,
                                std::less<K>,
                                pbds::rb_tree_tag,
                                pbds::tree_order_statistics_node_update>;

int n, m, h;
vector< vector<int> > g;
vector< set<int> > g_set;
vector< int > color;
vector< char > used;

const int INF = 1228228228;

void dfs(int v, int lol) {
    color[v] = lol;
    used[v] = true;
    for(int i = 0; i < sz(g[v]); ++i) {
            if(!used[g[v][i]])
                dfs(g[v][i], lol);
    }
}

bool test_way(int from, int to) {
    used[from] = true;
    for(int i = 0; i < sz(g[from]); ++i) {
        if(g[from][i] == to) return true;
        if(!used[g[from][i]]) {
            if(test_way(g[from][i], to)) return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> h;

    g.resize(n);
    g_set.resize(n);

    vector<int> u(n);

    for(int i = 0; i < n; ++i)
        cin >> u[i];
    for(int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        if(abs(u[x] - u[y]) == 1) {
            if(u[x] > u[y]) swap(x, y);
            g_set[x].insert(y);
            if(h == 2)
                g_set[y].insert(x);
        }
        else if(abs(u[x] - u[y]) + 1 == h) {
            if(u[x] < u[y]) swap(x, y);
            g_set[x].insert(y);
        }
    }

    for(int i = 0; i < n; ++i)
        for(auto p = g_set[i].begin(); p != g_set[i].end(); ++p)
            g[i].push_back(*p);

    /*
    for(int i = 0; i < n; ++i) {
        cout << i << ": ";
        for(int j = 0; j < sz(g[i]); ++j)
            cout << g[i][j] << " ";
        cout << endl;
    }
    */

    for(int i = 0; i < n; ++i) {
        if(sz(g[i]) == 0) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }
    }

    color.assign(n, INF);
    vector<int> far;
    for(int i = 0; i < n; ++i) {
        far = color;
        if(color[i] == INF) {
            color[i] = i;
            used.assign(n, false);
            dfs(i, i);
            for(int j = 0; j < n; ++j) {
                used.assign(n, false);
                if(!test_way(j, i)) color[j] = far[j];
            }
        }
    }

    far = color;
    sort(far.begin(), far.end());
    int ke = 1;
    pair<int, int> ans = {-1, -1};
    for(int i = 1; i < n; ++i) {
        if(far[i - 1] == far[i]) ke++;
        else {
            if(ke > ans.first) {
                ans = {ke, color[i]};
                ke = 1;
            }
        }
    }

    if(ke > ans.first) {
                ans = {ke, color[n - 1]};
                ke = 1;
            }
    cout << ans.first << endl;

    for(int i = 0; i < n; ++i) {
            if(color[i] == ans.second) {
                cout << i + 1 << " ";
            }
    }
    cout << endl;

    return 0;
}
