#include <iostream>
#include <vector>

using namespace std;

struct Node{
    Node *L = nullptr, *R = nullptr;
    int l, r;
    long long sum;
    bool fl = false;

    void push() {
        if (!fl) {
            return;
        }
        L->fl = true;
        L->sum = 0;
        R->fl = true;
        R->sum = 0;
        fl = false;

    }
};

vector <int> a;
Node* root;
int b, d, n;

Node* build(int l, int r) {
    Node* v = new Node();
    v->l = l;
    v->r = r;
    if (l == r) {
        v->sum = a[l];
        return v;
    }
    int m = (r + l) / 2;
    v->L = build(l, m);
    v->R = build(m + 1, r);
    v->sum = v->L->sum + v->R->sum;
    return v;
}

int getp(Node* v, int s) {
    if (v->sum < s) {
        return -1;
    }
    if (v->l == v-> r) {
        return v->l;
    }
    v->push();
    if (v->L->sum >= s) {
        return getp(v->L, s);
    }
    return getp(v->R, s - v->L->sum);
}

int gets(Node* v, int s) {
    if (v->sum < s) {
        return -1;
    }
    if (v->l == v-> r) {
        return v->l;
    }
    v->push();
    if (v->R->sum >= s) {
        return getp(v->R, s);
    }
    return gets(v->L, s - v->R->sum);
}

void setz(Node* v, int l, int r) {
    if (v->l > r || v-> r < l) {
        return;
    }
    if (v->l >= l && v->r <= r) {
        v->fl = true;
        v->sum = 0;
        return;
    }
    v->push();
    setz(v->L, l, r);
    setz(v->R, l, r);
    v->sum = v->L->sum + v->R->sum;
}

void change(Node* v, int i, int x) {
    if (i > v-> r || i < v-> l) {
        return;
    }
    if (v->l == v->r) {
        v->sum -= x;
        return;
    }
    v->push();
    change(v->L, i ,x);
    change(v->R, i, x);
    v->sum = v->L->sum + v->R->sum;
}

int get(Node* v, int i) {
    if (i > v-> r || i < v-> l) {
        return 0;
    }
    if (v->l == v->r) {
        return v->sum;
    }
    v->push();
    return get(v->L, i) + get(v->R, i);
}

long long getsum(Node* v, int l, int r) {
    if (v->l > r || v-> r < l) {
        return 0;
    }
    if (v->l >= l && v->r <= r) {
        return v->sum;
    }
    v->push();
    return getsum(v->L, l, r) + getsum(v->R, l, r);
}

bool solve(int i, int t, int p) {
    if (p == 1) {
        int cur = get(root, i);
        if (cur >= b) {
            change(root, i, b);
            return true;
        }
        change(root, i, cur);
        int r = getp(root, b - cur);
        if (r > i + (long long)t * d) {
            return false;
        }
        if (r != 0) {
            int s = getsum(root, 0, r - 1);
            setz(root, 0, r - 1);
            change(root, r, b - cur - s);
        }
        else {
            change(root, r, b - cur);
        }
        return true;
    }
    int cur = get(root, i);
    if (cur >= b) {
        change(root, i, b);
        return true;
    }
    change(root, i, cur);
    int l = gets(root, b - cur);
    if (l < i - (long long)t * d) {
        return false;
    }
    if (l != n - 1) {
        int s = getsum(root, l + 1, n - 1);
        setz(root, l + 1, n - 1);
        change(root, l, b - cur - s);
    }
    else {
        change(root, l, b - cur);
    }
    return true;
}



int main()
{
    int p;
    cin >> p >> n >> d >> b;
    a.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    root = build(0, n - 1);
    if (p == 1) {
        int ans = n;
        for (int i = 0; i < n; i++) {
            ans -= solve(i, i + 1, 1);
        }
        cout << ans;
    }
    else {
        int c1 = 0, c2 = 0;
        for (int i = 0; i * 2 < n; i++) {
            c1 += !solve(i, i + 1, 1);
            if (n - 1 - i != i) {
                c2 += !solve(n - 1 - i, i + 1, 2);
            }
        }
        root = build(0, n - 1);
        int delta = abs(c1 - c2) / 2;
        int ans1 = 0, ans2 = 0;
        int k = 0;
        //cout << delta << endl;
        for (int i = 0; i * 2 < n; i++) {
            if (n - 1- i == i) {
                ans1 += !solve(i, i + 1, 1);
                continue;
            }
            if (c1 < c2 && k < delta) {
                ans2 += !solve(n - 1 - i, i + 1, 2);
                ans1++;
                k++;
            }
            else if (c1 > c2 && k < delta) {
                ans2++;
                k++;
                ans1 += !solve(i, i + 1, 1);
            }
            else {
                ans1 += !solve(i, i + 1, 1);
                ans2 += !solve(n - i - 1, i + 1, 2);
            }
        }
        cout << max(ans1, ans2);
    }

    return 0;
}
