#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int int64_t
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <vector <int> > g, gt;
vector <bool> used;
vector <int> tin, tout;
vector <int> comp;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    used[v] = true;
    for (auto x : gt[v]) {
        if (!used[x])
            dfs(x);
    }
    tout[v] = timer++;
}

void dfs_for_cmp(int v, int cmp) {
    comp[v] = cmp;
    used[v] = true;
    for (auto x : g[v]) {
        if (!used[x]){
            dfs_for_cmp(x, cmp);
        }
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    g.resize(n);
    comp.resize(n);
    gt.resize(n);
    used.resize(n);
    tin.resize(n);
    tout.resize(n);
    vector <int> t(n);
    assert(n <= 5);
    cin >> t;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if ((t[a] + 1) % h == t[b]) {
            g[a].push_back(b);
            gt[b].push_back(a);
        }
        if (t[a] == (t[b] + 1) % h) {
            g[b].push_back(a);
            gt[a].push_back(b);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i])
            dfs(i);
    }
    vector <pair <int, int> > gg;
    for (int i = 0; i < n; ++i)
        gg.push_back(mp(tout[i], i));
    sort(gg.rbegin(), gg.rend());
    used.assign(n, false);
    int now = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[gg[i].se]) {
            dfs_for_cmp(gg[i].se, now++);
        }
    }
    vector <int> cnt(now);
    vector <int> sz(now);
    for (int i = 0; i < n; ++i) {
        sz[comp[i]]++;
        for (auto x : g[i]) {
            if (comp[i] != comp[x]) {
                cnt[comp[i]]++;
            }
        }
    }
    int best = -1;
    for (int i = 0; i < now; ++i) {
        if (cnt[i] == 0) {
            if (best == -1 || sz[best] > sz[i]) {
                best = i;
            }
        }

    }
    //assert(best != -1);
    cout << sz[best] << endl;
    for (int i = 0; i < n; ++i) {
        if (comp[i] == best) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    return 0;
}
