#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;


vector<vector<ll>> g;
vector<ll> used;
vector<ll> path;

bool link(ll a, ll b, ll h)
{
	a += 1;
	a %= h;

	return (a == b);
}

void dfs(ll v)
{
	used[v] = 1;
	path.push_back(v);

	for (int i = 0; i < g[v].size(); ++i)
	{
		ll to = g[v][i];

		if (used[to] == 0)
		{
			dfs(to);
		}
	}
}


vector<ll> solvve(ll n, ll m, ll h, vector<ll> a, vector<pair<ll, ll>> in)
{
	g.clear();
	used.clear();

	g.resize(n);
	used.resize(n);

	for (pair<ll, ll> p: in)
	{
		ll u = p.first - 1;

		ll v = p.second - 1;

		if (link(a[u], a[v], h))
		{
			g[u].push_back(v);
		}

		if (link(a[v], a[u], h))
		{
			g[v].push_back(u);
		}
	}
	vector<ll> ans;
	for (int i = 0; i < n; ++i)
	{
		used.assign(n, 0);
		path.clear();

		dfs(i);

		if (path.size() < ans.size() || ans.size() == 0)
		{
			ans = path;

		}
	}

	return ans;
}
int main()
{
     //freopen("inputB.txt", "r", stdin);
    //freopen("outputB.txt", "w", stdout);

	ll n, m, h;

	cin >> n >> m >> h;

	g.resize(n);
	used.resize(n);

	vector<ll> a(n);

	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}

	vector<pair<ll, ll>> in(m);

	for (int i = 0; i < m; ++i)
	{
		cin >> in[i].first >> in[i].second;
	}
	
	vector<ll> res = solvve(n, m, h, a, in);

	cout << res.size() << endl;

	for (ll val : res)
	{
		cout << val + 1 << " ";
	}
	
	puts("");
    return 0;
}

