#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e9;

vector<vector<ll>> g, gr;
vector<ll> used;
vector<ll> path, order, comp;

bool link(ll a, ll b, ll h)
{
	a += 1;
	a %= h;

	return (a == b);
}

void dfs(ll v)
{
	used[v] = 1;

	ll sum = 0;

	for (ll i = 0; i < g[v].size(); ++i)
	{
		ll to = g[v][i];

		if (used[to] == 0)
		{
			dfs(to);
		}
	}
	order.push_back(v);
	used[v] = 2;
}

void dfs2(ll v)
{
	used[v] = 1;

	comp.push_back(v);

	for (ll i = 0; i < gr[v].size(); ++i)
	{
		ll to = gr[v][i];

		if (used[to] == 0)
		{
			dfs2(to);
		}
	}
}

vector<ll> solvve(ll n, ll m, ll h, vector<ll> a, vector<pair<ll, ll>> in)
{
	g.clear();
	used.clear();
	gr.clear();
	
	g.resize(n);
	used.resize(n, 0);
	gr.resize(n);

	for (pair<ll, ll> p: in)
	{
		ll u = p.first - 1;

		ll v = p.second - 1;

		if (link(a[u], a[v], h))
		{
			g[u].push_back(v);
			gr[v].push_back(u);
		}

		if (link(a[v], a[u], h))
		{
			g[v].push_back(u);
			gr[u].push_back(v);
		}
	}
	
	for (ll i = 0; i < n; ++i)
	{
		if(used[i] == 0)
			dfs(i);
	}

	vector<ll> numcomp(n);
	ll cntcomp = 0;

	used.assign(n, 0);

	for (ll i = order.size() - 1; i >= 0; --i)
	{
		ll v = order[i];

		if (used[v] == 0)
		{
			comp.clear();
			dfs2(v);

			for (ll u : comp)
			{
				numcomp[u] = cntcomp;
			}

			cntcomp++;
		}
	}

	vector<vector<ll>> compg(cntcomp);

	for (ll i = 0; i < n; ++i)
	{
		for (ll j = 0; j < g[i].size(); ++j)
		{
			ll to = g[i][j];

			if (numcomp[i] != numcomp[to])
			{
				compg[numcomp[i]].push_back(numcomp[to]);
			}
		}
	}

	vector<ll> compnumb(cntcomp);

	for (int i = 0; i < n; ++i)
	{
		compnumb[numcomp[i]] += 1;
	}

	ll minsize = inf;
	ll anscomp = -1;

	for (ll i = 0; i < compg.size(); ++i)
	{
		if (compg[i].size() == 0 && compnumb[i] < minsize)
		{
			anscomp = i;
			minsize = compnumb[i];
		}
	}

	vector<ll> ans;

	for (ll i = 0; i < n; ++i)
	{
		if (numcomp[i] == anscomp)
		{
			ans.push_back(i);
		}
	}

	return ans;
}

int main()
{
    // freopen("inputB.txt", "r", stdin);
    //freopen("outputB.txt", "w", stdout);

	ll n, m, h;

	//cin >> n >> m >> h;
	scanf("%lld%lld%lld", &n, &m, &h);

	g.resize(n);
	used.resize(n);

	vector<ll> a(n);

	for (ll i = 0; i < n; ++i)
	{
		//cin >> a[i];
		scanf("%lld", &a[i]);
	}

	vector<pair<ll, ll>> in(m);

	for (ll i = 0; i < m; ++i)
	{
		//cin >> in[i].first >> in[i].second;
		scanf("%lld%lld", &in[i].first, &in[i].second);
	}
	
	vector<ll> res = solvve(n, m, h, a, in);

	//cout << res.size() << endl;
	printf("%lld\n", (ll)res.size());

	for (ll val : res)
	{
		//cout << val + 1 << " ";
		printf("%lld ", val + 1);
	}
	
	puts("");
    return 0;
}

