#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()
#define int ll

vector<set<int>> g;
vector<set<int>> rg;
vector<int> v;
vector<int> used;
vector<int> cyc;
vector<int> dp;


int dfscyc(int p) {
    used[p] = 1;
    for (auto i : g[p]) {
        if (used[i] == 1) {
            cyc[p] = i;
        }
        else {
            int t = dfscyc(i);
            if (t >= 0) {
                cyc[p] = t;
            }
        }
    }
    used[p] = 2;
    if (cyc[p] == p) {
        return -1;
    }
    else {
        return cyc[p];
    }
}

int dfs(int p) {
    used[p] = 1;
    dp[p] = 1;
    for (auto i : g[p]) {
        if (!used[i]) {
            dp[p] += dfs(i);
        }
    }
    return dp[p];
}

vector<int> path;

void dfsp(int p) {
    used[p] = 1;
    path.push_back(p);
    for (auto i : g[p]) {
        if (!used[i]) {
            dfsp(i);
        }
    }
}

void recdfs(int p) {
    used[p] = 1;
    dp[p] = 1;
    for (auto i : g[p]) {
        if (used[i] || cyc[i] >= 0) {
            dp[p] += dp[i];
        }
        else {
            recdfs(i);
            dp[p] += dp[i];
        }
    }
}


void kostil(int p) {
    used[p] = 1;
    for (auto i : g[p]) {
        if (used[i]) {
            if (cyc[i] == -1) {
                cyc[i] = i;
            }
            cyc[p] = cyc[i];
        }
        else {
            kostil(i);
            cyc[p] = cyc[i];
        }
    }
    if (cyc[p] == -1) {
        cyc[p] = p;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    g.resize(n);
    v.resize(n);
    cyc.resize(n, -1);
    used.resize(n);
    dp.resize(n);
    rg.resize(n);
    forn(i, n) {
        cin >> v[i];
    }
    forn(i, m) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (v[b] - v[a] == 1 || (v[b] + 1) % h - (v[a] + 1) % h == 1) {
            rg[b].insert(a);
            g[a].insert(b);
        }
        if (v[a] - v[b] == 1 || (v[a] + 1) % h - (v[b] + 1) % h == 1) {
            g[b].insert(a);
            rg[a].insert(b);
        }
    }
    int v = 0;
    if (h == 2) {
        forn(i, n) {
            if (!used[i]) {
                kostil(i);
            }
        }
        vector<int> t(n);
        int v = 0;
        forn(i, n) {
            if (cyc[i] >= 0) {
                v = i;
                t[cyc[i]]++;
            }
        }
        forn(i, n) {
            if (cyc[i] >= 0 && t[cyc[i]] < t[cyc[v]] && t[cyc[i]] > 0) {
                v = i;
            }
        }
    }
    else {

        forn(i, n) {
            if (!g[i].size()) {
                cout << 1 << endl;
                cout << i + 1 << endl;
#ifdef _MSC_VER
                system("pause");
#endif
                return 0;
            }
        }
        forn(i, n) {
            if (!used[i]) {
                dfscyc(i);
            }
        }
        fill(all(used), 0);
        forn(i, n) {
            if (!used[i]) {
                dfs(i);
            }
        }
        vector<int> t(n);
        forn(i, n) {
            if (cyc[i] >= 0) {
                t[cyc[i]] = max(t[cyc[i]], dp[i]);
            }
        }
        fill(all(used), 0);
        forn(i, n) {
            if (!used[i]) {
                recdfs(i);
            }
        }
        forn(i, n) {
            if (cyc[i] >= 0) {
                dp[i] = t[cyc[i]];
            }
            if (dp[i] < dp[v]) {
                v = i;
            }
        }
    }
    vector<int> t(n);
    forn(i, n) {
        if (cyc[i] >= 0) {
            v = i;
            t[cyc[i]]++;
        }
    }
    forn(i, n) {
        if (cyc[i] >= 0 && t[cyc[i]] < t[cyc[v]] && t[cyc[i]] > 0) {
            v = i;
        }
    }
    fill(all(used), 0);
    dfsp(v);
    cout << path.size() << endl;
    forn(i, path.size()) {
        cout << path[i] + 1 << " ";
    }
    cout << endl;
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}