#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()
#define int ll

vector<set<int>> g;
vector<set<int>> rg;
vector<int> v;
vector<int> used;
vector<int> cyc;
vector<int> dp;

vector<int> path;

void dfsp(int p) {
    used[p] = 1;
    path.push_back(p);
    for (auto i : g[p]) {
        if (!used[i]) {
            dfsp(i);
        }
    }
}


void dfs(int p, int k) {
    used[p] = 1;
    cyc[p] = k;
    for (auto i : g[p]) {
        if (!used[i]) {
            dfs(i, k);
        }
    }
}

void kostil(int p, int k) {
    used[p] = 1;
    cyc[p] = k;
    for (auto i : g[p]) {
        if (!used[i]) {
            dfs(i, k);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    g.resize(n);
    v.resize(n);
    cyc.resize(n, -1);
    used.resize(n);
    dp.resize(n);
    rg.resize(n);
    forn(i, n) {
        cin >> v[i];
    }
    forn(i, m) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (v[b] - v[a] == 1 || (v[b] + 1) % h - (v[a] + 1) % h == 1) {
            rg[b].insert(a);
            g[a].insert(b);
        }
        if (v[a] - v[b] == 1 || (v[a] + 1) % h - (v[b] + 1) % h == 1) {
            g[b].insert(a);
            rg[a].insert(b);
        }
    }
    if (h == 2) {
        forn(i, n) {
            if (!used[i]) {
                kostil(i, i);
            }
        }
    }
    else {
        forn(i, n) {
            if (!g[i].size()) {
                cout << 1 << endl;
                cout << i + 1 << endl;
#ifdef _MSC_VER
                system("pause");
#endif
                return 0;
            }
        }
        set<pair<int, int>> sm;
        forn(i, n) {
            sm.insert({ rg[i].size(), i });
        }
        while (sm.size() && (*sm.begin()).first == 0) {
            auto v = (*sm.begin());
            sm.erase(sm.begin());
            for (auto i : g[v.second]) {
                sm.erase({ rg[i].size(), i });
                rg[i].erase(v.second);
                sm.insert({ rg[i].size(), i });
            }
        }
        forn(i, n) {
            if (!used[i]) {
                dfs(i, i);
            }
        }
    }
    vector<int> t(n);
    int v = 0;
    forn(i, n) {
        if (cyc[i] >= 0) {
            v = i;
            t[cyc[i]]++;
        }
    }
    forn(i, n) {
        if (cyc[i] >= 0 && t[cyc[i]] < t[cyc[v]] && t[cyc[i]] > 0) {
            v = i;
        }
    }
    fill(all(used), 0);
    dfsp(v);
    cout << path.size() << endl;
    forn(i, path.size()) {
        cout << path[i] + 1 << " ";
    }
    cout << endl;
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}