#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()
#define int ll

vector<set<int>> g;
vector<set<int>> rg;
vector<int> v;
vector<int> used;
vector<int> cyc;

void comp(int p, int k) {
    used[p] = 1;
    cyc[p] = k;
    for (auto i : g[p]) {
        if (!used[i]) {
            comp(i, k);
        }
    }
}

vector<int> path;

void genPath(int p) {
    used[p] = 1;
    path.push_back(p);
    for (auto i : g[p]) {
        if (!used[i]) {
            genPath(i);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    g.resize(n);
    v.resize(n);
    cyc.resize(n, -1);
    used.resize(n);
    rg.resize(n);
    forn(i, n) {
        cin >> v[i];
    }
    forn(i, m) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (v[b] - v[a] == 1 || v[a] - v[b] == h - 1) {
            rg[b].insert(a);
            g[a].insert(b);
        }
        if (v[a] - v[b] == 1 || v[b] - v[a] == h - 1) {
            g[b].insert(a);
            rg[a].insert(b);
        }
    }
    forn(i, n) {
        if (!g[i].size()) {
            cout << 1 << endl;
            cout << i + 1 << endl;
#ifdef _MSC_VER
            system("pause");
#endif
            return 0;
        }
    }
    if (h == 2) {
        forn(i, n) {
            if (!used[i]) {
                comp(i, i);
            }
        }
        vector<int> sz(n);
        forn(i, n) {
            sz[cyc[i]]++;
        }
        int gd = 0;
        forn(i, n) {
            if (sz[i] < sz[gd]) {
                gd = i;
            }
        }
        fill(all(used), 0);
        genPath(gd);
        cout << path.size() << endl;
        forn(i, path.size()) {
            cout << path[i] + 1 << " ";
        }
        cout << endl;
    }
    else {
        set<pair<int, int>> sm;
        forn(i, n) {
            sm.insert({ rg[i].size(), i });
        }
        while (sm.size() && (*sm.begin()).first == 0) {
            auto v = (*sm.begin());
            sm.erase(sm.begin());
            for (auto i : g[v.second]) {
                sm.erase({ rg[i].size(), i });
                rg[i].erase(v.second);
                sm.insert({ rg[i].size(), i });
            }
        }
        forn(i, n) {
            if (!used[i]) {
                comp(i, i);
            }
        }
        vector<int> sz(n);
        int gd = 0;
        forn(i, n) {
            sz[cyc[i]]++;
            if (sz[cyc[i]] > 1) {
                gd = i;
            }
        }
        forn(i, n) {
            if (sz[cyc[i]] > 1 && sz[cyc[i]] < sz[cyc[gd]]) {
                gd = i;
            }
        }
        fill(all(used), 0);
        genPath(gd);
        cout << path.size() << endl;
        forn(i, path.size()) {
            cout << path[i] + 1 << " ";
        }
        cout << endl;
    }
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}