#include <map>
#include <set>
#include <list>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <cassert>
#include <complex>
#include <cstdlib>
#include <iomanip>
#include <numeric>
#include <iostream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using namespace chrono;

int main() {
	#ifdef DEBUG
		stdin = freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	
	int n, m, h; cin >> n >> m >> h;
	vector<int> u(n);
	for (int i = 0; i < n; i++) {
		cin >> u[i];
	}
	vector< vector<int> > g(n);
	vector< vector<int> > gRev(n);
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b; a--; b--;
		if ((u[b] + 1) % h == u[a]) {
			swap(a, b);
		}
		if ((u[a] + 1) % h == u[b]) {
			g[a].push_back(b);
			gRev[b].push_back(a);
		}
	}
	
	vector<char> used(n, false);
	vector<int> topSort;
	
	function<void(int)> dfs1 = [&](int v) {
		if (used[v]) {
			return;
		}
		used[v] = true;
		for (int to: g[v]) {
			dfs1(to);
		}
		topSort.push_back(v);
	};
	
	for (int i = 0; i < n; i++) {
		dfs1(i);
	}
	reverse(topSort.begin(), topSort.end());
	
	vector< vector<int> > komps;
	vector<int> kompId(n, -1);
	int kompKnt = 0;
	
	function<void(int)> dfs2 = [&](int v) {
		if (kompId[v] >= 0) {
			return;
		}
		komps.back().push_back(v);
		kompId[v] = kompKnt;
		for (int to: gRev[v]) {
			dfs2(to);
		}
	};
	
	for (int i: topSort) {
		if (kompId[i] >= 0) {
			continue;
		}
		komps.emplace_back();
		dfs2(i);
		kompKnt++;
	}
	
	vector<char> terminal(kompKnt, true);
	for (int i = 0; i < n; i++) {
		for (int j: g[i]) {
			if (kompId[i] != kompId[j]) {
				terminal[kompId[i]] = false;
			}
		}
	}
	
	int kompAns = -1;
	for (int i = 0; i < kompKnt; i++) {
		if (!terminal[i]) {
			continue;
		}
		if (kompAns < 0 || komps[i].size() < komps[kompAns].size()) {
			kompAns = i;
		}
	}
	assert(kompAns >= 0);
	
	cout << komps[kompAns].size() << "\n";
	for (int i: komps[kompAns]) {
		cout << i+1 << " ";
	}
	cout << endl;
	
	return 0;
}
