#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int MAXN = 100000 + 10;

vector < set <int> > g;
set <int> :: iterator it;
int n, m, h;

int u[MAXN];
pair <int, int> c[MAXN];

vector < pair <int, int> > edge;
vector <int> v;

vector <bool> flag;
vector <int> ans;

map <int, int> mp;
vector < vector <int> > cmp;

int p[MAXN];

void init_dsu(int n) {
    for (int i = 0; i < n; i++)
        p[i] = -1;
}

int find_set(int n) { return (p[n] < 0 ? n : p[n] = find_set(p[n])); }

void unite(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a != b) p[b] = a;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    g.resize(n); init_dsu(n);
    for (int i = 0; i < m; i++) {
        cin >> c[i].first >> c[i].second;
        c[i].first--; c[i].second--;
        g[c[i].first].insert(c[i].second);
        g[c[i].second].insert(c[i].first);
        unite(c[i].first, c[i].second);
    }

    for (int i = 0; i < n; i++) {

        if (g[i].empty()) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }

        for (it = g[i].begin(); it != g[i].end(); it++) {
            edge.push_back(make_pair(u[i], u[*it]));
            v.push_back(i);
        }
    }

    for (int i = 0; i < n; i++) {
        if (!mp.count(find_set(i))) {
            mp[find_set(i)] = cmp.size();
            cmp.push_back(vector <int> ());
        }
        cmp[mp[find_set(i)]].push_back(i);
    }
/*
    cout << edge.size() << endl;
    for (size_t i = 0; i < edge.size(); i++)
        cout << i << " : " << v[i] << " ||| " << edge[i].first << " " << edge[i].second << endl;
*/
    flag.assign(n, true);
    for (size_t i = 0; i < edge.size(); i++) {
        if (!flag[v[i]]) continue;
        if ((edge[i].first + 1) % h == edge[i].second)
            flag[v[i]] = false;
    }
    //cout << "kokoko" << endl;
/*
    for (int i = 0; i < n; i++)
        cout << flag[i] << " ";
    cout << endl;
*/
    for (int i = 0; i < n; i++)
        if (flag[i]) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }


    set <int> x;
    for (int i = 0; i < n; i++)
        x.insert(u[i]);
    if ((x.size() != n) && (x.size() != h)) return 1;

    int ind = 0;
    for (size_t i = 0; i < cmp.size(); i++)
        if (cmp[i].size() > cmp[ind].size())
            ind = i;

    for (size_t i = 0; i < cmp[ind].size(); i++)
        ans.push_back(cmp[ind][i] + 1);

    cout << ans.size() << "\n";
    for (size_t i = 0; i < ans.size(); i++)
        cout << ans[i] << " ";
    cout << endl;

    return 0;
}
