#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

const int MAXN = 100000 + 10;

vector < set <int> > g, g2;
set <int> :: iterator it;
int n, m, h;

int u[MAXN];
pair <int, int> c[MAXN];

vector < pair <int, int> > edge;
vector <int> v;

vector <bool> flag, order;
vector <int> ans, cur;
int sz = 10 * MAXN;

void dfs2(int v) {
    flag[v] = true; cur.push_back(v);
    set <int> :: iterator it;
    for (it = g2[v].begin(); it != g2[v].end(); it++) {
        int to = *it;
        if (!flag[to]) dfs2(to);
    }
    order.push_back(v);
}

void dfs1(int v) {
    flag[v] = true;
    set <int> :: iterator it;
    for (it = g[v].begin(); it != g[v].end(); it++) {
        int to = *it;
        if (!flag[to]) dfs1(to);
    }
    order.push_back(v);
}

void getSCC() {
    flag.assign(n, false);
    for (int i = 0; i < n; i++)
        if (!flag[i]) dfs1(i);
    reverse(order.begin(), order.end());
    flag.assign(n, false);
    for (int i = 0; i < n; i++)
        if (!flag[order[i]]) {
            dfs2(order[i]);
            if (cur.size() < sz)
                sz = cur.size(), ans = cur;
            cur.clear();
        }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        cin >> c[i].first >> c[i].second;
        c[i].first--; c[i].second--;
        g[c[i].first].insert(c[i].second);
        g[c[i].second].insert(c[i].first);
    }

    for (int i = 0; i < n; i++) {

        if (g[i].empty()) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }

        for (it = g[i].begin(); it != g[i].end(); it++) {
            edge.push_back(make_pair(i, *it));
            v.push_back(i);
        }
    }

/*
    cout << edge.size() << endl;
    for (size_t i = 0; i < edge.size(); i++)
        cout << i << " : " << v[i] << " ||| " << edge[i].first << " " << edge[i].second << endl;
*/
    g.clear(); g.resize(n); g2.resize(n);
    flag.assign(n, true);
    for (size_t i = 0; i < edge.size(); i++) {
        //if (!flag[v[i]]) continue;
        if ((u[edge[i].first] + 1) % h == u[edge[i].second]) {
            flag[edge[i].first] = false;
            g[edge[i].first].insert(edge[i].second);
            g2[edge[i].second].insert(edge[i].first);
        }
    }
    //cout << "kokoko" << endl;
/*
    for (int i = 0; i < n; i++)
        cout << flag[i] << " ";
    cout << endl;
*/
    for (int i = 0; i < n; i++)
        if (flag[i]) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }

    getSCC();

    cout << ans.size() << "\n";
    for (size_t i = 0; i < ans.size(); i++)
        cout << ans[i] + 1 << " ";
    cout << endl;

    return 0;
}
