#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

const int MAXN = 100000 + 10;

vector < set <int> > g, g2;
set <int> :: iterator it;
int n, m, h;

int u[MAXN];
pair <int, int> c[MAXN];

vector < pair <int, int> > edge;
vector <int> v;

vector <bool> flag;
vector <int> ans, cur;
int sz = 10 * MAXN;

vector < vector <int> > cmp;

int p[MAXN];

void init_dsu(int n) {
    for (int i = 0; i < n; i++)
        p[i] = -1;
}

int find_set(int n) { return (p[n] < 0 ? n : p[n] = find_set(p[n])); }

void unite(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a != b) p[b] = a;
}

void gen_ans() {
    set < pair <int, int> > s;
    for (int i = 0; i < n; i++)
        s.insert(make_pair(g2[i].size(), i));
    while ((!s.empty()) && (s.begin()->first == 0)) {
        int v = s.begin()->second;
        s.erase(s.begin());
        while (!g[v].empty()) {
            int to = *g[v].begin();
            s.erase(make_pair(g2[to].size(), to));
            g2[to].erase(v);
            g[v].erase(g[v].begin());
        }
        s.insert(make_pair(g2[v].size(), v));
    }

    init_dsu(n);

    for (int i = 0; i < n; i++) {
        for (it = g2[i].begin(); it != g2[i].end(); it++)
            unite(i, *it);
    }

    map <int, int> x;
    for (int i = 0; i < n; i++) {
        if (!x.count(find_set(i))) {
            x[find_set(i)] = cmp.size();
            cmp.push_back(vector <int> ());
        }
        cmp[x[find_set(i)]].push_back(i);
    }

    int ind = 0;
    for (size_t i = 1; i < cmp.size(); i++)
        if (cmp[ind].size() > cmp[i].size())
            ind = i;
    ans = cmp[ind];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        cin >> c[i].first >> c[i].second;
        c[i].first--; c[i].second--;
        g[c[i].first].insert(c[i].second);
        g[c[i].second].insert(c[i].first);
    }

    for (int i = 0; i < n; i++) {

        if (g[i].empty()) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }

        for (it = g[i].begin(); it != g[i].end(); it++) {
            edge.push_back(make_pair(i, *it));
            v.push_back(i);
        }
    }

/*
    cout << edge.size() << endl;
    for (size_t i = 0; i < edge.size(); i++)
        cout << i << " : " << v[i] << " ||| " << edge[i].first << " " << edge[i].second << endl;
*/
    g.clear(); g.resize(n); g2.resize(n);
    flag.assign(n, true);
    for (size_t i = 0; i < edge.size(); i++) {
        //if (!flag[v[i]]) continue;
        if ((u[edge[i].first] + 1) % h == u[edge[i].second]) {
            flag[edge[i].first] = false;
            g[edge[i].first].insert(edge[i].second);
            g2[edge[i].second].insert(edge[i].first);
        }
    }
    //cout << "kokoko" << endl;
/*
    for (int i = 0; i < n; i++)
        cout << flag[i] << " ";
    cout << endl;
*/
    for (int i = 0; i < n; i++)
        if (flag[i]) {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }

    gen_ans();

    cout << ans.size() << "\n";
    for (size_t i = 0; i < ans.size(); i++)
        cout << ans[i] + 1 << " ";
    cout << endl;

    return 0;
}
