#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int MAXN = 1e5 + 7;

int sz[MAXN];
int pr[MAXN];
int comp[MAXN];

void Init(int n) {
    for (int i = 0; i < n; ++i) {
        sz[i] = 1;
        pr[i] = i;
    }
}

int Get(int x) {
    if (pr[x] != x) pr[x] = Get(pr[x]);
    return pr[x];
}

void Union(int x, int y) {
    x = Get(x);
    y = Get(y);
    if (x == y) return;
    if (sz[x] < sz[y]) swap(x, y);
    pr[y] = x;
    sz[x] += sz[y];
}

bitset<MAXN> used;
vector<int> g[MAXN];
int pre[MAXN];
int tin[MAXN];
int tout[MAXN];
int fupa[MAXN];
int fft = 0;

bool Anc(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

void DFS(int v) {
    fupa[v] = v;
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u])
            continue;
        if (Anc(fupa[u], v) && tin[fupa[u]] < tin[fupa[v]])
            fupa[v] = fupa[u];
    }
    for (int u : g[v]) {
        if (used[u]) continue;
        DFS(u);
        if (Anc(fupa[u], v) && tin[fupa[u]] < tin[fupa[v]])
            fupa[v] = fupa[u];
    }
    for (int u = pre[v]; tin[u] >= tin[fupa[v]]; u = pre[fupa[u]]) {
        Union(v, u);
        if (tin[u] == tin[fupa[v]]) break;
    }
}

void SetT(int v) {
    tin[v] = fft++;
    used[v] = true;
    for (int u : g[v]) {
        if (used[u]) continue;
        pre[u] = v;
        SetT(u);
    }
    tout[v] = fft++;
}

bool CheckLeaf(int v) {
    used[v] = 1;
    for (int u : g[v])
        if (comp[pr[u]] != comp[pr[v]])
            return false;
    for (int u : g[v]) {
        if (used[u]) continue;
        if (!CheckLeaf(u))
            return false;
    }
    return true;
}

int tm[MAXN];

int main() {
    int n, m, h;
    cin >> n >> m >> h;
    Init(n);
    for (int i = 0; i < n; ++i) {
        cin >> tm[i];
        comp[i] = -1;
    }
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        if (tm[u] + 1 == tm[v] || tm[u] + 1 == tm[v] + h)
            g[u].push_back(v);
        swap(v, u);
        if (tm[u] + 1 == tm[v] || tm[u] + 1 == tm[v] + h)
            g[u].push_back(v);
        //g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        pre[i] = i;
        SetT(i);
    }
    for (int i = 0; i < n; ++i)
        used[i] = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        DFS(i);
    }
    int compSz = 0;
    for (int i = 0; i < n; ++i) {
        if (comp[Get(i)] == -1) {
            comp[pr[i]] = compSz;
            ++compSz;
        }
    }
    for (int i = 0; i < n; ++i)
        used[i] = 0;
    int ans = -1;
    int res = n + 1;
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        if (CheckLeaf(i)) {
            if (sz[pr[i]] < res) {
                res = sz[pr[i]];
                ans = comp[pr[i]];
            }
        }
    }
    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        if (comp[pr[i]] == ans)
            cout << i + 1 << ' ';
    }
    cout << '\n';
}

