#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

template<typename T>
struct segtree{
  int n;
  vector<T> t;
  segtree(int sz):n(1 << ((int)log2(n - 1) + 1)), t(n << 1, 0){}
  segtree(){}
  T combine(T x, T y){
    return x + y;
  }
  void modify(int p, T val, int v, int l, int r){
    if (r - l == 1){
      t[p] = val;
      return;
    }
    int mid = (l + r) >> 1;
    if (p < mid){
      modify(p, val, v << 1, l, mid);
    } else {
      modify(p, val, v << 1 | 1, mid, r);
    }
    t[v] = combine(t[v << 1], t[v << 1 | 1]);
  }
  void modify(int p, T val){
    modify(p, val, 1, 0, n);
  }
  T query(int cl, int cr, int v, int l, int r){
    if (r <= cl || l >= cr) return 0;
    if (l >= cl && r <= cr) return t[v];
    int mid = (l + r) >> 1;
    return combine(query(cl, cr, v << 1, l, mid), query(cl, cr, v << 1 | 1, mid, r));
  }
  T query(int l, int r){
    query(l, r, 1, 0, n);
  }
};

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
  string s;
  cin >> s;
  int n = s.size();
  vector<int> pr(n, -1);
  set<int> p0, p1;
  for (int i = 0; i < s.size(); i++){
    if (s[i] == '0'){
      if (p1.size() > 0){
        pr[i] = *p1.begin();
        p1.erase(p1.begin());
      }
      p0.insert(i);
    } else {
      if (p0.size() > 0){
        pr[i] = *p0.begin();
        p0.erase(p0.begin());
      }
      else{
        cout << -1 << endl;
        return 0;
      }
      p1.insert(i);
    }
  }
  if (p1.size() > 0){
    cout << -1 << endl;
    return 0;
  }
  vector<vector<int>> ans;
  vector<bool> used(n, false);
  for (int i = n - 1; i >= 0; i--){
    if (used[i]) continue;
    int v = i;
    vector<int> cur;
    while (v != -1){
      cur.pb(v);
      used[v] = true;
      v = pr[v];
    }
    reverse(cur.begin(), cur.end());
    ans.pb(cur);
  }
  cout << ans.size() << endl;
  for (int i = 0; i < ans.size(); i++){
    cout << ans[i].size() << ' ';
    for (auto it : ans[i]) cout << it + 1 << ' ';
    cout << endl;
  }
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
