#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <list>
#include <stack>

using namespace std;

list<int> dfs(int v, vector<vector<int>> &a, vector<bool> &used) {
    used[v] = true;
    list<int> ans;
    ans.push_back(v);
    for (auto u : a[v]) {
        if (!used[u])
            ans.splice(ans.begin(), dfs(u, a, used));
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<vector<int> > a(n);
    for (int i = 0; i < m; ++i) {
        int c1, c2;
        cin >> c1 >> c2;
        c1--; c2--;
        if ((t[c1] + 1) % h == t[c2])
            a[c1].push_back(c2);
        if ((t[c2] + 1) % h == t[c1])
            a[c2].push_back(c1);
    }
    list<int> ans;
    int k = 10000000;
    for (int i = 0; i < n; ++i) {
        vector<bool> used(n, false);
        list<int> q = dfs(i, a, used);
        if (k > q.size()) {
            k = q.size();
            ans = q;
        }
    }
    cout << k << endl;
    for (auto u: ans) {
        cout << u + 1 << " ";
    }
}
