import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class B {

    public int n, m, h;
    public int[] u;

    public boolean diffHour(int time1, int time2) {
        return (time1 + 1) % h == time2;
    }

    public List<List<Integer>> g;

    public int[] color;
    public int curColor = 0, curCount = 0;

    public void dfs(int v) {
        color[v] = curColor;
        curCount++;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (color[u] != curColor)
                dfs(u);
        }
    }

    public void solve() throws IOException {
        n = nextInt();
        m = nextInt();
        h = nextInt();
        u = new int[n];
        color = new int[n];
        Arrays.fill(color, -1);
        for (int i = 0; i < n; i++) {
            u[i] = nextInt();
        }
        g = new ArrayList<>(n);
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < m; i++) {
            int from = nextInt() - 1;
            int to = nextInt() - 1;
            int time1 = u[from];
            int time2 = u[to];
            if (diffHour(time1, time2)) {
                g.get(from).add(to);
            }
            if (diffHour(time2, time1)) {
                g.get(to).add(from);
            }
        }
        int minCount = -1;
        int minVertex = -1;
        for (int i = 0; i < n; i++) {
            dfs(i);
            curColor++;
            if (minCount == -1 || minCount > curCount) {
                minCount = curCount;
                minVertex = i;
            }
            curCount = 0;
        }
        out.println(minCount);
        dfs(minVertex);
        for (int i = 0; i < n; i++) {
            if (color[i] == curColor) {
                out.print((i + 1) + " ");
            }
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }
}
