import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class B {

    public int n, m, h;
    public int[] u;

    public boolean diffHour(int time1, int time2) {
        return (time1 + 1) % h == time2;
    }

    public List<List<Integer>> g, reverseG;

    public List<Integer> topSort;

    public boolean[] used;

    public void dfs(int v) {
        used[v] = true;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (!used[u])
                dfs(u);
        }
        topSort.add(v);
    }

    public int count = 0, curColor = 0;

    public int[] color, allCount;

    public void dfs2(int v) {
        count++;
        color[v] = curColor;
        for (int i = 0; i < reverseG.get(v).size(); i++) {
            int u = reverseG.get(v).get(i);
            if (color[u] == -1)
                dfs2(u);
        }
    }

    public static class Edge {
        public int from, to;

        public Edge(int from, int to) {
            this.from = from;
            this.to = to;
        }
    }

    public List<List<Integer>> newG;
    public List<Edge> edges;

    public int[] dp;

    public void dfs3(int v) {
        used[v] = true;
        for (int i = 0; i < newG.get(v).size(); i++) {
            int u = newG.get(v).get(i);
            if (!used[u])
                dfs3(u);
        }
        int count = allCount[v];
        for (int i = 0; i < newG.get(v).size(); i++) {
            int u = newG.get(v).get(i);
            count += dp[u];
        }
        dp[v] = count;
    }

    public void solve() throws IOException {
        n = nextInt();
        m = nextInt();
        h = nextInt();
        u = new int[n];
        used = new boolean[n];
        for (int i = 0; i < n; i++) {
            u[i] = nextInt();
        }
        g = new ArrayList<>(n);
        reverseG = new ArrayList<>(n);
        topSort = new ArrayList<>(n);
        edges = new ArrayList<>(m);
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<Integer>());
            reverseG.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < m; i++) {
            int from = nextInt() - 1;
            int to = nextInt() - 1;
            int time1 = u[from];
            int time2 = u[to];
            if (diffHour(time1, time2)) {
                g.get(from).add(to);
                edges.add(new Edge(from, to));
                reverseG.get(to).add(from);
            }
            if (diffHour(time2, time1)) {
                g.get(to).add(from);
                edges.add(new Edge(to, from));
                reverseG.get(from).add(to);
            }
        }
        for (int i = 0; i < n; i++) {
            if (!used[i])
                dfs(i);
        }
        color = new int[n];
        allCount = new int[n];
        Arrays.fill(color, -1);
        for (int i = 0; i < n; i++) {
            int v = topSort.get(topSort.size() - 1 - i);
            if (color[v] == -1) {
                dfs2(v);
                allCount[curColor] = count;
                count = 0;
                curColor++;
            }
        }
        newG = new ArrayList<>(curColor);
        for (int i = 0; i < curColor; i++) {
            newG.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < edges.size(); i++) {
            Edge edge = edges.get(i);
            if (color[edge.from] != color[edge.to]) {
                newG.get(color[edge.from]).add(color[edge.to]);
            }
        }
        dp = new int[curColor];
        Arrays.fill(used, false);
        for (int i = 0; i < curColor; i++) {
            if (!used[i])
                dfs3(i);
        }
        int minCount = dp[0];
        int minInd = 0;
        for (int i = 1; i < curColor; i++) {
            if (dp[i] < minCount) {
                minCount = dp[i];
                minInd = i;
            }
        }
        out.println(minCount);
        List<Integer> ansColors = new ArrayList<>(n);
        Arrays.fill(used, false);
        dfs3(minInd);
        for (int i = 0; i < curColor; i++) {
            if (used[i]) {
                ansColors.add(color[i]);
            }
        }
        List<Integer> finalAns = new ArrayList<>(n);
        for (int i = 0; i < n; i++) {
            if (color[i] == minInd)
                finalAns.add(i);
        }
        for (int i = 0; i < finalAns.size(); i++) {
            out.print((finalAns.get(i) + 1) + " ");
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }
}
