import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class A {

    public String s;
    public int n, curColor = 0;
    public int[] color;
    public List<Integer> one, zero;

    public int indexOf(int startFrom, char c) {
        int pos;
        List<Integer> toFind = one;
        if (c == '0')
            toFind = zero;

        do {
            int l = -1;
            int r = toFind.size();
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (toFind.get(m) > startFrom)
                    r = m;
                else
                    l = m;
            }
            if (r != toFind.size())
                pos = toFind.get(r);
            else
                pos = -1;
            if (pos == -1)
                return -1;
            startFrom = pos + 1;
        } while (color[pos] != -1);
        return pos;
    }

    public void find(int zeroInd) throws IOException {
        char curChar = '0';
        int curPos = zeroInd;
        while (true) {
            color[curPos] = curColor;
            if (s.charAt(curPos) == '0') {
                curPos = indexOf(curPos + 1, '1');
                if (curPos == -1)
                    return;
            } else {
                curPos = indexOf(curPos + 1, '0');
                if (curPos == -1) {
                    out.println(-1);
                    br.close();
                    out.close();
                    System.exit(0);
                    return;
                }
            }
        }
    }

    public void solve() throws IOException {
        s = nextToken();
        n = s.length();
        color = new int[n];
        Arrays.fill(color, -1);
        one = new ArrayList<>(n);
        zero = new ArrayList<>(n);
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) == '0')
                zero.add(i);
            else
                one.add(i);
        }
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) == '0' && color[i] == -1) {
                find(i);
                curColor++;
            }
        }
        List<List<Integer>> ans = new ArrayList<>(curColor);
        for (int i = 0; i < curColor; i++) {
            ans.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < n; i++) {
            if (color[i] == -1) {
                out.println(-1);
                return;
            }
            ans.get(color[i]).add(i + 1);
        }
        out.println(curColor);
        for (int i = 0; i < curColor; i++) {
            out.print(ans.get(i).size() + " ");
            for (int j = 0; j < ans.get(i).size(); j++) {
                out.print(ans.get(i).get(j) + " ");
            }
            out.println();
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter("output.txt");
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }
}
