import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class A {

    public String s;
    public int n, curColor = 0;
    public int[] color;
    public TreeSet<Integer> one, zero;

    public int indexOf(int startFrom, boolean zero) {
        TreeSet<Integer> toFind = one;
        if (zero)
            toFind = this.zero;
        Integer ans = toFind.ceiling(startFrom);
        if (ans == null)
            return -1;
        else
            return ans;
    }

    public void find(int zeroInd) throws IOException {
        int curPos = zeroInd;
        boolean zero = true;
        while (true) {
            color[curPos] = curColor;
            if (zero)
                this.zero.remove(curPos);
            else
                one.remove(curPos);
            if (zero) {
                curPos = indexOf(curPos + 1, false);
                if (curPos == -1)
                    return;
            } else {
                curPos = indexOf(curPos + 1, true);
                if (curPos == -1) {
                    out.println(-1);
                    br.close();
                    out.close();
                    System.exit(0);
                    return;
                }
            }
            zero = !zero;
        }
    }

    public void solve() throws IOException {
        s = nextToken();
        n = s.length();
        color = new int[n];
        Arrays.fill(color, -1);
        one = new TreeSet<>();
        zero = new TreeSet<>();
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) == '0')
                zero.add(i);
            else
                one.add(i);
        }
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) == '0' && color[i] == -1) {
                find(i);
                curColor++;
            }
        }
        List<List<Integer>> ans = new ArrayList<>(curColor);
        for (int i = 0; i < curColor; i++) {
            ans.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < n; i++) {
            if (color[i] == -1) {
                out.println(-1);
                return;
            }
            ans.get(color[i]).add(i + 1);
        }
        out.println(curColor);
        for (int i = 0; i < curColor; i++) {
            out.print(ans.get(i).size() + " ");
            for (int j = 0; j < ans.get(i).size(); j++) {
                out.print(ans.get(i).get(j) + " ");
            }
            out.println();
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter("output.txt");
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }
}
