#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > g1, g1t;
vector< vector<int> > g;
vector<int> used;
vector<int> dp, sz;

void dfs(int v) {
	dp[v] = sz[v];
	for (int to : g[v]) {
		if (dp[to] == -1) 
			dfs(to);
		dp[v] += dp[to];
	}
}

set<int> ans_comp;
void dfs1(int v) {
	ans_comp.insert(v);
	used[v] = true;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs1(to);
		}
	}
}

vector<bool> marked;
vector<int> order;
void topSort(int v) {
	marked[v] = true;
	for (int to : g1[v]) {
		if (!marked[to]) {
			topSort(to);
		}
	}
	order.push_back(v);
}

int color = 0;
vector<int> comp;
void findComp(int v) {
	sz[color]++;
	comp[v] = color;
	for (int to : g1t[v]) {
		if (comp[to] == -1) {
			findComp(to);
		}
	}
}

void solve() {
	int n, m, h;
	cin >> n >> m >> h;
	sz.resize(n);
	vector<int> u(n);
	for (int& uu : u) cin >> uu;
	g1.resize(n);
	g1t.resize(n);
	marked.resize(n, false);
	for (int i = 0; i < m; ++i) {
		int c1, c2;
		cin >> c1 >> c2;
		--c1; --c2;
		if ((u[c1] + 1) % h == u[c2]) {
			g1[c1].push_back(c2);
			g1t[c2].push_back(c1);
		}
		if ((u[c2] + 1) % h == u[c1]) {
			g1[c2].push_back(c1);
			g1t[c1].push_back(c2);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!marked[i]) {
			topSort(i);
		}	
	}
	reverse(order.begin(), order.end());
	comp.resize(n, -1);
	for (int v : order) {
		if (comp[v] == -1) {
			findComp(v);
			color++;
		}
	}/*
	for (int i = 0; i < n; ++i) {
		cout << i + 1 << ": ";
		for (int to : g1[i]) cout << to + 1 << " ";
		cout << endl;
	}
	cout << endl;
	for (int i = 0; i < n; ++i)
		cout << order[i] + 1 << " ";
	cout << endl;*/
	g.resize(color);
	for (int i = 0; i < n; ++i) {
		for (int to : g1[i]) {
			if (comp[to] != comp[i]) {
				g[comp[i]].push_back(comp[to]);
			}
		}
	}
	dp.resize(color, -1);
	int ans = 0;
	for (int i = 0; i < color; ++i) {
		if (dp[i] == -1)
			dfs(i);
		if (dp[ans] > dp[i]) {
			ans = i;
		}
	}
	used.resize(color);
	cout << dp[ans] << endl;
	dfs1(ans);
	for (int i = 0; i < n; ++i) {
		if (ans_comp.find(comp[i]) != ans_comp	.end()) {
			cout << i + 1 << " ";
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}