#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------

const int MAXN = 100005;
int n, m, h;
int u[MAXN], c1[MAXN], c2[MAXN];

vi g[MAXN];
vi gt[MAXN];

bool is_edge(int i, int j) {
	return (u[i] + 1) % h == u[j];
}

vi order;
int comp[MAXN];
bool is_good_comp[MAXN];
int comp_sz[MAXN];

bool used[MAXN];

void init_used() {
	for (int i = 0; i < n; ++i) {
		used[i] = false;
	}
}

void dfs1(int v) {
	used[v] = true;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs1(u);
		}
	}
	order.pb(v);
}

void dfs_comps(int v, int cur_comp) {
	used[v] = true;
	comp[v] = cur_comp;
	for (auto u : gt[v]) {
		if (!used[u]) {
			dfs_comps(u, cur_comp);
		}
	}
}


signed main() {
	doRoutine();

	cin >> n >> m >> h;
	for (int i = 0; i < n; ++i) {
		cin >> u[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> c1[i] >> c2[i];
		--c1[i];
		--c2[i];
		if (is_edge(c1[i], c2[i])) {
			g[c1[i]].pb(c2[i]);
			gt[c2[i]].pb(c1[i]);
		}
		if (is_edge(c2[i], c1[i])) {
			g[c2[i]].pb(c1[i]);
			gt[c1[i]].pb(c2[i]);
		}
	}

	init_used();
	for (int v = 0; v < n; ++v) {
		if (!used[v]) {
			dfs1(v);
		}
	}
	reverse(all(order));

	init_used();
	int comp_id = 0;
	for (int v = 0; v < n; ++v) {
		cerr << order[v] << " ";
		if (!used[order[v]]) {
			dfs_comps(order[v], comp_id);
			++comp_id;
		}
	}
	cerr << endl;

	int comps_cnt = comp_id;
	for (int i = 0; i < comps_cnt; ++i) {
		is_good_comp[i] = true;
	}
	for (int v = 0; v < n; ++v) {
		for (auto u : g[v]) {
			if (comp[v] != comp[u]) {
				is_good_comp[comp[v]] = false;
			}
		}
		++comp_sz[comp[v]];
	}

	int best_size = n + 1, best_id = -1;
	for (int i = 0; i < comps_cnt; ++i) {
		if (is_good_comp[i]) {
			if (comp_sz[i] < best_size) {
				best_size = comp_sz[i];
				best_id = i;
			}
		}
	}

	cout << best_size << endl;
	for (int v = 0; v < n; ++v) {
		if (comp[v] == best_id) {
			cout << v + 1 << " ";
		}
	}

	/// ----------------

	for (int v = 0; v < n; ++v) {
		cerr << v << ": ";
		for (auto u : g[v]) {
			cerr << u << ", ";
		}
		cerr << endl;
	}


	return 0;
}