#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------

const int MAXN = 100005;
int a[MAXN];
int p, n, d, b;

int get_left_cell(int x) {
	int L = -1, R = x;
	while (R - L > 1) {
		int m = (L + R) / 2;
		int t = (x - m + (d - 1)) / d;
		if (t <= m + 1) {
			R = m;
		}
		else {
			L = m;
		}
	}
	return R;
}

int get_right_cell(int x) {
	int L = x, R = n;
	cerr << "!" << x << endl;
	while (R - L > 1) {
		int m = (L + R) / 2;
		int t = (x - m + (d - 1)) / d;
		if (t <= n - m) {
			L = m;
		}
		else {
			R = m;
		}
	}
	return L;
}

bool check(vi &arr, int LB, int RB, int lsum, int rsum) {
	int l = LB, r = RB - 1;
	while (l < r) {
		lsum += arr[l], rsum += arr[r];
		if (lsum < b || rsum < b) {
			return false;
		}
		else {
			lsum -= b;
			rsum -= b;
		}
		++l;
		--r;
	}
	if (l == r) {
		if (lsum + rsum + arr[l] < b) {
			return false;
		}
	}
	return true;
}

void transfer(vi &a, int i, int j, int x) {
	if (i != j) {
		a[i] -= x;
		a[j] += x;
	}
}



bool ok_seg(int LB, int RB) {
	cerr << LB << " " << RB << endl;
	for (int pers = LB; pers < RB; ++pers) {
		cerr << pers << endl;
		for (int x = 0; x <= a[pers]; ++x) {
			cerr << x << endl;	
			vi left(n), right(n);
			for (int i = LB; i < RB; ++i) {
				left[i] = max(get_left_cell(i), LB);
			}
			for (int i = LB; i < RB; ++i) {
				right[i] = min(get_right_cell(i), RB - 1);
			}

			vi cur(n);
			for (int i = 0; i < n; ++i) {
				cur[i] = a[i];
			}

			transfer(cur, pers, left[pers], x);
			transfer(cur, pers, right[pers], a[pers] - x);
			for (int i = LB; i < pers; ++i) {
				transfer(cur, i, left[i], a[i]);
			}
			for (int i = pers + 1; i < RB; ++i) {
				transfer(cur, i, right[i], a[i]);
			}
			int lsum = 0;
			for (int i = 0; i < LB; ++i) {
				lsum += a[i];
			}
			int rsum = 0;
			for (int i = RB; i < n; ++i) {
				rsum += a[i];
			}
			if (check(cur, LB, RB, lsum, rsum)) {
				return true;
			}
		}
	}
	return false;
}

signed main() {
	doRoutine();

	cin >> p >> n >> d >> b;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}


	if (p == 1) {
		int LBS = -1, RBS = n;
		while (RBS - LBS > 1) {
			int MBS = (LBS + RBS) / 2;
			int pref_len = MBS;

			vi left(n);
			for (int i = pref_len; i < n; ++i) {
				left[i] = max(pref_len, get_left_cell(i));
			}

			vi val(n);
			for (int i = 0; i < n; ++i) {
				val[i] = a[i];
			}

			for (int i = pref_len; i < n; ++i) {
				if (left[i] < i) {
					val[left[i]] += val[i];
					val[i] = 0;
				}
			}

			int sum = 0;
			for (int i = 0; i < pref_len; ++i) {
				sum += a[i];
			}
			bool ok = true;
			for (int i = pref_len; i < n; ++i) {
				sum += val[i];
				if (sum < b * (i - pref_len + 1)) {
					ok = false;
				}
			}
			if (ok) {
				RBS = MBS;
			}
			else {
				LBS = MBS;
			}
		}
		cout << RBS << endl;
	}
	else {
		int LBS = 2, RBS = n + 1;
		while (RBS - LBS > 1) {
			int MBS = (LBS + RBS) / 2;
			bool flag = false;
			for (int i = 0; i + MBS <= n; ++i) {
				if (ok_seg(i, i + MBS)) {
					flag = true;
				}
			}
			if (flag) {
				LBS = MBS;
			}
			else {
				RBS = MBS;
			}
		}
		cout << n - LBS << endl;
	}


	return 0;
}