#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <stack>

using namespace std;

vector<vector<int>> edge, edgec;
int n, m, h, t, st, fn;
vector<int> srvrs, numc;
vector<pair<int, int>> chk;
vector<int> used, color;
vector<bool> colored;
int clr;
stack<int> stck;

int cycle(int v) {
    used[v] = -1;
    stck.push(v);
    int cyc = -1;
    for (auto nxt : edge[v]) {
        if (used[nxt] == -1) {
            if (colored[nxt]) {
                color[v] = color[nxt];
                cyc = color[nxt];
                continue;
            }
            while (stck.top() != nxt) {
                color[stck.top()] = color[nxt];
                colored[stck.top()] = true;
                stck.pop();
            }
            color[stck.top()] = color[nxt];
            colored[stck.top()] = true;
            stck.pop();
        }
        else if (used[nxt] == 0) {
            int rs = cycle(nxt);
            if (rs != -1 && rs != color[v]) {
                cyc = rs;
                color[v] = rs;
            }
        }
    }
    if (!colored[v]) stck.pop();
    used[v] = 1;
    if (cyc != -1) {
        color[v] = cyc;
        return cyc;
    }
    return -1;
}

int main()
{
    scanf("%d %d %d", &n, &m, &h);
    srvrs.resize(n);
    edge.resize(n);
    edgec.resize(n);
    chk.resize(n);
    numc.resize(n);
    color.resize(n);
    colored.resize(n, false);
    used.resize(n, 0);
    for (int i=0;i<n;i++) {
        scanf("%d", &srvrs[i]);
        chk[i] = {srvrs[i], i};
        color[i] = i;
    }
    for (int i=0;i<m;i++) {
        scanf("%d %d", &st, &fn);
        st--;
        fn--;
        if (srvrs[st] + 1 == srvrs[fn] || (srvrs[st] == h - 1 && srvrs[fn] == 0)) edge[st].push_back(fn);
        if (srvrs[fn] + 1 == srvrs[st] || (srvrs[fn] == h - 1 && srvrs[st] == 0)) edge[fn].push_back(st);
    }
    for (int i=0;i<n;i++) {
        if (used[chk[i].second] == 0) {
            cycle(chk[i].second);
        }
    }
    int mins = 1000000;
    int whr = -1;
    for (int i=0;i<n;i++) {
        numc[color[i]]++;
        for (auto nxt : edge[i]) {
            if (color[i] != color[nxt]) edgec[color[i]].push_back(color[nxt]);
        }
    }
    for (int i=0;i<n;i++) {
        if (numc[i] > 0 && numc[i] < mins && edgec[i].size() == 0) {
            mins = numc[i];
            whr = i;
        }
    }
    printf("%d\n", numc[whr]);
    for (int i=0;i<n;i++) {
        if (color[i] == whr) {
            printf("%d ", i + 1);
        }
    }

    return 0;
}