#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int n, m, h;
vector<int> path;
vector<int> color;
vector<vector<int>> g;

int next(int a, int b)
{
    if ((a == b - 1) || (a == h - 1 && b == 0))
        return 0;
    else if ((b == a - 1) || (b == h - 1 && a == 0))
        return 1;
    else
        return -1;
}

void dfs(int v, int clr)
{
    path.push_back(v);
    color[v] = clr;

    for (int u : g[v])
        if (color[u] != clr)
            dfs(u, clr);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int i, j;
    cin >> n >> m >> h;

    vector<int> updates(n);
    for (i = 0; i < n; i++)
        cin >> updates[i];

    g.resize(n);
    for (i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        int k = next(updates[a], updates[b]);
        if (k == 0)
            g[a].push_back(b);
        if (k == 1)
            g[b].push_back(a);
    }

    vector<int> *minpath = {};
    color.resize(n, -1);

    for (i = 0; i < n; i++)
    {
        path.clear();
        dfs(i, i);

        if (!minpath || path.size() < minpath->size())
            minpath = &path;
    }

    vector<int> ans = *minpath;

    cout << ans.size() << endl;
    for (auto elem : ans)
        cout << elem + 1 << " ";

    return 0;
}
