#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int n, m, h;
vector<int> used;
vector<int> topsort;
vector<int> comp;
vector<vector<int>> g;
vector<vector<int>> rev;

int next(int a, int b)
{
    if ((a == b - 1) || (a == h - 1 && b == 0))
        return 0;
    else if ((b == a - 1) || (b == h - 1 && a == 0))
        return 1;
    else
        return -1;
}

void dfs(int v)
{
    used[v] = true;

    for (int u : g[v])
        if (!used[u])
            dfs(u);

    topsort.push_back(v);
}

void dfs_mark(int v, int clr)
{
    used[v] = true;
    comp[v] = clr;

    for (int u : rev[v])
        if (!used[u])
            dfs_mark(u, clr);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int i;
    cin >> n >> m >> h;

    vector<int> updates(n);
    for (i = 0; i < n; i++)
        cin >> updates[i];

    g.resize(n);
    rev.resize(n);
    vector<pair<int, int>> edges;
    for (i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        int k = next(updates[a], updates[b]);
        if (k == 0)
        {
            g[a].push_back(b);
            rev[b].push_back(a);
            edges.push_back({a, b});
        }
        if (k == 1)
        {
            g[b].push_back(a);
            rev[a].push_back(b);
            edges.push_back({b, a});
        }
    }

    used.resize(n, false);
    for (i = 0; i < n; i++)
        if (!used[i])
            dfs(i);

    used.assign(n, false);
    comp.resize(n, -1);
    int cur = 0;
    for (auto it = topsort.rbegin(); it != topsort.rend(); it++)
    {
        if (!used[*it])
        {
            dfs_mark(*it, cur);
            cur++;
        }
    }

    vector<vector<int>> compg(cur);
    for (i = 0; i < edges.size(); i++)
        if (comp[edges[i].first] != comp[edges[i].second])
            compg[comp[edges[i].first]].push_back(comp[edges[i].second]);

    int empty = -1;
    for (i = 0; i < cur; i++)
    {
        if (compg[i].empty())
        {
            empty = i;
            break;
        }
    }

    vector<int> ans;
    for (i = 0; i < n; i++)
        if (comp[i] == empty)
            ans.push_back(i);

    cout << ans.size() << endl;
    for (auto elem : ans)
        cout << elem + 1 << " ";

    return 0;
}
