#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

typedef long long ll;

const ll SIDE = 9;

ll calc(ll mask)
{
    ll ans = 0;
    for (ll i = 0; i < SIDE * 2ll; i++)
    {
        if (mask & (1ll << i))
        {
            if (i < SIDE)
                ans -= (1ll << (SIDE - i - 1ll));
            else
                ans += (1ll << (i - SIDE));
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, i, j;
    cin >> n;

    vector<ll> num(n);
    vector<bool> exists(3e5, false);
    vector<ll> counted(3e5, -1);
    ll total = 0;
    for (i = 0; i < n; i++)
    {
        cin >> num[i];
        if (!exists[num[i] + (ll)1e5])
            total++;
        exists[num[i] + (ll)1e5] = true;
    }

    vector<ll> sums(1ll << (SIDE * 2ll));
    for (ll mask = 0; mask < (1ll << (SIDE * 2ll)); mask++)
        sums[mask] = calc(mask) + (ll)1e5;

    ll ans = -1;
    ll ansones = 1000;
    for (ll mask = 0; mask < (1ll << (SIDE * 2ll)); mask++)
    {
        ll submask = mask;
        ll cnt = 0;

        if (exists[sums[submask]])
        {
            cnt++;
            counted[sums[submask]] = mask;
        }

        while (submask)
        {
            submask = (submask - 1ll) & mask;

            if (exists[sums[submask]] && counted[sums[submask]] != mask)
            {
                cnt++;
                counted[sums[submask]] = mask;
            }
        }

        if (cnt == total)
        {
            ll ones = 0;
            for (ll i = 0; i < SIDE * 2ll; i++)
                if (mask & (1ll << i))
                    ones++;

            if (ones < ansones)
            {
                ans = mask;
                ansones = ones;
            }
        }
    }

    vector<ll> final;
    for (ll i = 0; i < SIDE * 2ll; i++)
    {
        if (ans & (1ll << i))
        {
            if (i < SIDE)
                final.push_back(-(1ll << (SIDE - i - 1ll)));
            else
                final.push_back(1ll << (i - SIDE));
        }
    }

    cout << final.size() << endl;
    for (auto elem : final)
        cout << elem << " ";

    return 0;
}
