#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

typedef long long ll;

const ll SIDE = 10;

pair<ll, ll> calc(ll mask)
{
    ll ans = 0;
    ll cnt = 0;

    for (ll i = 0; i < SIDE * 2ll; i++)
    {
        if (mask & (1ll << i))
        {
            if (i < SIDE)
                ans -= (1ll << (SIDE - i - 1ll));
            else
                ans += (1ll << (i - SIDE));

            cnt++;
        }
    }

    return {ans, cnt};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, i, j;
    cin >> n;

    vector<ll> num(n);
    vector<bool> exists((ll)1e6, false);
    vector<ll> counted((ll)1e6, -1);
    ll total = 0;
    for (i = 0; i < n; i++)
    {
        cin >> num[i];
        if (!exists[num[i] + (ll)4e5])
            total++;
        exists[num[i] + (ll)4e5] = true;
    }

    vector<ll> sums(1ll << (SIDE * 2ll));
    vector<ll> ones(1ll << (SIDE * 2ll));
    vector<vector<ll>> working(1ll << (SIDE * 2ll));
    for (ll mask = 0; mask < (1ll << (SIDE * 2ll)); mask++)
    {
        auto p = calc(mask);
        sums[mask] = p.first + (ll)4e5;
        ones[mask] = p.second;

        if (exists[sums[mask]])
            working[mask].push_back(sums[mask]);
    }

    ll ans = -1;
    ll ansones = 1000;
    for (ll mask = 0; mask < (1ll << (SIDE * 2ll)); mask++)
    {
        ll submask = mask;
        ll cnt = 0;

        if (ones[mask] >= ansones)
            continue;

        if (exists[sums[submask]])
        {
            cnt++;
            counted[sums[submask]] = mask;
        }

        for (ll i = 0; i < SIDE * 2ll; i++)
        {
            if (mask & (1ll << i))
            {
                for (ll elem : working[mask ^ (1ll << i)])
                {
                    if (counted[elem] != mask)
                    {
                        cnt++;
                        counted[elem] = mask;
                        working[mask].push_back(elem);
                    }

                    if (cnt == total)
                        break;
                }
            }

            if (cnt == total)
                break;
        }

        if (cnt == total)
        {
            ans = mask;
            ansones = ones[mask];
        }
    }

    vector<ll> final;
    for (ll i = 0; i < SIDE * 2ll; i++)
    {
        if (ans & (1ll << i))
        {
            if (i < SIDE)
                final.push_back(-(1ll << (SIDE - i - 1ll)));
            else
                final.push_back(1ll << (i - SIDE));
        }
    }

    cout << final.size() << endl;
    for (auto elem : final)
        cout << elem << " ";

    return 0;
}
