#include <iostream>
#include <vector>
#include <queue>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string s;
    cin >> s;
    int n = s.size();
    int i;

    vector<vector<int>> subseq(n);
    queue<int> zeroes;
    queue<int> ones;
    int next = 0;
    bool imp = false;

    for (i = 0; i < n; i++)
    {
        if (s[i] == '0')
        {
            if (ones.empty())
            {
                subseq[next].push_back(i);
                zeroes.push(next);
                next++;
            }
            else
            {
                int k = ones.front();
                ones.pop();

                subseq[k].push_back(i);
                zeroes.push(k);
            }
        }
        else
        {
            if (zeroes.empty())
            {
                imp = true;
                break;
            }
            else
            {
                int k = zeroes.front();
                zeroes.pop();

                subseq[k].push_back(i);
                ones.push(k);
            }
        }
    }

    if (imp)
        cout << "-1" << endl;
    else
    {
        cout << next << endl;
        for (i = 0; i < next; i++)
        {
            cout << subseq[i].size() << " ";
            for (auto elem : subseq[i])
                cout << elem + 1 << " ";
            cout << endl;
        }
    }

    return 0;
}
