//#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

const int MAXN = 1e5 + 100;
int n, m, h;
set <int> g[MAXN], ng[MAXN], G[MAXN], rng[MAXN];
int t[MAXN];
vector <bool> used;
vector <pii> edge;

void read() {
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v; u--; v--;
        g[u].insert(v);
        g[v].insert(u);
    }

    for (int v = 0; v < n; v++) {
        for (auto u : g[v]) {
            if (t[u] == (t[v] + 1) % h) {
                ng[v].insert(u);
                edge.push_back(mp(v, u));
                rng[u].insert(v);
            }
        }
    }
}

void dfs1(int v, vector <int> &ans) {
    ans.push_back(v);
    used[v] = true;
    for (auto u : ng[v]) {
        if (!used[u]) {
            dfs1(u, ans);
        }
    }
}

vector <int> order;

void dfsTopSort(int v) {
    used[v] = true;
    for (auto u : ng[v]) {
        if (!used[u]) {
            dfsTopSort(u);
        }
    }
    order.push_back(v);
}

int comp[MAXN];

void dfs2(int v, int c) {
    comp[v] = c;
    used[v] = true;
    for (auto u : rng[v]) {
        if (!used[u]) {
            dfs2(u, c);
        }
    }
}

void solve() {
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfsTopSort(i);
        }
    }
    reverse(all(order));
    used.assign(n, false);
    int N = 0;
    for (int i = 0; i < n; i++) {
        if (!used[order[i]]) {
            dfs2(order[i], N);
            N++;
        }
    }
    for (auto c : edge) {
        int c1 = comp[c.first], c2 = comp[c.second];
        if (c1 != c2) {
            G[c1].insert(c2);
        }
    }
    used.assign(n, false);
    vector <int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i] = i;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i] && G[comp[i]].empty()) {
            vector <int> b;
            dfs1(i, b);
            if (b.size() < ans.size()) {
                ans.swap(b);
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto u : ans) {
        cout << u + 1 << ' ';
    }
}
/*
void read1() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v; u--, v--;
        ng[u].push_back(v);
    }
}

void solve1() {
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfsTopSort(i);
    }
    reverse(all(order));
    for (auto u : order) {
        cout << u + 1 << ' ';
    }
}
*/
int main() {
    read();
    solve();
}