#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

int n;
vector <int> a;

const int L = 10;
const int N = 1000;
const int add = 500;

bool isBit(int n, int i) {
    return (n >> i) & 1;
}

bool check(int mask) {
    vector <int> take;
    for (int i = 0; i < L; i++) {
        if (isBit(mask, i)) {
            take.push_back(-(1 << (L - i - 1)));
        }
    }
    for (int i = L; i < (2 * L); i++) {
        if (isBit(mask, i)) {
            take.push_back(1 << (i - L));
        }
    }
    bitset <N> ans;
    ans[add] = 1;
    for (auto u : take) {
        if (u > 0) ans |= ans << u;
        else ans |= ans >> (-u);
    }
    for (int i = 0; i < n; i++) {
        if (!ans[a[i] + add]) {
            return false;
        }
    }
    return true;
}



void write(int mask) {
    vector <int> take;
    for (int i = 0; i < L; i++) {
        if (isBit(mask, i)) {
            take.push_back(-(1 << (L - i - 1)));
        }
    }
    for (int i = L; i < (2 * L); i++) {
        if (isBit(mask, i)) {
            take.push_back(1 << (i - L));
        }
    }
    cout << take.size() << '\n';
    for (auto u : take) {
        cout << u << ' ';
    }
}

int cnt(int mask) {
    if (mask == -1) {
        return 1000;
    }
    int res = 0;
    for (int i = 0; i < 2 * L; i++) {
        res += isBit(mask, i);
    }
    return res;
}

bool used[(1 << (2 * L))];

int main() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = -1;
    for (int mask = (1 << (2 * L)); mask >= 0 ; mask--) {
        if (used[mask]) {
            continue;
        }
        if (check(mask)) {
            if (cnt(mask) < cnt(ans)) {
                ans = mask;
            }
        }
        else {
            int submask = mask;
            while (submask > 0) {
                used[submask] = true;
                submask = mask & (submask - 1);
            }
        }
    }
    write(ans);
    return 0;
}