#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

int ctr = 0;

void dfs(int v, vector<int> &used, vector<vector<int>> &g) {
    ctr++;
    used[v] = 1;
    for (auto &to : g[v]) {
        if (!used[to]) {
            dfs(to, used, g);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    for (int &i : u) {
        cin >> i;
    }

    vector<vector<int>> g(n);
    while (m--) {
        int c1, c2;
        cin >> c1 >> c2;
        --c1, --c2;
        if ((u[c2] + 1) % h == u[c1]) {
            g[c2].push_back(c1);
        }
        if ((u[c1] + 1) % h == u[c2]) {
            g[c1].push_back(c2);
        }
    }

    int ans = n, id = 0;
    for (int i = 0; i < n; ++i) {
        vector<int> used(n, 0);
        ctr = 0;
        dfs(i, used, g);
        if (ans > ctr) {
            ans = ctr;
            id = i;
        }
    }

    //cout << id << '\n';
    vector<int> used(n, 0);
    dfs(id, used, g);
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            cout << i + 1 << ' ';
        }
    }
    return 0;
}

/*
 3 3 5
 4 4 0
 1 3
 3 2
 3 1

 4 5 4
 2 1 0 3
 4 3
 3 2
 1 2
 1 4
 1 3
 */
