#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

int ctr = 0;
int cmp_num = 0;
vector<int> order, currcomp, compof;

void dfs(int v, vector<int> &used, vector<vector<int>> &g) {
    used[v] = 1;
    for (auto &to : g[v]) {
        if (!used[to]) {
            dfs(to, used, g);
        }
    }
    order.push_back(v);
}

void dfs2(int v, vector<int> &used, vector<vector<int>> &rg) {
    used[v] = 1;
    currcomp.push_back(v);
    compof[v] = cmp_num;
    for (auto &to : rg[v]) {
        if (!used[to]) {
            dfs2(to, used, rg);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    for (int &i : u) {
        cin >> i;
    }

    vector<vector<int>> g(n), rg(n);
    while (m--) {
        int c1, c2;
        cin >> c1 >> c2;
        --c1, --c2;
        if ((u[c2] + 1) % h == u[c1]) {
            g[c2].push_back(c1);
            rg[c1].push_back(c2);
        }
        if ((u[c1] + 1) % h == u[c2]) {
            g[c1].push_back(c2);
            rg[c2].push_back(c1);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (g[i].empty()) {
            cout << "1\n" << i + 1;
            return 0;
        }
    }

    vector<int> used(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, used, g);
        }
    }

    compof.assign(n, 0);
    vector<vector<int>> comps;
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        int v = order[n - 1 - i];
        if (!used[v]) {
            dfs2(v, used, rg);
            comps.push_back(currcomp);
            ++cmp_num;
            currcomp.clear();
        }
    }

    int ans = n;
    int id = 0;
    for (int i = 0; i < comps.size(); ++i) {
        bool fl = 1;
        for (int j = 0; fl && j < comps[i].size(); ++j) {
            for (int &to : g[j]) {
                if (compof[to] != compof[j]) {
                    fl = false;
                    break;
                }
            }
        }
        if (fl) {
            if (ans > comps[i].size()) {
                ans = comps[i].size();
                id = i;
            }
        }
    }

    cout << ans << '\n';
    for (int &i : comps[id]) {
        cout << i + 1 << ' ';
    }
    return 0;
}

/*
 3 3 5
 4 4 0
 1 3
 3 2
 3 1

 4 5 4
 2 1 0 3
 4 3
 3 2
 1 2
 1 4
 1 3
 */
