#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

int n, m, h;
vector<int> *g;
int *upd;

vector<bool> used;

void dfs(int node, list<int> &st) {
    if (used[node])return;
    used[node] = true;
    st.push_back(node);
    for (auto j : g[node])dfs(j, st);
}

int __main() {
    ios::sync_with_stdio(false);
    cin.tie();

    cin >> n >> m >> h;
    g = new vector<int>[n];
    upd = new int[n];
    for (int i = 0; i < n; i++)cin >> upd[i];
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((upd[a] + 1) % h == upd[b])
            g[a].push_back(b);
        if ((upd[b] + 1) % h == upd[a])
            g[b].push_back(a);
    }

    //check for no cycles
    for (int i = 0; i < n; i++) {
        if (g[i].size() == 0) {
            cout << "1\n" << (i + 1);
            return 0;
        }
    }

    //find smallest cycle;
    used = vector<bool>(n, false);
    vector<list<int> *> cycles;
    for (int i = 0; i < n; i++) {
        if (used[i])continue;
        list<int> *l = new list<int>;
        dfs(i, *l);
        cycles.push_back(l);
    }
    
    list<int> *best = cycles[0];
    for (auto &p : cycles) {
        if (p->size() < best->size())best = p;
    }

    cout << best->size() << endl;
    for (auto i : *best) {
        cout << (i+1) << " ";
    }

    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}