#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

int n, m, h;
vector<int> *g,*gt;
int *upd;

vector<bool> used;

void dfs(int node,list<int> &a) {
    if (used[node])return;
    a.push_back(node);
    used[node] = true;
    for (auto j : g[node])dfs(j, a);
}

int __main() {
    ios::sync_with_stdio(false);
    cin.tie();

    cin >> n >> m >> h;
    g = new vector<int>[n];
    gt = new vector<int>[n];
    upd = new int[n];
    for (int i = 0; i < n; i++)cin >> upd[i];
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((upd[a] + 1) % h == upd[b]){
            g[a].push_back(b);
            gt[b].push_back(a);
        }
            
        if ((upd[b] + 1) % h == upd[a]) {
            g[b].push_back(a);
            gt[a].push_back(b);
        }
            
    }

    int size = INT32_MAX;
    list<int> *res = {};
    for (int i = 0; i < n; i++) {
        used = vector<bool>(n, false);
        list<int> *l = new list<int>();
        dfs(i, *l);
        if (l->size() < size) {
            size = l->size();
            res = l;
        }
    }
    cout << size << endl;
    for (auto j : *res)cout << (j + 1) << " ";
    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}