#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

int n, m, h;
vector<int> *g, *gt;
int *upd;

vector<bool> used;
vector<int> s;

void dfs(int node) {
    if (used[node])return;
    used[node] = true;
    for (auto j : g[node])dfs(j);
    s.push_back(node);
}

void dfs1(int node, list<int> &comp) {
    if (used[node])return;
    used[node] = true;
    comp.push_back(node);
    for (auto j : gt[node])dfs1(j, comp);

}
int *con;
int __main() {
    ios::sync_with_stdio(false);
    cin.tie();

    cin >> n >> m >> h;
    g = new vector<int>[n];
    gt = new vector<int>[n];
    upd = new int[n];
    for (int i = 0; i < n; i++)cin >> upd[i];
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((upd[a] + 1) % h == upd[b]) {
            g[a].push_back(b);
            gt[b].push_back(a);
        }

        if ((upd[b] + 1) % h == upd[a]) {
            g[b].push_back(a);
            gt[a].push_back(b);
        }

    }

    used = vector<bool>(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i])dfs(i);
    }
    reverse(s.begin(), s.end());

    used = vector<bool>(n, false);
    con = new int[n];
    vector<list<int> *> comps;
    for (auto i : s) {
        if (used[i])continue;
        list<int> *l = new list<int>();
        dfs1(i, *l);
        comps.push_back(l);
        for (auto p : *l)con[p] = comps.size() - 1;
    }

    vector<bool> ok(comps.size(), true);
    for (int i = 0; i < n; i++) {
        for (auto j : g[i]) {
            if (con[i] != con[j])ok[con[i]] = false;
        }
    }

    vector<list<int> *> comps1;
    for (int i = 0; i < comps.size(); i++) {
        if (ok[i])comps1.push_back(comps[i]);
    }
    list<int> *best = comps1[0];
    for (auto &a : comps1) {
        if (a->size() < best->size())best = a;
    }

    cout << best->size() << endl;
    for (auto j : *best) {
        cout << (j + 1) << " ";
    }

    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}