#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>
#include <map>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

int *p;
void print(int val, int count) {
    if (p[val] == -1) {
        cout << count << " " << (val+1);
        return;
    }
    print(p[val], count + 1);
    cout << " " << (val+1);
}
#define endl '\n'
int __main() {
    ios::sync_with_stdio(false);
    cin.tie();

    string s;
    cin >> s;
    stack<int> ones, zeros;
    int n = s.size();
    p = new int[n];
    for (int i = 0; i < n; i++) {
        char c = s[i];
        if (c == '1') {
            if (zeros.empty()) {
                cout << -1; return 0;
            }
            p[i] = zeros.top();
            zeros.pop();
            ones.push(i);
        }

        if (c == '0') {
            if (!ones.empty()) { p[i] = ones.top(); ones.pop(); }
            else p[i] = -1;
            zeros.push(i);       
        }
    }

    if (!ones.empty()) { cout << -1; return 0; }
    cout << zeros.size() << endl;
    while (!zeros.empty()) {
        int l = zeros.top();
        zeros.pop();
        print(l, 1);
        cout << endl;
    }

    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}