#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
using namespace std;
#define int long long
#define INF 1791791791
struct node
{
    int x = 0;
    node *left = nullptr, *right = nullptr;
    int l, r;
    node(int l, int r) : l(l), r(r)
    {
        if (r - l > 1) {
            int m = (l + r) / 2;
            left = new node(l, m);
            right = new node(m, r);
        }
    }
};

int dfs(int x, vector<set<int>> & g, vector<int> & vis)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y])
            c += dfs(y, g, vis);
    }
    vis[x] = 2;
    return c;
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
        swap(x, y);
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
    }
    vector<vector<int>> vis(n, vector<int>(n));
    int mv = n + 1;
    int ans;
    for (int i = 0; i < n; ++i) {
        int c = dfs(i, g, vis[i]);
        if (c < mv) {
            mv = c;
            ans = i;
        }
    }
    cout << mv << '\n';
    for (int i = 0; i < n; ++i)
        if (vis[ans][i])
            cout << i + 1 << ' ';
}

