#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
using namespace std;
#define int long long
#define INF 1791791791
struct node
{
    int x = 0;
    node *left = nullptr, *right = nullptr;
    int l, r;
    node(int l, int r) : l(l), r(r)
    {
        if (r - l > 1) {
            int m = (l + r) / 2;
            left = new node(l, m);
            right = new node(m, r);
        }
    }
    int query(int L, int R) {
        if (L >= r || R <= l)
            return 0;
        if (L <= l && r <= R)
            return x;
        return left->query(L, R) + right->query(L, R);
    }
    void update(int i, int y) {
        if (r - l > 1) {
            int m = (l + r) / 2;
            if (i < m)
                left->update(i, y);
            else
                right->update(i, y);
            x = left->x + right->x;
        }
        else
            x = y;
    }
};

int dfs(int x, vector<set<int>> & g, vector<int> & vis)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y])
            c += dfs(y, g, vis);
    }
    vis[x] = 2;
    return c;
}

int dfs2(int x, vector<set<int>> & g, vector<int> & vis, vector<int> & valid, vector<int> & cnt, vector<int> & h)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y]) {
            h[y] = h[x] + 1;
            c += dfs2(y, g, vis, valid, cnt, h);
        }
        else if (vis[y] == 1) {
            valid[x] = min(valid[x], valid[y]);
        }
    }
    vis[x] = 2;
    return c;
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
    /*int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
        swap(x, y);
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
    }
    vector<vector<int>> vis(n, vector<int>(n));
    int mv = n + 1;
    int ans;
    for (int i = 0; i < n; ++i) {
        int c = dfs(i, g, vis[i]);
        if (c < mv) {
            mv = c;
            ans = i;
        }
    }
    cout << mv << '\n';
    for (int i = 0; i < n; ++i)
        if (vis[ans][i])
            cout << i + 1 << ' ';*/
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int j1 = 0, j2 = n - 1;
        node root(0, n);
        for (int i = 0; i < n; ++i)
            root.update(i, a[i]);
        int i = 0;
        int c1 = 0, c2 = 0;
        while (p == 1 && i < n || p == 2 && i < (n + 1) / 2) {
            if (p == 1 || c1 + (n + 1) / 2 - i > m) {
                if (root.query(0, i + (i + 1) * d + 1) < b) {
                    ++c1;
                }
                else {
                    int k = b;
                    while (k) {
                        int x = root.query(j1, j1 + 1);
                        if (k >= x) {
                            k -= x;
                            root.update(j1, 0);
                            ++j1;
                        }
                        else {
                            x -= k;
                            root.update(j1, x);
                            k = 0;
                        }
                    }
                }
            }
            if (p == 2 && c2 + n / 2 - i > m && i < n / 2) {
                if (root.query(n - 1 - i - (i + 1) * d, n) < b) {
                    ++c2;
                }
                else {
                    int k = b;
                    while (k) {
                        int x = root.query(j2, j2 + 1);
                        if (k >= x) {
                            k -= x;
                            root.update(j2, 0);
                            --j2;
                        }
                        else {
                            x -= k;
                            root.update(j2, x);
                            k = 0;
                        }
                    }
                }
            }
            ++i;
        }
        if (c1 <= m && c2 <= m)
            r = m;
        else
            l = m;
    }
    cout << r;
}

