#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
#include <bitset>
using namespace std;
#define int long long
#define INF 1791791791
struct node
{
    int x = 0;
    node *left = nullptr, *right = nullptr;
    int l, r;
    node(int l, int r) : l(l), r(r)
    {
        if (r - l > 1) {
            int m = (l + r) / 2;
            left = new node(l, m);
            right = new node(m, r);
        }
    }
    int query(int L, int R) {
        if (L >= r || R <= l)
            return 0;
        if (L <= l && r <= R)
            return x;
        return left->query(L, R) + right->query(L, R);
    }
    void update(int i, int y) {
        if (r - l > 1) {
            int m = (l + r) / 2;
            if (i < m)
                left->update(i, y);
            else
                right->update(i, y);
            x = left->x + right->x;
        }
        else
            x = y;
    }
};

int dfs(int x, vector<set<int>> & g, vector<int> & vis)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y])
            c += dfs(y, g, vis);
    }
    vis[x] = 2;
    return c;
}

int dfs2(int x, vector<set<int>> & g, vector<int> & vis, vector<int> & valid, vector<int> & cnt, vector<int> & h)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y]) {
            h[y] = h[x] + 1;
            c += dfs2(y, g, vis, valid, cnt, h);
        }
        else if (vis[y] == 1) {
            valid[x] = min(valid[x], valid[y]);
        }
    }
    vis[x] = 2;
    return c;
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
    /*int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
        swap(x, y);
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
    }
    vector<vector<int>> vis(n, vector<int>(n));
    int mv = n + 1;
    int ans;
    for (int i = 0; i < n; ++i) {
        int c = dfs(i, g, vis[i]);
        if (c < mv) {
            mv = c;
            ans = i;
        }
    }
    cout << mv << '\n';
    for (int i = 0; i < n; ++i)
        if (vis[ans][i])
            cout << i + 1 << ' ';*/
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int r = -1;
    int mask;
    for (int i = 0; i < (1 << 14); ++i) {
        set<int> nums;
        nums.insert(0);
        for (int j = i; j > 0; j = (j - 1) & i) {
            int s = 0;
            for (int i = 0; i < 14; ++i) {
                if (j & (1 << i)) {
                    if (i < 7)
                        s += (1 << (i));
                    else
                        s -= (1 << (i - 7));
                }
            }
            nums.insert(s);
        }
        bool can = true;
        for (int i = 0; i < n && can; ++i)
            if (!nums.count(a[i]))
                can = false;
        if (can && (r == -1 || bitset<64>(i).count() < r)) {
            r = bitset<64>(i).count();
            mask = i;
        }
    }
    cout << r << '\n';
    for (int i = 0; i < 14; ++i) {
        if (mask & (1 << i)) {
            if (i < 7)
                cout << (1 << (i)) << ' ';
            else
                cout << -(1 << (i - 7)) << ' ';
        }
    }
}

