#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cmath>

using namespace std;

vector<int> used, cnt;
vector<set<int>> g;
vector<int> clr;
int ans, temp, ts, te;
int ansstart, ansend;

	vector<int> p;
	int get(int v)
	{
		if (v != p[v])
		{
			v = get(p[v]);
		}
		return p[v];
	}
	void join(int v, int u)
	{
		u = get(u);
		v = get(v);
		p[u] = v;
	}


void dfs(int v, int c)
{
	used[v] = c;
	join(c, v);
	for (auto i : g[v])
	{
		if (!used[i])
		{
			dfs(i, c);
		}
		else
		{
			join(c, i);
		}
	}
}

int main()
{
	int n = 0, m = 0, h = 0;
	cin >> n >> m >> h;
	vector<set<int>> v(n), tm(h);
	vector<int> t(n);
	g.resize(n);
	used.resize(n, 0);
	clr.resize(n + 1, 0);
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (int i = 0; i < m; i++)
	{
		int a = 0, b = 0;
		cin >> a >> b;
		v[a - 1].insert(i);
		v[b - 1].insert(i);
		tm[t[a - 1]].insert(i);
		tm[t[b - 1]].insert(i);
		if ((t[a - 1] + 1) % h == t[b - 1])
		{
			g[a - 1].insert(b - 1);
		}
		if ((t[b - 1] + 1) % h == t[a - 1])
		{
			g[b - 1].insert(a - 1);
		}
	}
	// for (int i = 0; i < n; i++)
	// {
	// 	cerr << i << " ";
	// 	for (auto j : g[i])
	// 	{
	// 		cerr << j << " ";
	// 	}
	// 	cerr << endl;
	// }
	p.resize(n);
	for (int i = 0; i < n; i++)
	{
		p[i] = i;
	}
	for (int i = 0; i < n; i++)
	{
		bool good = true;
		for (auto j : v[i])
		{
			if (tm[(t[i] + 1) % h].count(j))
			{
				good = false;
			}
		}
		if (good)
		{
			cout << 1 << endl << i + 1 << endl;
			return 0;
		}
	}
	map<int ,int> col;
	//join(0, 1);
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(i, i + 1);
		}
	}
	for (int i = 0; i < n; i++)
	{
		//cerr << get(i) << " ";
		col[get(i)]++;
	}
	//cerr << endl;

	int bestcol = col.begin()->first;
	cout << col.begin()->second << endl;
	for (int i = 0; i < n; i++)
	{
		if (get(i) == bestcol)
		{
			cout << i + 1 << " ";
		}
	}
	cout << endl;
	return 0;
}