#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

vector<set<int>> g;
vector<int> p;
vector<int> used;

int get(int v)
{
	if (p[v] != v)
	{
		v = get(p[v]);
	}
	return p[v];
}

void join(int v, int u)
{
	v = get(v);
	u = get(u);
	p[u] = v;
}

void dfs(int v)
{
	used[v] = 1;
	for (auto i : g[v])
	{
		if (used[i] == -1)
		{
			dfs(i);
			join(v, i);
		}
		
	}
}

int main()
{
	int n = 0, m = 0, h = 0;
	cin >> n >> m >> h;
	vector<int> t(n);
	g.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (int i = 0; i < m; i++)
	{
		int a = 0, b =0;
		cin >> a >> b;
		if ((t[a - 1] + 1) % h == t[b - 1])
		{
			g[a - 1].insert(b - 1);
		}
		if ((t[b - 1] + 1) % h == t[a - 1])
		{
			g[b - 1].insert(a - 1);
		}
	}
	used.resize(n, -1);
	p.resize(n);
	for (int i = 0; i < n; i++)
	{
		p[i] = i;
	}
	for (int i = 0; i < n; i++)
	{
		if (g[i].empty())
		{
			cout << 1 << endl << i + 1 << endl;
			return 0;
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (used[i] == -1)
		{
			dfs(i);
		}
	}
	map<int, int> clr;
	for (int i = 0; i < n; i++)
	{
		clr[get(i)]++;
	}
	int bestlr = -1, bestcnt = n + 100;
	// for (int i = 0; i < n; i++)
	// {
	// 	cerr << i << ' ' << get(i) << endl;
	// }
	for (auto i : clr)
	{
		if (i.second < bestcnt)
		{
			bestcnt = i.second;
			bestlr = i.first;
		}
	}
	cout << bestcnt << endl;
	for (int i = 0; i < n; i++)
	{
		if (get(i) == bestlr)
		{
			cout << i  + 1 << " ";
		}
	}
	cout << endl;
}