#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;


const int LG = 18;
const int N = 1 << LG;
struct it
{
	int t[2 * N], psh[2 * N];
	it()
	{
		fill(t, t + 2 * N, 0);
		fill(psh, psh + 2 * N, 0);
	}
	void push(int x)
	{
		for (int i = LG; i > 0; --i)
		{
			int u = x >> i;
			if (psh[u])
			{
				psh[2 * u] += psh[u];
				t[2 * u] += psh[u];
				psh[2 * u + 1] += psh[u];
				t[2 * u + 1] += psh[u]; // change in case of sum queries
				psh[u] = 0;
			}
		}
	}
	void update(int x)
	{
		push(x);
		while (x > 1)
			t[x >> 1] = max(t[x], t[x ^ 1]), x >>= 1;
	}
	void add(int l, int r, int x)
	{
		l += N;
		r += N;
		int l1 = l, r1 = r;
		while (l < r)
		{
			if (l & 1)
			{
				t[l] += x;
				psh[l] += x;
				++l;
			}
			if (r & 1)
			{
				t[r - 1] += x;
				psh[r - 1] += x;
				--r;
			}
			l >>= 1, r >>= 1;
		}
		update(l1);
		update(r1 - 1);
	}
	int get(int l, int r)
	{
		l += N;
		r += N;
		push(l);
		push(r - 1);
		int ans = 0;
		while (l < r)
		{
			if (l & 1)
				ans = max(ans, t[l++]);
			if (r & 1)
				ans = max(ans, t[--r]);
			l >>= 1, r >>= 1;
		}
		return ans;
	}

};

vector<vector<int>> g;
vector<bool> used;
vector<int> cur;
void d(int u)
{
	if (used[u])
		return;
	used[u] = true;
	cur.push_back(u);
	for (int v : g[u])
		d(v);
}

int main()
{
	ios::sync_with_stdio(false);
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> u(n);
	for (auto& x : u)
		cin >> x;
	g.resize(n);
	auto kek = [&](int x)
	{
		return x + 1 == h ? 0 : x + 1;
	};
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		--a, --b;
		if (kek(u[a]) == u[b])
			g[a].push_back(b);
		if (kek(u[b]) == u[a])
			g[b].push_back(a);
	}
	used.resize(n);
	for (int i = 0; i < n; ++i)
	{
		if (g[i].size() == 0)
		{
			cout << 1 << '\n' << i + 1 << '\n';
			return 0;
		}
	}
	vector<int> ans;
	for (int i = 0; i < n; ++i)
	{
		if (!used[i])
		{
			cur.clear();
			d(i);
			if (ans.empty() || cur.size() < ans.size())
				ans = cur;
		}
	}
	cout << ans.size() << '\n';
	for (auto& x : ans)
		cout << x + 1 << ' ';
	cout << '\n';
	return 0;

}