#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;


const int LG = 18;
const int N = 1 << LG;
struct it
{
	int t[2 * N], psh[2 * N];
	it()
	{
		fill(t, t + 2 * N, 0);
		fill(psh, psh + 2 * N, 0);
	}
	void push(int x)
	{
		for (int i = LG; i > 0; --i)
		{
			int u = x >> i;
			if (psh[u])
			{
				psh[2 * u] += psh[u];
				t[2 * u] += psh[u];
				psh[2 * u + 1] += psh[u];
				t[2 * u + 1] += psh[u]; // change in case of sum queries
				psh[u] = 0;
			}
		}
	}
	void update(int x)
	{
		push(x);
		while (x > 1)
			t[x >> 1] = max(t[x], t[x ^ 1]), x >>= 1;
	}
	void add(int l, int r, int x)
	{
		l += N;
		r += N;
		int l1 = l, r1 = r;
		while (l < r)
		{
			if (l & 1)
			{
				t[l] += x;
				psh[l] += x;
				++l;
			}
			if (r & 1)
			{
				t[r - 1] += x;
				psh[r - 1] += x;
				--r;
			}
			l >>= 1, r >>= 1;
		}
		update(l1);
		update(r1 - 1);
	}
	int get(int l, int r)
	{
		l += N;
		r += N;
		push(l);
		push(r - 1);
		int ans = 0;
		while (l < r)
		{
			if (l & 1)
				ans = max(ans, t[l++]);
			if (r & 1)
				ans = max(ans, t[--r]);
			l >>= 1, r >>= 1;
		}
		return ans;
	}

};

typedef long long nagai;

int main()
{
	ios::sync_with_stdio(false);
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector<nagai> a(n);
	for (auto& x : a)
		cin >> x;
	if (p == 1)
	{
		int L = -1, R = n;
		while (R - L > 1)
		{
			int M = (L + R) / 2;
			vector<nagai> a1 = a;
			for (int i = 0; i < M; ++i)
				a[M] += a[i];
			int cur = M;
			bool ok = true;
			for (int i = M; i < n; ++i)
			{
				nagai time = i + 1;
				if (a[i] >= b)
					a[i] -= b;
				else
				{
					nagai rest = b - a[i];
					a[i] = 0;
					while (rest)
					{
						while (cur < i)
							++cur;
						if (cur >= n || cur - time * d > i)
						{
							ok = false;
							break;
						}
						nagai mem = min(a[cur], rest);
						a[cur] -= mem;
						rest -= mem;
						if (a[cur] == 0)
							++cur;
					}
				}
				if (i + 1 < n)
					a[i + 1] += a[i], a[i] = 0;
			}
			if (ok)
				R = M;
			else
				L = M;
			a = a1;
		}
		cout << R << '\n';
	}
	else
	{
		int L = -1, R = n;

		while (R - L > 1)
		{
			int M = (L + R) / 2;
			auto a1 = a; 
			int to = n - M;
			int cur = 0;
			bool ok = true;
			int last1 = (n - 1) / 2;
			for (int i = M; i <= last1; ++i)
			{
				nagai time = i + 1;
				if (a[i] >= b)
					a[i] -= b;
				else
				{
					nagai rest = b - a[i];
					a[i] = 0;
					while (rest)
					{
						if (cur >= n || cur - time * d > i)
						{
							ok = false;
							break;
						}
						nagai mem = min(a[cur], rest);
						a[cur] -= mem;
						rest -= mem;
						if (a[cur] == 0)
							++cur;
					}
				}

			}
			for (int i = to; i < n; ++i)
				a[to - 1] += a[i];
			cur = to - 1;
			for (int i = to - 1; i > last1; --i)
			{
				nagai time = (n - i);
				if (a[i] >= b)
					a[i] -= b;
				else
				{
					nagai rest = b - a[i];
					a[i] = 0;
					while (rest)
					{
						if (cur < 0 || cur + time * d < i)
						{
							ok = false;
							break;
						}
						nagai mem = min(a[cur], rest);
						a[cur] -= mem;
						rest -= mem;
						if (a[cur] == 0)
							--cur;
					}
				}
			}
			if (ok)
				R = M;
			else
				L = M;
			a = a1;
		}
		cout << R << '\n';
	}
	system("pause");
	
	return 0;
}