#include <vector>
#include <iostream>
#include <string>
#include <algorithm>

using namespace std;


const int LG = 18;
const int N = 1 << LG;
struct it
{
	int t[2 * N], psh[2 * N];
	it()
	{
		fill(t, t + 2 * N, 0);
		fill(psh, psh + 2 * N, 0);
	}
	void push(int x)
	{
		for (int i = LG; i > 0; --i)
		{
			int u = x >> i;
			if (psh[u])
			{
				psh[2 * u] += psh[u];
				t[2 * u] += psh[u];
				psh[2 * u + 1] += psh[u];
				t[2 * u + 1] += psh[u]; // change in case of sum queries
				psh[u] = 0;
			}
		}
	}
	void update(int x)
	{
		push(x);
		while (x > 1)
			t[x >> 1] = max(t[x], t[x ^ 1]), x >>= 1;
	}
	void add(int l, int r, int x)
	{
		l += N;
		r += N;
		int l1 = l, r1 = r;
		while (l < r)
		{
			if (l & 1)
			{
				t[l] += x;
				psh[l] += x;
				++l;
			}
			if (r & 1)
			{
				t[r - 1] += x;
				psh[r - 1] += x;
				--r;
			}
			l >>= 1, r >>= 1;
		}
		update(l1);
		update(r1 - 1);
	}
	int get(int l, int r)
	{
		l += N;
		r += N;
		push(l);
		push(r - 1);
		int ans = 0;
		while (l < r)
		{
			if (l & 1)
				ans = max(ans, t[l++]);
			if (r & 1)
				ans = max(ans, t[--r]);
			l >>= 1, r >>= 1;
		}
		return ans;
	}

};


#include <set>

void fail()
{
	cout << -1 << '\n';
	exit(0);
}
int main()
{
	ios::sync_with_stdio(false);
	string s;
	cin >> s;
	vector<vector<int>> ans;
	set<int> zer, ones;
	for (int i = 0; i < s.size(); ++i)
		if (s[i] == '0')
			zer.insert(i);
		else
			ones.insert(i);
	while (ones.size())
	{
		auto kek = *ones.begin();
		auto beg = zer.lower_bound(kek);
		if (beg == zer.begin())
			fail();
		--beg;
		int b = *beg;
		vector<int> ansich;
		ansich.push_back(b);
		ansich.push_back(kek);
		++beg;
		if (beg == zer.end())
			fail();
		int e = *beg;
		ansich.push_back(e);
		ones.erase(kek);
		zer.erase(b);
		zer.erase(e);
		while (true)
		{
			auto mem = ones.lower_bound(e);
			if (mem == ones.end())
				break;
			int o = *mem;
			auto kek = zer.lower_bound(o);
			if (kek == zer.end())
				break;
			ansich.push_back(o);
			ansich.push_back(*kek);
			e = *kek;
			ones.erase(o);
			zer.erase(e);
		}
		ans.push_back(ansich);
	}
	for (int x : zer)
		ans.push_back({x});
	cout << ans.size() << '\n';
	for (auto& x : ans)
	{
		cout << x.size() << ' ';
		for (auto& y : x)
			cout << y + 1 << ' ';
		cout << '\n';
	}
	system("pause");
	return 0;
}