#include<iostream>
#include <vector>
#include <numeric>

using namespace std;

typedef long long ll;

template <typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) {
        out << x << "\n";
    }
    return out;
}

int main() {
    ll p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<ll> a(n);
    cin >> a;
    vector<ll> ps(n + 1, 0);
    partial_sum(a.begin(), a.end(), ps.begin() + 1);
    auto get = [&](ll l, ll r) {
        return ps[r + 1] - ps[l];
    };
    if (p == 1) {
        ll ost = 0;
        ll ans = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i] + ost >= b) {
                ost += a[i] - b;
            } else {
                ll here = ost + get(i, min(n - 1, i + (i + 1) * d));
                if (here >= b) {
                    ost = ost + a[i] - b;
                } else {
                    ++ans;
                    ost += a[i];
                }
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
/*
 1 5 3 1
 0 0 0 5 0

 1 5 3 10
 5 1 1 1 42

 2 5 1 1
 1 0 0 0 4
 2 6 1 2
 3 8 0 1 0 0
 */