#include<iostream>
#include <vector>
#include <numeric>
#include <set>

using namespace std;

typedef long long ll;

template <typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) {
        out << x << "\n";
    }
    return out;
}

int main() {
    ll p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<ll> a(n);
    cin >> a;
    vector<ll> ps(n + 1, 0);
    partial_sum(a.begin(), a.end(), ps.begin() + 1);
    auto get = [&](ll l, ll r) {
        return ps[r + 1] - ps[l];
    };
    if (p == 1) {
        ll ost = 0;
        ll ans = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i] + ost >= b) {
                ost += a[i] - b;
            } else {
                ll here = ost + get(i, min(n - 1, i + (i + 1) * d));
                if (here >= b) {
                    ost = ost + a[i] - b;
                } else {
                    ++ans;
                    ost += a[i];
                }
            }
        }
        cout << ans << "\n";
    } else {
        vector<set<int>> can(n);
        for (int i = 0; i < n; ++i) {
            ll l = -1, r = i;
            while (l < r - 1) {
                ll m = (l + r) / 2;
                if (m + (m + 1) * d >= i) {
                    r = m;
                } else {
                    l = m;
                }
            }
            can[r].insert(i);
        }
        auto check = [&](ll lt, ll rt) {
            set<pair<ll, ll>> nl, nr;
            for (ll ptr1 = 0, ptr2 = 0; ptr1 < (n + 1) / 2; ptr1++, ptr2++) {
                for (auto to : can[ptr1]) {
                    if (a[to]) nl.insert({to, a[to]});
                }
                for (auto to : can[ptr2]) {
                    if (a[n - 1 - to]) nr.insert({to, a[n - 1 - to]});
                }
                if (ptr1 >= lt) {
                    ll need = b;
                    while (need) {
                        if (nl.empty()) return false;
                        auto f = *nl.begin();
                        nl.erase(nl.begin());
                        bool ins = nr.find({n - 1 - f.first, f.second}) != nr.end();
                        if (ins) {
                            nr.erase({n - 1 - f.first, f.second});
                        }
                        ll db = min(f.second, need);
                        f.second -= db;
                        need -= db;
                        if (f.second) {
                            nl.insert(f);
                            if (ins) {
                                nr.insert({n - 1 - f.first, f.second});
                            }
                        }
                    }
                }
                if (ptr2 >= rt) {
                    ll need = b;
                    while (need) {
                        if (nr.empty()) return false;
                        auto f = *nr.begin();
                        nr.erase(nr.begin());
                        bool ins = nl.find({n - 1 - f.first, f.second}) != nl.end();
                        if (ins) {
                            nl.erase({n - 1 - f.first, f.second});
                        }
                        ll db = min(f.second, need);
                        f.second -= db;
                        need -= db;
                        if (f.second) {
                            nr.insert(f);
                            if (ins) {
                                nl.insert({n - 1 - f.first, f.second});
                            }
                        }
                    }
                }
            }
            return true;
        };
        ll ans = n + 1;
        for (ll lt = 0; lt < (n + 1) / 2; ++lt) {
//            for (ll rt = 0; rt < (n + 1) / 2; ++rt) {
            ll rt = lt;
                if (check(lt, rt)) {
                    ans = min(ans, max(lt, rt));
                }
//            }
        }
        cout << ans << "\n";
    }
    return 0;
}
/*
 1 5 3 1
 0 0 0 5 0

 1 5 3 10
 5 1 1 1 42

 2 5 1 1
 1 0 0 0 4

 2 6 1 2
 3 8 0 1 0 0
 */