#include<iostream>
#include <vector>
#include <cmath>
#include <queue>
#include <algorithm>

using namespace std;

typedef long long ll;

template <typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) {
        out << x << "\n";
    }
    return out;
}

int MAXLOG = 0;
int here[23];

bool badCheck(int n, ll mask) {
    int cnt = 0;
    for (int i = 0; i < 2 * MAXLOG; ++i) {
        if ((mask >> i) & 1) {
            here[cnt++] = i;
        }
    }
    for (ll m = 0; m < (1 << cnt); ++m) {
        ll here1 = 0;
        for (int i = 0; i < cnt; ++i) {
            if ((m >> i) & 1) {
                if (here[i] >= MAXLOG) {
                    here1 -= 1 << here[i] - MAXLOG;
                } else {
                    here1 += 1 << here[i];
                }
            }
        }
        if (here1 == n) return true;
    }
    return false;
}

ll st3[23];

bool badCheck3(int n, ll mask) {
    int mask3[MAXLOG];
    for (int i = 0; i < MAXLOG; ++i) {
        mask3[i] = mask % 3;
        mask /= 3;
    }
    int cnt = 0;
    int here[21];
    for (int i = 0; i < MAXLOG; ++i) {
        if (mask3[i]) {
            here[cnt++] = i;
        }
    }
    for (ll m = 0; m < (1 << cnt); ++m) {
        ll here1 = 0;
        for (int i = 0; i < cnt; ++i) {
            if ((m >> i) & 1) {
                if (mask3[here[i]] == 1) {
                    here1 -= 1 << here[i];
                } else {
                    here1 += 1 << here[i];
                }
            }
        }
        if (here1 == n) return true;
    }
    return false;
}

bool check3(int n, ll mask) {
    int mask3[MAXLOG];
    for (int i = 0; i < MAXLOG; ++i) {
        mask3[i] = mask % 3;
        mask /= 3;
    }
    if (n < 0) {
        n = -n;
        for (int i = 0; i < MAXLOG; ++i) {
            if (mask3[i]) {
                mask3[i] = 3 - mask3[i];
            }
        }
    }
//    int ptr1 = MAXLOG - 1, ptr2 = MAXLOG - 1;
    ll now = 0;
    ll stHere = 1 << MAXLOG - 1;
//    ll stPtr1 = 1 << MAXLOG - 1, stPtr2 = 1 << MAXLOG - 1;
    for (int i = MAXLOG - 1; i >= 0; --i, stHere /= 2) {
//        while (ptr1 >= 0 && mask3[ptr1] != 1) {
//            --ptr1;
//            stPtr1 >>= 1;
//        }
//        while (ptr2 >= 0 && mask3[ptr2] != 2) {
//            --ptr2;
//            stPtr2 >>= 1;
//        }
        if (((now >> i) & 1) != ((n >> i) & 1)) {
            if (!((now >> i) & 1)) {
                ll ptr1 = i;
                while (ptr1 >= 0 && mask3[ptr1] != 1) {
                    --ptr1;
                }
                if (mask3[i + 1] == 2 && ptr1 >= 0) {
                    ll stPtr1 = 1LL << ptr1;
                    mask3[i + 1] = 1;
                    mask3[ptr1] = 2;
//                    ptr2 = max(ptr2, ptr1);
//                    stPtr2 = 1LL << ptr2;
                    now += stHere << 1;
                    now -= stPtr1;
                } else if (mask3[i] == 2) {
                    mask3[i] = 1;
                    now += stHere;
                } else {
                    return false;
                }
            } else {
                ll ptr2 = i;
                while (ptr2 >= 0 && mask3[ptr2] != 2) {
                    --ptr2;
                }
                if (mask3[i + 1] == 1 && ptr2 >= 0) {
                    ll stPtr2 = 1LL << ptr2;
                    mask3[i + 1] = 2;
                    mask3[ptr2] = 1;
//                    ptr1 = max(ptr1, ptr2);
//                    stPtr1 = 1LL << ptr1;
                    now -= stHere << 1;
                    now += stPtr2;
                } else if (mask3[i] == 1) {
                    mask3[i] = 2;
                    now -= stHere;
                } else {
                    return false;
                }
            }
        }
    }
    return true;
}

bool check(int n, ll mask) {
    if (n < 0) {
        n = -n;
        ll nmask = 0;
        ll now = 1;
        for (int i = MAXLOG, cnt = 0; cnt < 2 * MAXLOG; ++i, now *= 2, ++cnt) {
            if (i == 2 * MAXLOG) i = 0;
            if ((mask >> i) & 1) {
                nmask += now;
            }
        }
        mask = nmask;
    }
    ll now = 0;
    for (int i = MAXLOG - 1; i >= 0; --i) {
        if ((n >> i) & 1) {
            if (((mask >> MAXLOG + i) & 1) && ((mask >> i + 1) & 1)) {
                mask ^= 1LL << MAXLOG + i;
                mask ^= 1LL << i + 1;
            } else if ((mask >> i) & 1) {
                mask ^= 1LL << i;
            } else {
                return false;
            }
        }
    }
    return true;
}

int cnt(ll mask) {
    int ans = 0;
    while (mask) {
        ++ans;
        mask &= (mask - 1);
    }
    return ans;
}

int main() {
    st3[0] = 1;
    for (int i = 1; i < 23; ++i) {
        st3[i] = st3[i - 1] * 3;
    }
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    for (auto &x : a) {
        MAXLOG = max(MAXLOG, (int) log2(fabs(x)) + 2);
    }
//    cout << MAXLOG << "\n";
//    for (auto x : a) {
//        cout << badCheck(x, 28) << " ";
//    }
//    cout << "\n";
    ll ansMask = -1, ans = 0;
//    for (ll mask = 0; mask < (1LL << 2 * MAXLOG); ++mask) {
//        bool ok = true;
//        for (auto x : a) {
//            if (!badCheck(x, mask)) {
//                ok = false;
//                break;
//            }
//        }
//        int here = cnt(mask);
//        if (ok && here < ans) {
//            ans = here;
//            ansMask = mask;
//        }
//    }
    queue<ll> q;
    q.push(0);
    auto good = [&](ll mask) {
        for (auto &x : a) {
            if (!check3(x, mask)) {
                return false;
            }
        }
        return true;
    };
    good(73);
    bool ok = false;
    vector<ll> toPush;
    while(!q.empty() && !ok) {
        ll mask = q.front();
        q.pop();
        ll was = mask;
        for (int i = 0; i < MAXLOG; ++i) {
            if (mask % 3 == 0) {
                ll nmask = was + st3[i];
                if (good(nmask)) {
                    ok = true;
                    ansMask = nmask;
                    break;
                }
//                q.push(nmask);
                toPush.push_back(nmask);
                nmask += st3[i];
                if (good(nmask)) {
                    ok = true;
                    ansMask = nmask;
                    break;
                }
//                q.push(nmask);
                toPush.push_back(nmask);
            }
            mask /= 3;
        }
        random_shuffle(toPush.begin(), toPush.end());
        while (!toPush.empty()) {
            q.push(toPush.back());
            toPush.pop_back();
        }
    }
    ll m = ansMask;
    for (int i = 0; i < MAXLOG; ++i) {
        if (m % 3) ++ans;
        m /= 3;
    }
    cout << ans << "\n";
    for (int i = 0; i < MAXLOG; ++i) {
        if (ansMask % 3 == 1) {
            cout << "-";
        }
        if (ansMask % 3) {
            cout << (1LL << i) << " ";
        }
        ansMask /= 3;
    }
//    for (int i = 0; i < 2 * MAXLOG; ++i) {
//        if ((ansMask >> i) & 1) {
//            int j = i;
//            if (i >= MAXLOG) {
//                cout << "-";
//                j -= MAXLOG;
//            }
//            cout << (1 << j) << " ";
//        }
//    }
    cout << "\n";
    return 0;
}
/*
1
9

5
-1 3 0 4 7

4
2 -2 14 18
 */