#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;

vector<int> mat[N];
bool cycle_rch[N];
bool in_cycle[N];
char color[N];
int siz[N];
bool used[N];
vector<int> res[N];

void dfs(int v) {
	color[v] = 1;
	siz[v] = 1;
	for (auto to : mat[v]) {
		if (color[to] == 2) {
			siz[v] += siz[to];
			cycle_rch[v] |= cycle_rch[to];
			continue;
		}
		if (color[to] == 1) {
			cycle_rch[v] = in_cycle[v] = 1;
			continue;
		}
		dfs(to);
		siz[v] += siz[to];
		cycle_rch[v] |= cycle_rch[to];
	}
	color[v] = 2;
}

void dfs_ans(int v, int w) {
	res[w].push_back(v);
	used[v] = 1;
	for (auto to : mat[v]) {
		if (!used[to])
			dfs_ans(to, w);
	}
}

void run() {
	
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> when(n);
	for (int i = 0; i < n; i++)
		cin >> when[i];

	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if ((when[u] + 1) % h == when[v]) 
			mat[u].push_back(v);
		if ((when[v] + 1) % h == when[u])
			mat[v].push_back(u);
	}

	for (int i = 0; i < n; i++) {
		if (!color[i]) {
			dfs(i);
		}
	}

	for (int i = 0; i < n; i++) {
		if (mat[i].empty()) {
			cout << 1 << endl << i + 1;
			return;
		}
	}

	int cur = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i] && in_cycle[i])
			dfs_ans(i, cur++);
	}

	int ans = INF;
	int best = -1;
	for (int i = 0; i < cur; i++) {
		if (sz(res[i]) < ans) {
			ans = sz(res[i]);
			best = i;
		}
	}

	cout << ans << endl;
	for (auto it : res[best]) {
		cout << it + 1 << ' ';
	}




}