#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;

vector<int> mat[N];
bool cycle_rch[N];
bool in_cycle[N];
bool used[N];
vector<int> order;
int which[N];
set<int> nmat[N];

void topsort(int v) {
	used[v] = 1;

	for (auto to : mat[v])
		if (!used[to])
			topsort(to);

	order.push_back(v);
}

void dfs_condensate(int v, vector<int> &cur) {
	cur.push_back(v);
	used[v] = 1;
	for (auto to : mat[v])
		if (!used[to])
			dfs_condensate(to, cur);

}

void run() {
	
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> when(n);
	for (int i = 0; i < n; i++)
		cin >> when[i];

	vector<pair<int, int>> edges;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if ((when[u] + 1) % h == when[v]) {
			mat[u].push_back(v);
			edges.eb(u, v);
		}
		if ((when[v] + 1) % h == when[u]) {
			mat[v].push_back(u);
			edges.eb(v, u);
		}
	}

	for (int i = 0; i < n; i++) {
		if (mat[i].empty()) {
			cout << 1 << endl << i + 1;
			return;
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i])
			topsort(i);
	}

	//reverse(all(order));
	vector<vector<int>> comps;
	fill(used, used + n, false);
	for (auto v : order) {
		if (!used[v]) {
			vector<int> tmp;
			dfs_condensate(v, tmp);
			for (auto it : tmp)
				which[it] = sz(comps);
			comps.push_back(tmp);
		}
	}

	for (auto e : edges) {
		if (which[e.x] != which[e.y])
			nmat[which[e.x]].insert(which[e.y]);
	}

	int ans = INF;
	int best = -1;
	for (int i = 0; i < sz(comps); i++) {
		if (!sz(nmat[i]) && sz(comps[i]) < ans) {
			ans = sz(comps[i]);
			best = i;
		}
	}
	cout << ans << endl;
	for (auto v : comps[best])
		cout << v + 1 << ' ';



}