import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    TreeSet<Integer> g[], g1[];
    boolean can[];
    boolean used[];
    int lvl[];

    void dfs(int v) {
        lvl[v] = 0;
        used[v] = true;
        for (int u : g1[v]) {
            if (!used[u]) {
                dfs(u);
            }
            lvl[v] += lvl[u];
        }
        lvl[v]++;
    }

    void dfswr(int v) {
        wr.add(v + 1);
        used[v] = true;
        for (int u : g1[v]) {
            if (!used[u]) {
                dfswr(u);
            }
        }
    }

    ArrayList<Integer> wr = new ArrayList<>();

    public void solve() throws IOException {
        int n = nextInt();
        lvl = new int[n];
        can = new boolean[n];
        used = new boolean[n];
        int m = nextInt();
        int h = nextInt();

        g = new TreeSet[n];
        for (int i = 0; i < n; i++) {
            g[i] = new TreeSet<>();
        }
        g1 = new TreeSet[n];
        for (int i = 0; i < n; i++) {
            g1[i] = new TreeSet<>();
        }
        int uc[] = new int[n];
        for (int i = 0; i < n; i++) {
            uc[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            int x = nextInt() - 1, y = nextInt() - 1;
            g[x].add(y);
            g[y].add(x);
        }
        for (int i = 0; i < n; i++) {
            for (int u : g[i]) {
                if ((uc[i] + 1) % h == uc[u]) {
                    can[i] = true;
                    g1[i].add(u);
                }
            }
        }
        int res = Integer.MAX_VALUE, cur = 0;
        for (int i = 0; i < n; i++) {
            if(!used[i]) dfs(i);
        }
        for (int i = 0; i < n; i++) {
            if(lvl[i] < res){
                res = lvl[i];
                cur = i;
            }
        }
        out.println(res);
        Arrays.fill(used, false);
        dfswr(cur);
        Collections.sort(wr);
        for(int u : wr){
            out.print(u + " ");
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
