#include <bits/stdc++.h>
#define fr first
#define sc second

using namespace std;
typedef pair<int, int> ii;
typedef long long ll;
typedef unsigned long long u64;
const int NMAX = 1e5 + 9, INF = 1e9 + 7, MOD = 1e9 + 7;

vector<int> g[NMAX], gt[NMAX], col(NMAX), tsort, verWithCol(NMAX);
vector<char> used(NMAX), bad(NMAX);

void dfs(int v) {
    used[v] = 1;
    for (int to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    tsort.push_back(v);
}

void zhfs(int v, int c) {
    col[v] = c;
    for (int to : gt[v]) {
        if (col[to] == 0) {
            zhfs(to, c);
        } else if (col[to] != col[v]) {
            bad[col[to]] = 1;
        }
    }
}

void kekfs(int v, vector<int> &vev) {
    used[v] = 1;
    vev.push_back(v);
    for (int to : g[v]) {
        if (!used[to] && col[to] == col[v]) {
            kekfs(to, vev);
        }
    }
}

set<ii> edge;

main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(0);

    int n, m, h;
    cin >> n >> m >> h;
    int t[n];
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v, --u, --v;
        if ((t[u] + 1) % h == t[v] && !edge.count({u, v})) {
            edge.insert({u, v});
            g[u].push_back(v);
            gt[v].push_back(u);
        }
        if ((t[v] + 1) % h == t[u] && !edge.count({v, u})) {
            edge.insert({v, u});
            g[v].push_back(u);
            gt[u].push_back(v);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(tsort.begin(), tsort.end());

    int c = 0;
    for (int v : tsort) {
        if (col[v] == 0) {
            verWithCol[++c] = v;
            zhfs(v, c);
        }
    }

    fill(used.begin(), used.end(), 0);
    vector<int> ans;
    int szAns = INF;
    for (int i = 1; i <= c; ++i) {
        if (!bad[i]) {
            vector<int> cur;
            kekfs(verWithCol[i], cur);
            if (cur.size() < szAns) {
                szAns = cur.size();
                ans = cur;
            }
        }
    }

    assert(szAns != INF);
    cout << szAns << '\n';
    for (int v : ans) {
        cout << v + 1 << ' ';
    }
}
