#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <cstdio>
#include <utility>
#include <ostream>
#include <ctime>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

void topsort(int s, vector<vector<int>> &g, vector<int> &ord, vector<bool> &vis) {
	vis[s] = true;
	for (int to : g[s]) {
		if (!vis[to]) topsort(to, g, ord, vis);
	}
	ord.push_back(s);
}

void cond(int s, int c, vector<int> &color, vector<vector<int>> &g) {
	color[s] = c;
	for (int to : g[s]) {
		if (color[to] == 0) cond(to, c, color, g);
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> u(n);
	vector<vector<int>> g(n), ig(n);
	for (int i = 0; i < n; i++) {
		cin >> u[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		if ((u[a] + 1) % h == u[b]) {
			g[a].push_back(b);
			ig[b].push_back(a);
		}
		if ((u[b] + 1) % h == u[a]) {
			g[b].push_back(a);
			ig[a].push_back(b);
		}
	}
	vector<int> ord;
	vector<bool> vis(n);
	for (int i = 0; i < n; i++) {
		if (!vis[i]) topsort(i, g, ord, vis);
	}
	vector<int> color(n);
	int c = 1;
	reverse(ord.begin(), ord.end());
	for (int i = 0; i < n; i++) {
		int cur = ord[i];
		if (color[cur] == 0)
			cond(cur, c++, color, ig);
	}
	for (int i = 0; i < n; i++) {
		color[i]--;
	}
	c--;
	vector<vector<int>> newg(c);
	for (int i = 0; i < n; i++) {
		for (int to : g[i]) {
			if (color[to] != color[i]) 
				newg[color[i]].push_back(color[to]);
		}
	}
	vector<int> sz(c);
	for (int i = 0; i < n; i++) {
		sz[color[i]]++;
	}
	ord.clear();
	fill(vis.begin(), vis.end(), false);
	for (int i = 0; i < c; i++) {
		if (!vis[i]) topsort(i, newg, ord, vis);
	}
	int ansc = -1, val = 1e9;
	for (int i = 0; i < c; i++) {
		if (newg[i].size() != 0) continue;
		if (sz[i] < val) val = sz[i], ansc = i;
	}
	cout << val << "\n";
	for (int i = 0; i < n; i++) {
		if (color[i] == ansc) cout << i + 1 << " ";
	}
}