#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<cmath>
#include<list>
using namespace std;
#define elif else if
#define int long long
class point
{
public:
	double x, y;
	point operator +(point a)
	{
		return { a.x + x,a.y + y };
	}
	point operator -(point a)
	{
		return { x - a.x,y - a.y };
	}
	point operator *(double k)
	{
		return { k*x,k*y };
	}
	point operator /(double k)
	{
		return { x / k,y / k };
	}
	double operator *(point a)
	{
		return a.x*x + a.y*y;
	}
	double operator %(point a)
	{
		return x * a.y - y * a.x;
	}
	double lensqr()
	{
		return x * x + y * y;
	}
	double len()
	{
		return sqrt(lensqr());
	}
	point norm()
	{
		return { x / len(),y / len() };
	}
};
vector<vector<int>>graf;
vector<vector<int>>rev;
vector<int>ordre;
vector<int>usd;
int comp = 0;
void dfs(int s)
{
	usd[s] = 1;
	for (int i = 0; i < graf[s].size(); ++i)
	{
		if (usd[graf[s][i]] == 0)
		{
			dfs(graf[s][i]);
		}
	}
	ordre.push_back(s);
}
void sfd(int s)
{
	usd[s] = comp;
	for (int i = 0; i < rev[s].size(); ++i)
	{
		if (usd[rev[s][i]] == 0)
		{
			sfd(rev[s][i]);
		}
	}
}
int32_t main()
{
	ios_base::sync_with_stdio(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector<int>helb(n);
	rev.resize(n);
	graf.resize(n);
	usd.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> helb[i];
	}
	for (int i = 0; i < m; ++i)
	{
		int f, t;
		cin >> f >> t;
		--f;
		--t;
		if (helb[f] == (helb[t] + 1) % k)
		{
			graf[t].push_back(f);
			rev[f].push_back(t);
		}
		if(helb[t] == (helb[f] + 1) % k)
		{
			graf[f].push_back(t);
			rev[t].push_back(f);
		}
	}
	for (int i = 0; i < n; ++i)
	{
		if (!usd[i])
		{
			dfs(i);
		}
	}
	usd.assign(n, 0);
	reverse(ordre.begin(), ordre.end());
	for (int i = 0; i < n; ++i)
	{
		if (!usd[ordre[i]])
		{
			++comp;
			sfd(ordre[i]);
		}
	}
	vector<int>is_gud(comp,1);
	for (int i = 0; i < n; ++i)
	{
		for (int q = 0; q < graf[i].size(); ++q)
		{
			if (usd[graf[i][q]] != usd[i])
			{
				is_gud[usd[i] - 1] = 0;
				break;
			}
		}
	}
	vector<int>inc(comp);
	for (int i = 0; i < n; ++i)
	{
		++inc[usd[i] - 1];
	}
	int minc = -1;
	for (int i = 0; i < comp; ++i)
	{
		if (is_gud[i])
		{
			if (minc == -1 || inc[minc] > inc[i])
			{
				minc = i;
			}
		}
	}
	cout << inc[minc] << '\n';
	for (int i = 0; i < n; ++i)
	{
		if (usd[i] - 1 == minc)
		{
			cout << i + 1 << ' ';
		}
	}
	return 0;
}