#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

#define F first
#define S second
#define add push_back
#define sz(x) (x).size()
#define all(x) (x).begin(), (x).end()

const ll INF = (ll)1e9 + 2018;

struct SegTree {
    int l0, l1;
};

const int N = 2e5 + 10;
int arr[N];
SegTree t[N * 4];
vector <vector <int>> ans;

void relax(int v) {
    t[v].l0 = INF;
    t[v].l1 = INF;
    t[v].l0 = min(t[v * 2].l0, t[v * 2 + 1].l0);
    t[v].l1 = min(t[v * 2].l1, t[v * 2 + 1].l1);
}

void build(int v, int l, int r) {
    if (l == r) {
        if (!arr[l]) {
            t[v].l0 = l;
            t[v].l1 = INF;
        } else {
            t[v].l0 = INF;
            t[v].l1 = l;
        }
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    relax(v);
}

pii query(int v, int l, int r, int a, int b) {
    if (a > r || l > b) {
        return {INF, INF};
    }
    if (a <= l && r <= b) {
        return {t[v].l0, t[v].l1};
    }
    int m = (l + r) / 2;
    pii res1 = query(v * 2, l, m, a, b), res2 = query(v * 2 + 1, m + 1, r, a, b);
    return {min(res1.F, res2.F), min(res1.S, res2.S)};
}

void update(int v, int l, int r, int p) {
    if (l == r) {
        t[v].l0 = INF;
        t[v].l1 = INF;
        return;
    }
    int m = (l + r) / 2;
    if (p <= m) {
        update(v * 2, l, m, p);
    } else {
        update(v * 2 + 1, m + 1, r, p);
    }
    relax(v);
}

void $main() {
    string s;
    cin >> s;
    int n = sz(s);
    int c0 = 0, c1 = 0;
    for (int i = 0; i < n; i++) {
        c0 += s[i] == '0';
        c1 += s[i] == '1';
        arr[i] = s[i] - '0';
    }
    if (c0 - c1 <= 0) {
        cout << -1;
        return;
    }
    build(1, 0, n - 1);
    int cnt = n;
    while (cnt) {
        bool f = 0;
        vector <int> res;
        int l = 0;
        pii w = query(1, 0, n - 1, l, n - 1);
        while ((!f && w.F < INF) || (f && w.S < INF)) {
            int ind = 0;
            if (!f) {
                ind = w.F;
            } else {
                ind = w.S;
            }
            l = ind + 1;
            res.add(l);
            f ^= 1;
            cnt--;
            update(1, 0, n - 1, ind);
            w = query(1, 0, n - 1, l, n - 1);
        }
        if (!f) {
            cout << -1;
            return;
        }
        ans.add(res);
    }
    cout << sz(ans) << endl;
    for (int i = 0; i < sz(ans); i++) {
        cout << sz(ans[i]) << " ";
        for (int j = 0; j < sz(ans[i]); j++) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    ios::sync_with_stdio(0);
#ifdef flaax
    freopen("input.txt", "r", stdin);
#endif
    $main();
}
