#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 100100;

int n, m, h;
int u[N];
std::vector<int> g[N], gr[N];
std::vector<std::vector<int>> cmp;
int cmpNum[N];
bool used[N];
std::vector<int> order;
bool isGood[N];

void topSort(int v) {
    used[v] = true;
    for (auto to: gr[v]) {
        if (!used[to]) {
            topSort(to);
        }
    }
    order.push_back(v);
}

void dfs(int v) {
    cmp.back().push_back(v);
    cmpNum[v] = cmp.size() - 1;
    used[v] = true;
    for (auto to: g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}

int main(void) {
    scanf("%d%d%d", &n, &m, &h);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &u[i]);
    }
    for (int i = 0; i < m; ++i) {
        int from, to;
        scanf("%d%d", &from, &to);
        //g[from - 1].push_back(to - 1);
        //g[to - 1].push_back(from - 1);
        if ((u[from - 1] + 1) % h == u[to - 1] % h) {
            g[from - 1].push_back(to - 1);
            gr[to - 1].push_back(from - 1);
        }
        if ((u[to - 1] + 1) % h == u[from - 1] % h) {
            g[to - 1].push_back(from - 1);
            gr[from - 1].push_back(to - 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            topSort(i);
        }
    }
    std::reverse(order.begin(), order.end());
    memset(used, false, n * sizeof(bool));
    for (auto i: order) {
        if (!used[i]) {
            cmp.push_back(std::vector<int>());
            dfs(i);
        }
    }
    memset(isGood, true, n * sizeof(bool));
    for (int i = 0; i < n; ++i) {
        for (auto to: g[i]) {
            if (cmpNum[to] != cmpNum[i]) {
                isGood[cmpNum[i]] = false;
            }
        }
    }
    int res = -1;
    for (int i = 0; i < cmp.size(); ++i) {
        if ((res == -1 || cmp[res].size() > cmp[i].size()) && isGood[i]) {
            res = i;
        }
    }
    printf("%d\n", cmp[res].size());
    for (auto i: cmp[res]) {
        printf("%d ", i + 1);
    }
    return 0;
}