#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>

using namespace std;

#define ll long long

int add(int h, int cur) {
    return (cur + 1) % h;
}

void dfs(int start, int h, vector <bool> &used, vector <set <int>> &graph, vector <int> &u) {
    used[start] = 1;
    for (auto i : graph[start]) {
        if (!used[i] && add(h, u[start]) == u[i]) {
            dfs(i, h, used, graph, u);
        }
    }
}

int main() {
    //freopen("in.txt", "r", stdin);
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> u(n);
    for (int i = 0; i < n; ++i) {
        cin >> u[i];
    }

    vector <set <int>> graph(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graph[a].insert(b);
        graph[b].insert(a);
    }
    int ans = n;
    vector <int> res;
    for (int i = 0; i < n;++i) {
        res.push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        vector <bool> used(n, 0);
        dfs(i, h, used, graph, u);
        int cur = 0;
        for (auto i : used) cur += i;
        if (ans > cur) {
            ans = cur;
            res.clear();
            for (int i = 0; i < n; ++i) {
                if (used[i]) {
                    res.push_back(i);
                }
            }
        }
    }

    cout << ans << endl;
    for (auto i : res) cout << i + 1 << " ";

    return 0;
}
