#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>

using namespace std;

#define ll long long

void add(ll x, vector <ll> &ans) {
    if (x < 0) {
        x = -x;
        for (int i = 0; i < 30; ++i) {
            if (((1 << i) & x)) {
                ans.push_back(-(1 << i));
            }
        }
    }
    else {
        for (int i = 0; i < 30; ++i) {
            if (((1 << i) & x)) {
                ans.push_back((1 << i));
            }
        }
    }
}

ll up(ll x) {
    ll i = 1;
    while (i <= x) {
        i *= 2;
    }
    return i;
}

ll down(ll x) {
    ll i = 1;
    while (i * 2 < x) {
        i *= 2;
    }
    return i;
}

void print(vector <ll> &ans) {
    for (auto i : ans) cout << i << " ";
    cout << endl;
}

void get_ans(ll x) {
    if (!x) {
        cout << 0;
        //cout << endl << endl;
        return;
    }

    vector <ll> ans1, ans2, ans3;
    if (x > 0) {
            ll u = up(x), d = down(x);
            add(x, ans1);
            add(u, ans2);
            add(-u + x, ans2);
            add(d, ans3);
            add(x - d, ans3);
            if (ans1.size() > ans2.size()) swap(ans1, ans2);
            if (ans1.size() > ans3.size()) swap(ans1, ans3);
        }
        else {
            ll u = -up(-x), d = -down(-x);
            add(x, ans1);
            add(u, ans2);
            add(x - u, ans2);
            add(d, ans3);
            add(x - d, ans3);
            if (ans1.size() > ans2.size()) swap(ans1, ans2);
            if (ans1.size() > ans3.size()) swap(ans1, ans3);
        }


    cout << ans1.size() << endl;
    for (auto i : ans1) {
        cout << i << " ";
    }
    //cout << endl << endl;
}

void get_ans2(ll x, vector <vector <ll>> &c) {
    if (!x) {
        return;
    }
    vector <ll> ans1, ans2, ans3;
    if (x > 0) {
            ll u = up(x), d = down(x);
            add(x, ans1);
            add(u, ans2);
            add(-u + x, ans2);
            add(d, ans3);
            add(x - d, ans3);
            if (ans1.size() > ans2.size()) swap(ans1, ans2);
            if (ans1.size() > ans3.size()) swap(ans1, ans3);
        }
        else {
            ll u = -up(-x), d = -down(-x);
            add(x, ans1);
            add(u, ans2);
            add(x - u, ans2);
            add(d, ans3);
            add(x - d, ans3);
            if (ans1.size() > ans2.size()) swap(ans1, ans2);
            if (ans1.size() > ans3.size()) swap(ans1, ans3);
        }
    c[0] = ans1;
    c[1] = ans2;
    c[2] = ans3;
}

set <int> s;

void get_ans3(int ind, vector <vector <vector <ll>>> &a, map <int, int> &cur) {
    if (ind >= a.size()) {
        set <int> tmp;
        for (auto i : cur) {
            tmp.insert(i.first);
        }
        /*for (auto i : tmp) cout << i << " ";
        cout << endl;*/
        if (!s.size() || tmp.size() < s.size()) {
            s = tmp;
        }
        return;
    }
    for (int i = 0; i < 3; ++i) {
        for (auto j : a[ind][i]) {
            cur[j]++;
        }
        get_ans3(ind + 1, a, cur);
        for (auto j : a[ind][i]) {
            if (cur[j] == 1) {
                cur.erase(j);
            }
            else {
                cur[j]--;
            }
        }
    }
}
int main() {
    //freopen("in.txt", "r", stdin);

    int n;
    cin >> n;
    if (n == 1) {
        ll x;
        cin >> x;
        get_ans(x);
        return 0;
    }
    vector <vector <vector <ll>>> a(n, vector <vector <ll>> (3));
    for (int i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        get_ans2(x, a[i]);
    }
    map <int, int> cur;
    get_ans3(0, a, cur);
    cout << s.size() << endl;
    for (auto i : s) {
        cout << i << " ";
    }

    /*if (n == 5) cout << 3 << endl << "4 -1 4";
    if (n == 4) cout << 3 << endl << "-2 2 16";*/

    return 0;
}
