#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

bool check(vector<bool> &a) {
    for (auto i : a)
        if (i == false)
            return true;
    return false;
}

int n, m, h;
vector<vector<ll>> G;
vector<ll> arr;
vector<ll> vertans;
vector<bool> used;
vector<ll> ans;
set<ll> setans;
vector<ll> dpth;

bool check(ll a, ll b) {
    return (a + 1) % h == b;
}

ll ansdfs(int v, int depth) {
    used[v] = true;
    dpth[v] = depth;
    ll answ = inf;
    for (auto i : G[v])
        if (used[i])
            answ = min(answ, dpth[v] - dpth[i]);
        else
            answ = min(answ, ansdfs(i, depth + 1) + 1);
    return answ;
}

void dfsadd(int v) {
    used[v] = true;
    arr[v] = (arr[v] + 1) % h;
    for (auto i : G[v])
        if (!used[i])
            dfsadd(i);
}

void addans(int v) {
    setans.insert(v + 1);
    used[v] = true;
    for (auto i : G[v])
        if (!used[i])
            addans(i);
}

int main() {
    fast_input();
    files();
    cin >> n >> m >> h;
    arr.resize(n);
    for (auto &i : arr) cin >> i;
    vector<ll> startarr = arr;
    G.resize(n);
    vector<pair<int, int>> users(m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v, --u, --v;
        users[i] = { u, v };
        if (check(arr[u], arr[v]))G[u].push_back(v);
        if (check(arr[v], arr[u]))G[v].push_back(u);
    }
    vector<ll> stack;
    for (auto i : users) {
        if (arr[i.first] == arr[i.second]) {
            if (G[i.first].size() > 0) stack.push_back(i.first);
            else stack.push_back(i.second);
        }
    }
    if (stack.size() > 0) {
        for (auto i : stack)
            dfsadd(i);
        for (int i = 0; i < n; ++i)
            if (arr[i] != startarr[i])
                ans.push_back(i + 1);
        cout << ans.size() << '\n';
        for (auto i : ans) cout << i;
    }
    else {
        vertans.resize(n, inf);
        used.resize(n);
        dpth.resize(n);
        for (int i = 0; i < n; ++i) used[i] = false;
        for (int i = 0; i < n; ++i)
            vertans[i] = ansdfs(i, 0);
        int ind = 0;
        for (int i = 0; i < n; ++i)
            if (vertans[i] < vertans[ind])
                ind = i;
        used.resize(n);
        addans(ind);
        cout << setans.size() << '\n';
        for (auto i : setans) cout << i << ' ';
    }

    system("pause");
    return 0;
}