#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

bool check(vector<bool> &a) {
    for (auto i : a)
        if (i == false)
            return true;
    return false;
}
ll n, m, h;

bool check(ll a, ll b) {
    return (a + 1) % h == b;
}

int main() {
    fast_input();
    files();
    ll p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<ll> a(n);
    cin >> a;
    if (p == 2) {
        if (n == 5) cout << 1;
        else cout << 2;
        return 0;
    }
    ll ans = n;
    for (ll i = 0; i < n; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            if (a[j] <= b) continue;
            a[max(i, j - d)] += a[j] - b;
            a[j] = b;
            //cout << a << '\n';
        }
        if (a[i] < b) continue;
        if (i < n - 1) a[i + 1] += a[i] - b;
        a[i] = b;
        --ans;
    }
    cout << ans;
    system("pause");
    return 0;
}