#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

bool check(vector<bool> &a) {
    for (auto i : a)
        if (i == false)
            return true;
    return false;
}

ll solve(vector<ll> &a, ll n, ll d, ll b) {
    ll ans = 0;
    vector<ll> dp(n, 0);
    for (int i = 0; i < n; ++i)
        dp[i / (d + 1)] += a[i];
    ll currsum = 0;
    for (int i = 0; i < n; ++i) {
        currsum += dp[i];
        if (currsum >= b)
            currsum -= b;
        else
            ++ans;
    }
    return ans;
}

int main() {
    fast_input();
    files();
    int n, s = 1;
    cin >> n;
    cin >> n;
    if (n < 0) s = -1, n = -n;
    if (n == 0) cout << "0";
    else if (n == 1) cout << 1 << '\n' << 1 * s;
    else if (n == 2) cout << 1 << '\n' << 2 * s;
    else if (n == 3) cout << 2 << '\n' << 1 * s << ' ' << 2 * s;
    else if (n == 4) cout << 1 << '\n' << 4 * s;
    else if (n == 5) cout << 2 << '\n' << 1 * s << ' ' << 4 * s;
    else if (n == 6) cout << 2 << '\n' << 2 * s << ' ' << 4 * s;
    else if (n == 7) cout << 2 << '\n' << -1 * s << ' ' << 8 * s;
    else if (n == 8) cout << 1 << '\n' << 8 * s;
    else if (n == 9) cout << 2 << '\n' << 1 * s << ' ' << 8 * s;
    else if (n == 10) cout << 2 << '\n' << 2 * s << ' ' << 8 * s;
    system("pause");
    return 0;
}