#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

bool check(vector<bool> &a) {
    for (auto i : a)
        if (i == false)
            return true;
    return false;
}

int main() {
    fast_input();
    files();
    string s;
    cin >> s;
    for (auto &i : s) i -= 48;
    int n = s.size();
    vector<bool> used(n);
    vector<vector<ll>> ans;
    while (check(used)) {
        vector<ll> now;
        ll curr = 0;
        for (int i = 0; i < n; ++i)
            if (!used[i] && s[i] == curr) {
                curr = !curr;
                used[i] = true;
                now.push_back(i + 1);
            }
        if (now.size() == 0) {
            cout << -1;
            return 0;
        }
        if (now.size() % 2 == 0) used[now.back() - 1] = false, now.pop_back();
        ans.push_back(now);
    }
    cout << ans.size() << '\n';
    for (auto &i : ans) {
        cout << i.size() << ' ';
        cout << i << '\n';
    }
    system("pause");
    return 0;
}