#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

vector<vector<int>> graph, rever, finish;
vector<int> times, colors, order, counter;
vector<bool> used;
int n, m, h;

void create_order(int vert)
{
    used[vert] = true;
    for (int elem : graph[vert])
        if (!used[elem])
            create_order(elem);

    order.pb(vert);
}

void create_color(int vert, int now)
{
    colors[vert] = now;
    counter[now]++;
    for (int elem : rever[vert])
        if (!colors[elem])
            create_color(elem, now);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> h;
    times.resize(n);
    graph.resize(n);
    rever.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> times[i];
    for (int i = 0; i < m; ++i) {
        int c1, c2;
        cin >> c1 >> c2;
        c1--;
        c2--;

        if ((times[c1] + 1) % h == times[c2]) {
            graph[c1].pb(c2);
            rever[c2].pb(c1);
        }
        if ((times[c2] + 1) % h == times[c1]) {
            graph[c2].pb(c1);
            rever[c1].pb(c2);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (graph[i].empty()) {
            cout << 1 << endl << i + 1 << endl;
            return 0;
        }
    }

    used.resize(n);
    for (int i = 0; i < n; ++i)
        if (!used[i])
            create_order(i);
    reverse(all(order));

    colors.resize(n);
    counter.resize(n + 1);
    int now = 1;
    for (int elem : order)
        if (!colors[elem])
            create_color(elem, now++);

    finish.resize(now);
    for (int i = 0; i < n; ++i)
        for (int elem : graph[i])
            if (colors[i] != colors[elem])
                finish[colors[i]].pb(colors[elem]);

    int ans = INF, pos = -1;
    for (int i = 1; i < now; ++i) {
        if (finish[i].empty() && counter[i] < ans) {
            ans = counter[i];
            pos = i;
        }
    }

    cout << ans << endl;
    vector<int> print;
    for (int i = 0; i < n; ++i)
        if (colors[i] == pos)
            print.pb(i + 1);
    for (int elem : print)
        cout << elem << " ";

    return 0;
}
