#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<int>> gr, invGr, newGr;
vector<int> order, cl;

vector<bool> used;
int cnt = 0;

void orderDfs(int v) {
    used[v] = 1;
    for (int to: gr[v]) {
        if (!used[to]) {
            orderDfs(to);
        }
    }
    order.push_back(v);
}

void invDfs(int v, int col) {
    cl[v] = col;
    for (int to: invGr[v]) {
        if (cl[to] == -1) {
            invDfs(to, col);
        }
    }
}

void constructGraph(int v) {
    used[v] = 1;
    for (int to: gr[v]) {
        if (cl[to] != cl[v]) {
            newGr[cl[v]].push_back(cl[to]);
        } else {
            if (!used[to]) {
                constructGraph(to);
            }
        }
    }
}

vector<int> ans, w;

int findAns(int v) {
    if (ans[v] != -1) {
        return ans[v];
    }
    ans[v] = w[v];
    for (int to: newGr[v]) {
        if (ans[to] == -1) {
            findAns(to);
        }
        ans[v] += ans[to];
    }
    return ans[v];
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    gr.resize(n);
    used.resize(n, 0);
    cl.resize(n, -1);
    invGr.resize(n);
    auto nxt = [&](int &x) {
        return (x + 1) % h;
    };
    vector<int> tm(n);
    for (int i = 0; i < n; ++i) {
        cin >> tm[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        if (nxt(tm[a]) == tm[b]) {
            gr[a].push_back(b);
            invGr[b].push_back(a);
        }
        if (nxt(tm[b]) == tm[a]){
            gr[b].push_back(a);
            invGr[a].push_back(b);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            orderDfs(i);
        }
    }
    int cnt = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (cl[order[i]] == -1) {
            invDfs(order[i], cnt);
            ++cnt;
        }
    }
    used.assign(n, 0);
    newGr.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            constructGraph(i);
        }
    }
    w.resize(cnt, 0);
    for (int i = 0; i < n; ++i) {
        w[cl[i]]++;
    }
    ans.resize(cnt, -1);
    int color = 0, k = n + 1;
    for (int i = 0; i < cnt; ++i) {
        if (ans[i] == -1) {
            findAns(i);
        }
        if (ans[i] < k) {
            k = ans[i];
            color = i;
        }
    }
    cout << k << "\n";
    for (int i = 0; i < n; ++i) {
        if (cl[i] == color) {
            cout << i + 1 << " ";
        }
    }
}