#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Tree {
    int L, R, sum;
    Tree *left, *right;
    Tree(int l, int r) {
        L = l;
        R = r;
        sum = 0;
        left = nullptr;
        right = nullptr;
    }
};

Tree *newTree(int L, int R) {
    return new Tree(L, R);
}

void recalc(Tree *tree) {
    if (!tree) {
        return;
    }
    tree->sum = tree->left->sum + tree->right->sum;
}

Tree *buildTree(int L, int R, vector<int> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        int M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        recalc(tree);
    } else {
        tree->sum = data[L];
    }
    return tree;
}

int getSum(Tree *tree, int l, int r) {
    if (tree->L >= r || tree->R <= l) {
        return 0;
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->sum;
    }
    return getSum(tree->left, l, r) + getSum(tree->right, l, r);
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p, n, b, d;
    cin >> p >> n >> d >> b;
    vector<int> data(n);
    for (int i = 0; i < n; ++i) {
        cin >> data[i];
    }
    Tree *tree = buildTree(0, n, data);
    for (int i = 0; i < n; ++i) {
        int pref = 0;
        int now = 0;
        bool fl = 0;
        for (int j = i; j < n; ++j) {
            if (data[j] + now >= b ) {
                now += data[j] - b;
            } else {
                int sum = getSum(tree, j + 1, min(j + d + 1, n));
                if (sum + now + data[i] < b) {
                    fl = 1;
                    break;
                } else {
                    now += data[i] + sum - b;
                }
            }
        }
        if (!fl) {
            cout << i << "\n";
            break;
        }
        pref += data[i];
    }
}