#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Tree {
    ll L, R, sum;
    Tree *left, *right;
    Tree(ll l, ll r) {
        L = l;
        R = r;
        sum = 0;
        left = nullptr;
        right = nullptr;
    }
};

Tree *newTree(ll L, ll R) {
    return new Tree(L, R);
}

void recalc(Tree *tree) {
    if (!tree) {
        return;
    }
    tree->sum = tree->left->sum + tree->right->sum;
}

Tree *buildTree(ll L, ll R, vector<ll> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        ll M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        recalc(tree);
    } else {
        tree->sum = data[L];
    }
    return tree;
}

ll getSum(Tree *tree, ll l, ll r) {
    if (tree->L >= r || tree->R <= l) {
        return 0;
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->sum;
    }
    return getSum(tree->left, l, r) + getSum(tree->right, l, r);
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll p, n, b, d;
    cin >> p >> n >> d >> b;
    vector<ll> data(n);
    for (ll i = 0; i < n; ++i) {
        cin >> data[i];
    }
    Tree *tree = buildTree(0, n, data);
    ll pref = 0;
    for (ll i = 0; i < n; ++i) {
        ll now = pref;
        bool fl = 0;
        for (ll j = i; j < n; ++j) {
            if (data[j] + now >= b) {
                now += data[j] - b;
            } else {
                ll sum = getSum(tree, j + 1, min(j + (j + 1) * d + 1, n));
                if (j == n - 1) {
                    sum = 0;
                }
                if (sum + now + data[i] < b) {
                    fl = 1;
                    break;
                } else {
                    now += data[i] + sum - b;
                }
            }
        }
        if (!fl) {
            cout << i << "\n";
            break;
        }
        pref += data[i];
    }
    if (p == 1) {
        assert(0);
    }
}