#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Tree {
    ll L, R, sum, val;
    Tree *left, *right;

    Tree(ll l, ll r) {
        L = l;
        R = r;
        sum = 0;
        val = 1;
        left = nullptr;
        right = nullptr;
    }
};

Tree *newTree(ll L, ll R) {
    return new Tree(L, R);
}

ll tsum(Tree *tree) {
    if (!tree) {
        return 0;
    }
    return tree->val * tree->sum;
}

void recalc(Tree *tree) {
    if (!tree) {
        return;
    }
    tree->sum = tsum(tree->left) + tsum(tree->right);
}

void push(Tree *tree) {
    if (!tree) {
        return;
    }
    if (tree->val != 1) {
        tree->val = 1;
        tree->sum = 0;
        tree->left->val = 0;
        tree->right->val = 0;
    }
}

Tree *buildTree(ll L, ll R, vector<ll> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        ll M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        recalc(tree);
    } else {
        tree->sum = data[L];
    }
    return tree;
}

ll getSum(Tree *tree, ll l, ll r) {
    if (tree->L >= r || tree->R <= l) {
        return 0;
    }
    if (tree->L >= l && tree->R <= r) {
        return tsum(tree);
    }
    push(tree);
    ll ans = getSum(tree->left, l, r) + getSum(tree->right, l, r);
    recalc(tree);
    return ans;
}

void setZero(Tree *tree, ll l, ll r) {
    if (tree->L >= r || tree->R <= l) {
        return;
    }
    if (tree->L >= l && tree->R <= r) {
        tree->val = 0;
        return;
    }
    push(tree);
    setZero(tree->left, l, r);
    setZero(tree->right, l, r);
    recalc(tree);
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll p, n, b, d;
    cin >> p >> n >> d >> b;
    vector<ll> data(n);
    for (ll i = 0; i < n; ++i) {
        cin >> data[i];
    }
    ll pref = 0;
    for (ll i = 0; i < n; ++i) {
        ll now = pref;
        bool fl = 0;
        Tree *tree = buildTree(0, n, data);
        for (ll j = i; j < n; ++j) {
//            cout << j << " " << min(j + (j + 1) * d + 1, n) << "\n";
            ll sum = getSum(tree, j, min(j + (j + 1) * d + 1, n));
            setZero(tree, j, min(j + (j + 1) * d + 1, n));
            if (sum + now < b) {
                fl = 1;
                break;
            } else {
                now += sum - b;
            }
        }
        if (!fl) {
            cout << i << "\n";
            return 0;
        }
        pref += data[i];
    }
    if (p == 1) {
        assert(0);
    }
}