#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> pr;

bool isZebr(string s) {
    if (s.size() % 2 == 0) {
        return false;
    }
    for (int i = 0; i < s.size(); i += 2) {
        if (s[i] != '0') {
            return false;
        }
    }
    for (int i = 1; i < s.size(); i += 2) {
        if (s[i] != '1') {
            return false;
        }
    }
    return true;
}

int find(int v) {
    return (pr[v] == v ? v : pr[v] = find(pr[v]));
}

void unite(int v, int u) {
    u = find(u);
    v = find(v);
    pr[v] = u;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    int n = s.size();
    int cnt1 = 0, cnt0 = 0;
    pr.resize(n);
    for (int i = 0; i < n; ++i) {
        pr[i] = i;
    }
    vector<int> poses1, poses0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1') {
            ++cnt1;
        } else {
            ++cnt0;
        }
    }
    if (cnt1 >= cnt0) {
        cout << -1 << "\n";
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (!poses1.empty()) {
                int v = pr[poses1.back()];
                poses1.pop_back();
                unite(v, pr[i]);
            }
            poses0.push_back(i);
        } else {
            if (!poses0.empty()) {
                int v = pr[poses0.back()];
                poses0.pop_back();
                unite(pr[i], v);
            } else {
                cout << -1 << "\n";
                return 0;
            }
            poses1.push_back(i);
        }
    }
    map<int, vector<int>> ans;
    for (int i = 0; i < n; ++i) {
        pr[i] = find(pr[i]);
        ans[pr[i]].push_back(i + 1);
    }
    cout << ans.size() << "\n";
    for (auto x: ans) {
        cout << x.second.size() << " ";
        for (auto y: x.second){
            cout << y << " ";
        }
        string q;
        for (auto y: x.second) {
            q += s[y - 1];
        }
        assert(isZebr(q));
        cout << "\n";
    }
}