#include <stdio.h>
#include <vector>
#include <algorithm>

std::vector<int> *graph;
__gnu_cxx::__normal_iterator<int*, std::vector<int> > *its;
bool *usecomps;
int *used1, *used2, *used3, *tin, *tout, *min, time = 1, color = 1, color1 = 1, color2 = 1, num, opt = 1e9, comps = 1;

void dfstimes(int v) {
	used1[v] = color2;
	tin[v] = time;
	time++;
	for (__gnu_cxx::__normal_iterator<int*, std::vector<int> > it = graph[v].begin();
	  it < its[v]; it++) {
		if (!used1[*it]) {
			dfstimes(*it);
		}
	}
	tout[v] = time;
	time++;
}

void dfsmin(int v) {
	used2[v] = color;
	min[v] = tin[v];
	for (__gnu_cxx::__normal_iterator<int*, std::vector<int> > it = graph[v].begin();
	  it < its[v]; it++) {
		if (used1[*it] && used1[*it] != color2) {
			continue;
		}
		if (used2[*it] != color) {
			dfsmin(*it);
			if (min[v] > min[*it]) {
				min[v] = min[*it];
			}
		} else {
			if (min[v] > tin[*it]) {
				min[v] = tin[*it];
			}
		}
	}
}

int dfs2(int v) {
	used2[v] = color;
	int ans = 1;
	for (__gnu_cxx::__normal_iterator<int*, std::vector<int> > it = graph[v].begin();
	  it < its[v]; it++) {
		if (used2[*it] != color) {
			ans += dfs2(*it);
		}
	}
	return ans;
}

void dfsleafs(int v, int comp) {
	used3[v] = color1;
	for (__gnu_cxx::__normal_iterator<int*, std::vector<int> > it = graph[v].begin();
	  it < its[v]; it++) {
		if (used1[*it] && used1[*it] != color2) {
			usecomps[comp - 1] = true;
			continue;
		}
		if (used3[*it] != color1) {
			if (min[*it] != min[v]) {
				usecomps[comp - 1] = true;
				comps++;
				dfsleafs(*it, comps);
			} else {
				dfsleafs(*it, comp);
			}
		}
	}
	if (!usecomps[comp - 1]) {
		int ans = dfs2(v);
		color++;
		if (ans < opt) {
			opt = ans;
			num = v;
		}
	}
}

void dfs3(int v) {
	used2[v] = color;
	for (__gnu_cxx::__normal_iterator<int*, std::vector<int> > it = graph[v].begin();
	  it < its[v]; it++) {
		if (used2[*it] != color) {
			dfs3(*it);
		}
	}
	printf("%d ", v + 1);
}

int main() {
	int n, m, h;
	scanf("%d%d%d", &n, &m, &h);
	graph = new std::vector<int>[n];
	int u[n];
	used1 = new int[n]();
	usecomps = new bool[n]();
	used2 = new int[n]();
	used3 = new int[n]();
	tin = new int[n];
	tout = new int[n];
	min = new int[n];
	its = new __gnu_cxx::__normal_iterator<int*, std::vector<int> >[n];
	for (int i = 0; i < n; i++) {
		scanf("%d", &u[i]);
	}
	for (int i = 0; i < m; i++) {
		int c1, c2;
		scanf("%d%d", &c1, &c2);
		c1--, c2--;
		if ((u[c1] + 1) % h == u[c2]) {
			graph[c1].push_back(c2);
		}
		if ((u[c2] + 1) % h == u[c1]) {
			graph[c2].push_back(c1);
		}
	}
	for (int i = 0; i < n; i++) {
		std::sort(graph[i].begin(), graph[i].end());
		its[i] = std::unique(graph[i].begin(), graph[i].end());
	}
	for (int i = 0; i < n; i++) {
		if (!used1[i]) {
			dfstimes(i);
			dfsmin(i);
			color++;
			dfsleafs(i, 1);
			color1++;
			color2++;
		}	
	}
	printf("%d\n", opt);
	dfs3(num);
	return 0;
}
