#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <set>
#include <fstream>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

int main() {

    int n, m, h;
    cin >> n >> m >> h;
    vector<set<int>> time(h);
    vector<vector<int>> ctime(h);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        time[x].insert(i);
        ctime[x].push_back(i);
    }
    vector<vector<int>> p(m);
    for (int i = 0; i < m; i++) {
        int f, t;
        cin >> f >> t;
        f--, t--;
        p[f].push_back(t), p[t].push_back(f);
    }
    int worst = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < ctime[i].size(); j++) {
            int check = 0;
            for (int k = 0; k < p[ctime[i][j]].size(); k++) {
                if (time[(i + 1) % h].find(p[ctime[i][j]][k]) == time[(i + 1) % h].end()) {
                    check++;
                }
            }
            if (check == p[ctime[i][j]].size()) {
                cout << 1 << "\n" << ctime[i][j] + 1;
                return 0;
            } else {
                worst++;
            }
        }
    }
    if (worst == n) {
        cout << n << "\n";
        for (int i = 1; i <= n; i++) {
            cout << i << " ";
        }
    }
    return 0;
}

/*

 3 3 5
 4 4 0
 1 3
 3 2
 3 1

 4 5 4
 2 1 0 3
 4 3
 3 2
 1 2
 1 4
 1 3

 */