#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>

using namespace std;

typedef long long LL;

const int MAXN = 100500;

int n, m, h;
int u[MAXN];
vector<int> g[MAXN];
vector<int> st[MAXN * 2], strev[MAXN * 2];
vector<int> compsz;
vector<int> order;
vector<char> used;
vector<int> component;
vector<unordered_set<int>> cond;
vector<int> szsz;
vector<vector<int>> vcomp;

int compid[2 * MAXN];

void dfs_szsz(int v) {
  used[v] = 1;
  for (auto to : cond[v]) {
    if (!used[v])
      dfs_szsz(v);
    szsz[v] += szsz[to];
  }
}

void dfs_order(int v) {
  used[v] = 1;
  
  for (auto to : st[v]) {
    if (!used[to])
      dfs_order(to);
  }
  order.push_back(v);
}

void dfs_back(int v) {
  component.push_back(v);
  used[v] = 1;

  for (auto to : strev[v]) {
    if (!used[to])
      dfs_back(to);
  }
}

void genans(int v, vector<int> &ans) {
  used[v] = 1;
  for (auto x : vcomp[v])
    if (x % 2 == 1)
      ans.push_back(x / 2);

  for (auto to : cond[v]) {
    if (!used[to])
      genans(to, ans);
  }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    cin.tie(0);
    cin.sync_with_stdio(0);

    cin >> n >> m >> h;

    for (int i = 0; i < n; ++i) {
      cin >> u[i];
    }

    for (int i = 0; i < m; ++i) {
      int c1, c2;
      cin >> c1 >> c2;
      c1--, c2--;

      g[c1].push_back(c2);
      g[c2].push_back(c1);
    }

    for (int i = 0; i < n; ++i) {
      for (auto to : g[i]) {
        if (u[i] == u[to]) {
          st[2 * i].push_back(2 * to + 1);
          st[2 * i + 1].push_back(2 * to);
        }
        if (u[i] == (u[to] + 1) % h) {
          st[2 * i].push_back(2 * to);
          st[2 * to + 1].push_back(2 * i + 1);
        }
        if ((u[i] + 1) % h == u[to]) {
          st[2 * i + 1].push_back(2 * to + 1);
          st[2 * to].push_back(2 * i);
        }
      }
    }

    for (int i = 0; i < 2 * MAXN; ++i) {
      for (auto to : st[i]) {
        strev[to].push_back(i);
      }
    }

    used.resize(2 * n, 0);

    for (int i = 0; i < 2 * n; ++i) {
      if (!used[i])
        dfs_order(i);
    }

    reverse(order.begin(), order.end());

    used.assign(2 * n, 0);

    int cnt = 0;
    for (int i : order) {
      if (!used[i]) {
        component.clear();
        dfs_back(i);

        for (auto x : component)
          compid[x] = cnt;

        cnt++;
        vcomp.push_back(component);
      }
    }

    cond.resize(cnt);
    compsz.assign(cnt, 0);

    for (int i = 0; i < 2 * n; ++i) {
      int idi = compid[i];
      if (i & 1)
        compsz[idi]++;

      for (auto to : st[i]) {
        int idto = compid[to];
        if (idi != idto) cond[idi].insert(idto);
      }
    }

    /*used.assign(cnt, 0);
    szsz = compsz;

    for (int i = 0; i < cnt; ++i) {
      if (!used[i])
        dfs_szsz(i);
    }*/
    
    int mid = -1;
    for (int i = 0; i < cnt; ++i)
      if (cond[i].size() == 0 && compsz[i] > 0 && (mid == -1 || compsz[mid] > compsz[i]))
        mid = i;

    vector<int> ans;

    used.assign(cnt, 0);
    genans(mid, ans);

    cout << ans.size() << '\n';
    for (auto x : ans)
      cout << x + 1 << ' ';
    cout << '\n';

    return 0;
}