#include <iostream>
#include <vector>
#include <set>
#include <cstdio>
#include <climits>
#include <cstdlib>
#include <cassert>
#include <algorithm>

using namespace std;
typedef unsigned int index;

void dfs(index v, const vector<vector<index>> &g, vector<bool> &used, vector<index> &ans)
{
    if (used[v])
        return;
    used[v] = true;
    for (auto i: g[v])
        dfs(i, g, used, ans);
    ans.push_back(v);
}

size_t sdfs(index v, index it, const vector<vector<index>> &g, vector<index> &st_used, vector<index> &anss)
{
    if (st_used[v] != 0)
    {
        if (st_used[v] < it)
            return INT_MAX / 2;
        else
            return 0;
    }
    anss.push_back(v);
    st_used[v] = it;
    size_t ans = 1;
    for (auto i: g[v])
    {
        ans += sdfs(i, it, g, st_used, anss);
        if (ans > INT_MAX / 2)
            return ans;
    }
    return ans;
}


int main()
{
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    //
    // assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    size_t n, m, h;
    cin >> n >> m >> h;
    vector<index> a(n);
    for (auto &i: a)
        cin >> i;
    vector<vector<index>> g(n);
    for (index i = 0; i < m; i++)
    {
        index l, r;
        cin >> l >> r;
        l--, r--;
        if ((a[l] + 1) % h == a[r])
            g[l].push_back(r);
        if ((a[r] + 1) % h == a[l])
            g[r].push_back(l);
    }
    vector<vector<index>> tg(n);
    for (index i = 0; i < n; i++)
        for (auto j: g[i])
            tg[j].push_back(i);
    vector<index> ot;
    vector<bool> used(n);
    for (index i = 0; i < n; i++)
    {
        dfs(i, tg, used, ot);
    }
    reverse(ot.begin(), ot.end());
    vector<index> st_used(n);
    size_t ans = ULONG_MAX;
    vector<index> ids;
    for (index i = 0; i < n; i++)
    {
        vector<index> nans;
        size_t sv = sdfs(ot[i], i + 1, g, st_used, nans);
        if (sv < ans)
        {
            ans = sv;
            ids = nans;
        }
    }
    assert(ans == ids.size());
    cout << ans << endl;
    for (auto i: ids)
        cout << i + 1 << " ";
    cout << endl;
}
