#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<climits>

using namespace std;

void dfs(int s, vector<vector<int> > &graph, vector<char> &visited, vector<int> &path, int &num)
{
	if (visited[s])
		return;
	visited[s] = true;
	++num;
	path.push_back(s);
	for (int i : graph[s])
		dfs(i, graph, visited, path, num);
}

int dfs2(int s, vector<vector<int> > &graph, vector<char> &visited, vector<int> &num)
{
	if (visited[s])
		return num[s];
	visited[s] = true;
	int curr = 1;
	for (int i : graph[s])
		curr += dfs2(i, graph, visited, num);
	return num[s] = curr;
}

void dfs_time(int s, vector<vector<int> > &graph, vector<char> &visited, vector<int> &top_sort)
{
	if (visited[s])
		return;
	visited[s] = true;
	for (int i : graph[s])
		dfs_time(i, graph, visited, top_sort);
	top_sort.push_back(s);
}

void dfs_col(int s, vector<vector<int> > &graph, vector<int> &col, vector<vector<int> > &in_col, int k)
{
	if (col[s] != -1)
		return;
	col[s] = k;
	in_col[k].push_back(s);
	for (int i : graph[s])
		dfs_col(i, graph, col, in_col, k);
}

int main()
{
	int n, m, h, x, y;
	cin >> n >> m >> h;
	vector<int> u(n);
	for (int i = 0; i < n; ++i)
		cin >> u[i];
	vector<vector<int> > graph(n), tr_graph(n);
	for (int i = 0; i < m; ++i)
	{
		cin >> x >> y;
		--x;
		--y;
		if ((u[x] + 1) % h == u[y])
		{
			graph[x].push_back(y);
			tr_graph[y].push_back(x);
		}
		if ((u[y] + 1) % h == u[x])
		{
			graph[y].push_back(x);
			tr_graph[x].push_back(y);
		}
	}
	for (int i = 0; i < n; ++i)
	{
		sort(graph[i].begin(), graph[i].end());
		auto it = unique(graph[i].begin(), graph[i].end());
		graph[i].erase(it, graph[i].end());
		sort(tr_graph[i].begin(), tr_graph[i].end());
		it = unique(tr_graph[i].begin(), tr_graph[i].end());
		tr_graph[i].erase(it, tr_graph[i].end());
	}
	vector<int> ts;
	vector<char> visited(n);
	for (int i = 0; i < n; ++i)
	{
		if (!visited[i])
			dfs_time(i, graph, visited, ts);
	}
	reverse(ts.begin(), ts.end());
	int k = 0;
	vector<int> col(n, -1);
	vector<vector<int> > in_col;
	for (int i : ts)
	{
		if (col[i] == -1)
		{
			vector<int> em;
			in_col.push_back(em);
			dfs_col(i, tr_graph, col, in_col, k);
			++k;
		}
	}
//	cout << "K " << k << endl;
	vector<vector<int> > graph2(k);
	for (int i = 0; i < n; ++i)
	{
		for (int j : graph[i])
			graph2[col[i]].push_back(col[j]);
	}
	for (int i = 0; i < k; ++i)
	{
		sort(graph2[i].begin(), graph2[i].end());
		auto it = unique(graph2[i].begin(), graph2[i].end());
		graph2[i].erase(it, graph2[i].end());
	}
	vector<int> num(k);
	int minim = INT_MAX, ind;
	for (int i = 0; i < k; ++i)
		num[i] = in_col[i].size() - 1;
	vector<char> vis(k);
	for (int i = 0; i < k; ++i)
	{
		if (!vis[i])
			num[i] = dfs2(i, graph2, vis, num);
//		cout << num[i] << endl;
		if (num[i] < minim)
		{
			minim = num[i];
			ind = i;
		}
	}
	fill(vis.begin(), vis.end(), 0);
	vector<int> path;
	x = 0;
	dfs(ind, graph2, vis, path, x);
	vector<int> ans;
	for (int i = 0; i < path.size(); ++i)
	{
		for (int j = 0; j < in_col[path[i]].size(); ++j)
			ans.push_back(in_col[path[i]][j]);
	}
	cout << ans.size() << '\n';
	sort(ans.begin(), ans.end());
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] + 1 << " ";
	//system("pause");
	return 0;
}