#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#ifdef DEBUG
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

vector<vector<int>> g, gr, c;
vector<int> sz, order, col, d;
vector<char> use;

void top_sort(int v)
{
    use[v] = 1;
    for (auto x: gr[v])
    {
        if (!use[x])
            top_sort(x);
    }
    order.pb(v);
}

int dfs(int v, int cl)
{
    use[v] = 1;
    col[v] = cl;
    int ans = 1;
    for (auto x: g[v])
    {
        if (!use[x])
            ans += dfs(x, cl);
    }
    return ans;
}

void dfs2(int v)
{
    use[v] = 1;
    for (auto x: g[v])
    {
        if (use[x])
            continue;
        if (col[x] == col[v])
            dfs2(x);
        else
            c[col[v] - 1].pb(col[x] - 1);
    }
}

void run()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    for (auto &x: u)
        cin >> x;
    g.resize(n);
    gr.resize(n);
    use.resize(n);
    col.resize(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (u[b] == (u[a] + 1) % h)
        {
            g[a].pb(b);
            gr[b].pb(a);
        }
        if (u[a] == (u[b] + 1) % h)
        {
            gr[a].pb(b);
            g[b].pb(a);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (!use[i])
            top_sort(i);
    }
    reverse(all(order));
    fill(all(use), 0);
    for (auto x: order)
    {
        if (!use[x])
        {
            c.pb({});
            sz.pb(dfs(x, c.size()));
        }
    }
    debug("!" << sz.size());
    fill(all(use), 0);
    for (int i = 0; i < n; i++)
    {
        if (!use[i])
            dfs2(i);
    }
    int num = 0, best = n;
    for (int i = 0; i < (int)c.size(); i++)
    {
        if (c[i].empty() && sz[i] < best)
        {
            num = i;
            best = sz[i];
        }
    }
    cout << best << "\n";
    for (int i = 0; i < n; i++)
    {
        if (col[i] == num + 1)
            cout << i + 1 << " ";
    }
}
/*
4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
