#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

const int maxn = 2e5 + 88;
const int inf = 1e9 + 88;

vector<int> curg[maxn], g[maxn], rg[maxn];
bool used[maxn];
int sum[maxn], comp[maxn], u[maxn];
vector<int> order;
int timer = 0;

void dfs1(int v)
{
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++)
        if (!used[g[v][i]])
            dfs1(g[v][i]);
    order.push_back(v);
}

void dfs2(int v)
{
    used[v] = true;
    comp[v] = timer;
    sum[timer]++;
    for (int i = 0; i < rg[v].size(); i++)
        if (!used[rg[v][i]])
            dfs2(rg[v][i]);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    long long n, m, i, j, h, a, b;
    cin >> n >> m >> h;
    for (i = 0; i < n; i++)
        cin >> u[i];
    for (i = 0; i < m; i++)
    {
        cin >> a >> b;
        a--, b--;
        if ((u[a] + 1)%h == u[b])
        {
            g[a].push_back(b);
            rg[b].push_back(a);
        }
        if ((u[b] + 1)%h == u[a])
        {
            g[b].push_back(a);
            rg[a].push_back(b);
        }
    }
    for (i = 0; i < n; i++)
        if (!used[i])
            dfs1(i);
    reverse(order.begin(), order.end());
    for (i = 0; i < n; i++)
        used[i] = false;
    for (i = 0; i < n; i++)
        if (!used[order[i]])
        {
            dfs2(order[i]);
            timer++;
        }
    for (i = 0; i < n; i++)
        for (j = 0; j < g[i].size(); j++)
        {
            int to = g[i][j];
            if (comp[to] != comp[i])
                curg[comp[i]].push_back(comp[to]);
        }
    for (i = 0; i < timer; i++)
    {
        g[i] = curg[i];
        used[i] = false;
    }
    int ans = inf, ansno = 0;
    for (i = 0; i < timer; i++)
        if (g[i].size() == 0 && ans > sum[i])
        {
            ans = sum[i];
            ansno = i;
        }
    cout << ans << "\n";
    for (i = 0; i < n; i++)
        if (comp[i] == ansno)
            cout << i + 1 << " ";
    return 0;
}
