//
// Created by olymp on 08.03.2018.
//
#include <iostream>
#include <stack>
#include <vector>

int n = 0, m = 0, h = 0;
std::vector<int> u;
std::vector< std::vector<int> > G, tG;
std::stack<int> sorted;
std::vector<int> used;
std::vector<int> components;
std::vector<char> valid;

void DFS(int v) {
    used[v] = 1;
    for (auto to : G[v]) {
        if (!used[to]) {
            DFS(to);
        }
    }
    sorted.push(v);
}

void DFS2(int v, int color) {
    used[v] = color;
    ++components[color - 1];
    for (auto to : tG[v]) {
        if (!used[to]) {
            DFS2(to, color);
        } else if (used[to] != color) {
            valid[used[to] - 1] = 1;
        }
    }
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n >> m >> h;
    u.resize(n);
    G.resize(n);
    tG.resize(n);
    used.resize(n);
    for (auto &i : u) {
        std::cin >> i;
    }
    for (int i = 0; i < m; ++i) {
        int v1 = 0, v2 = 0;
        std::cin >> v1 >> v2;
        --v1;
        --v2;
        if ((u[v1] + 1) % h == u[v2]) {
            G[v1].push_back(v2);
            tG[v2].push_back(v1);
        }
        if ((u[v2] + 1) %  h == u[v1]) {
            G[v2].push_back(v1);
            tG[v1].push_back(v2);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            DFS(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
    int cnt = 0;
    while(!sorted.empty()) {
        int cur = sorted.top();
        sorted.pop();
        if (!used[cur]) {
            ++cnt;
            valid.push_back(0);
            components.push_back(0);
            DFS2(cur, cnt);
        }
    }
    int min_color = -1;
    for (int i = 0; i < cnt; ++i) {
        if (!valid[i]) {
            if (min_color == -1) {
                min_color = i;
            } else if (components[i] < components[min_color]) {
                min_color = i;
            }
        }
    }
    std::cout << components[min_color] << '\n';
    ++min_color;
    for (int i = 0; i < n; ++i) {
        if (used[i] == min_color) {
            std::cout << i + 1 << ' ';
        }
    }
    return 0;
}