// ConsoleApplication1.cpp: определяет точку входа для консольного приложения.
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
typedef long long ll;
typedef long double db;
using namespace std;
#define fs first
#define sc second
#define endl '\n'
#define sz(g) int(g.size())
#define all(g) (g.begin()),(g.end())
#define mp make_pair

const int max_n = 1 << 17;
struct Node {
    int x;
    Node(int xx = 0) :x(xx) {}
    Node operator +(Node d) {
        return Node(x + d.x);
    }
};

struct Segment_Tree {
#define tm (tl+tr)/2
    vector<Node> t;
    Segment_Tree() {
        t.resize(max_n * 2, Node());
    }
    void add(int l, int r, int res) {
        add_el(0, max_n - 1, l, r, 1, res);
    }
    int get(int l, int r) {
        get_seg(0, max_n - 1, l, r, 1);
    }
    void add_el(int tl, int tr, int l, int r, int v,int res) {
        if (tl > r || tr < l)
            return;
        if (tl >= l && tr <= r) {
            t[v].x += res;
            return;
        }
        add_el(tl, tm, l, r, v * 2, res);
        add_el(tm + 1, tr, l, r, v * 2 + 1, res);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get_seg(int tl, int tr, int l, int r, int v) {
        if (tl > r || tr < l)
            return 0;
        if (tl >= l && tr <= r)
            return t[v].x;
        return get_seg(tl, tm, l, r, v * 2) + get_seg(tm + 1, tr, l, r, v * 2 + 1);
    }
#undef tm
};

vector<vector<int>> Edge;
vector<vector<int>> col;
vector<int> t;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    t.resize(n);
    Edge.resize(n);
    col.resize(n);
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        Edge[u].push_back(v);
        Edge[v].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        int up = (t[i] + 1) % h;
        for (int j = 0; j < Edge[i].size(); j++) {
            int to = Edge[i][j];
            if (up == t[to])
                col[i].push_back(to);
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++)
        ans[i] = i;
    for (int i = 0; i < n; i++) {
        vector<bool> used(n, false);
        set<int> s;
        s.insert(i);
        used[i] = true;
        while (s.size() != 0) {
            int to = *s.begin();
            s.erase(s.begin());
            for (int j = 0; j < col[to].size(); j++) {
                if (used[col[to][j]])continue;
                used[col[to][j]] = true;
                s.insert(col[to][j]);
            }
        }
        vector<int> res;
        for (int j = 0; j < n; j++) {
            if (used[j])res.push_back(j);
        }
        if (res.size() < ans.size())
            ans = res;
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
        cout << ans[i] + 1 << ' ';
    cout << endl;
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}

