// ConsoleApplication1.cpp: определяет точку входа для консольного приложения.
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
typedef long long ll;
typedef long double db;
using namespace std;
#define fs first
#define sc second
#define endl '\n'
#define sz(g) int(g.size())
#define all(g) (g.begin()),(g.end())
#define mp make_pair

const int max_n = 1 << 17;
struct Node {
    int x;
    Node(int xx = 0) :x(xx) {}
    Node operator +(Node d) {
        return Node(x + d.x);
    }
};

struct Segment_Tree {
#define tm (tl+tr)/2
    vector<Node> t;
    Segment_Tree() {
        t.resize(max_n * 2, Node());
    }
    void add(int l, int r, int res) {
        add_el(0, max_n - 1, l, r, 1, res);
    }
    int get(int l, int r) {
        get_seg(0, max_n - 1, l, r, 1);
    }
    void add_el(int tl, int tr, int l, int r, int v,int res) {
        if (tl > r || tr < l)
            return;
        if (tl >= l && tr <= r) {
            t[v].x += res;
            return;
        }
        add_el(tl, tm, l, r, v * 2, res);
        add_el(tm + 1, tr, l, r, v * 2 + 1, res);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get_seg(int tl, int tr, int l, int r, int v) {
        if (tl > r || tr < l)
            return 0;
        if (tl >= l && tr <= r)
            return t[v].x;
        return get_seg(tl, tm, l, r, v * 2) + get_seg(tm + 1, tr, l, r, v * 2 + 1);
    }
#undef tm
};


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    int a = 0;
    int b = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '0')
            a++;
        else
            b++;
    }
    if (a < b) {
        cout << -1 << endl;
        return 0;
    }
    int k = a - b;
    vector<vector<int>> ans(k);
    set<int> q;
    set<int> w;
    for (int i = 0; i < k; i++) {
        q.insert(i);
    }
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '0') {
            if (q.size() == 0) {
                cout << -1 << endl;
                return 0;
            }
            int n = *q.begin();
            ans[n].push_back(i);
            q.erase(q.begin());
            w.insert(n);
        }
        else {
            if (w.size() == 0) {
                cout << -1 << endl;
                return 0;
            }
            int n = *w.begin();
            ans[n].push_back(i);
            w.erase(w.begin());
            q.insert(n);
        }
    }
    cout << k << endl;
    for (int i = 0; i < k; i++) {
        cout << ans[i].size() << ' ';
        for (int j = 0; j < ans[i].size(); j++) {
            cout << ans[i][j] + 1 << ' ';
        }
        cout << endl;
    }
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}

