#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;
const int max_num = 10000000;

void dfs1(vector <vector <int> > &graph, vector <bool> &used, vector <int> &sorted, int u) {
    int w;
    used[u] = true;
    for (int i = 0; i < int(graph[u].size()); i++) {
        w = graph[u][i];
        if (!used[w]) {
            dfs1(graph, used, sorted, w);
        }
    }
    sorted.push_back(u);
}

int dfs2(vector <vector <int> > &graph, vector <int> &components, int comp, int u) {
    int w;
    components[u] = comp;
    for (int i = 0; i < int(graph[u].size()); i++) {
        w = graph[u][i];
        if (components[w] == -1) {
            dfs2(graph, components, comp, w);
        }
    }
}

int condens(vector <vector <int> > &graph, vector <int> &components, int n) {
    int u, comp;
    vector <int> sorted;
    sorted.reserve(n);
    vector <bool> used(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs1(graph, used, sorted, i);
        }
    }
    reverse(sorted.begin(), sorted.end());
/*
    cout << "sorted: ";
    for (int i = 0; i < n; i++) {
        cout << sorted[i] << ' ';
    }
    cout << '\n';
*/
    vector <vector <int> > reverse_graph(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < int(graph[i].size()); j++) {
            u = graph[i][j];
            reverse_graph[u].push_back(i);
        }
    }
    comp = 0;
    for (int i = 0; i < n; i++) {
        if (components[sorted[i]] == -1) {
            dfs2(reverse_graph, components, comp, sorted[i]);
            comp++;
        }
    }
    return comp;
}

int main() {
    ifstream fin("input.txt");
    int n, m, h, u, w, num_comp, minimum, min_id;
    fin >> n >> m >> h;
    vector <int> times(n);
    for (int i = 0; i < n; i++) {
        fin >> times[i];
    }
    vector <vector <int> > graph(n);
    for (int i = 0; i < m; i++) {
        fin >> u >> w;
        u--;
        w--;
        if ((times[u] + 1) % h == times[w]) {
            graph[u].push_back(w);
        }
        if ((times[w] + 1) % h == times[u]) {
            graph[w].push_back(u);
        }
    }
    vector <int> components(n, -1);
    num_comp = condens(graph, components, n);
/*
    cout << "graph:\n";
    for (int i = 0; i < n; i++) {
        cout << i << ": ";
        for (int j = 0; j < int(graph[i].size()); j++) {
            cout << graph[i][j] << ' ';
        }
        cout << '\n';
    }
    cout << '\n';
    cout << "components: ";
    for (int i = 0; i < n; i++) {
        cout << components[i] << ' ';
    }
    cout << '\n';
*/
    vector <int> sizes(num_comp, 0);
    vector <bool> possible(num_comp, true);
    vector <vector <int> > comps(num_comp);
    for (int i = 0; i < n; i++) {
        u = components[i];
        sizes[u]++;
        comps[u].push_back(i + 1);
        for (int j = 0; j < int(graph[i].size()); j++) {
            w = components[graph[i][j]];
            if (u != w) {
                possible[u] = false;
            }
        }
    }
/*
    cout << "sizes: ";
    for (int i = 0; i < num_comp; i++) {
        cout << sizes[i] << ' ';
    }
    cout << '\n';
    cout << "possible: ";
    for (int i = 0; i < num_comp; i++) {
        cout << possible[i] << ' ';
    }
    cout << '\n';
    cout << "comps:\n";
    for (int i = 0; i < num_comp; i++) {
        cout << i << ": ";
        for (int j = 0; j < int(comps[i].size()); j++) {
            cout << comps[i][j] << ' ';
        }
        cout << '\n';
    }
    cout << '\n';
*/
    minimum = max_num;
    min_id = -1;
    for (int i = 0; i < num_comp; i++) {
        if (possible[i] && sizes[i] < minimum) {
            min_id = i;
            minimum = sizes[i];
        }
    }
    cout << sizes[min_id] << '\n';
    for (int i = 0; i < sizes[min_id]; i++) {
        cout << comps[min_id][i] << ' ';
    }
    cout << '\n';
    return 0;
}
