#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <bitset>

using namespace std;
const int max_num = 4096;
const int max_power = 12;
int best = 1000;
int best_mask1;
int best_mask2;
//ofstream fout("output.txt");

bool check(bitset <2 * max_num> &possible, bitset <2 * max_num> &quests, int n) {
    if ((possible | quests) == possible) {
        return true;
    }
    return false;
}

void gen(bitset <2 * max_num> &possible, bitset <2 * max_num> &quests, int mask1, int mask2, int len, int power, int sign, int n) {
    int absol;
    //fout << mask1 << ' ' << mask2 << ' ' << len << ' ' << power << ' ' << sign << '\n';
    if (len >= best) {
        return;
    }
    if (power == max_power) {
        if (check(possible, quests, n)) {
            best = len;
            best_mask1 = mask1;
            best_mask2 = mask2;
        }
    }
    else {
        absol = 1 << power;
        bitset <2 * max_num> new_possible;
        if (sign == 1) {
            new_possible = possible | (possible << absol);
            gen(possible, quests, mask1, mask2, len, power, -1, n);
            gen(new_possible, quests, mask1 + absol, mask2, len + 1, power, -1, n);
        }
        else {
            new_possible = possible | (possible >> absol);
            gen(possible, quests, mask1, mask2, len, power + 1, 1, n);
            gen(new_possible, quests, mask1, mask2 + absol, len + 1, power + 1, 1, n);
        }
    }
}

int main() {
    ifstream fin("input.txt");
    int n;
    fin >> n;
    bitset <2 * max_num> possible;
    bitset <2 * max_num> quests;
    vector <int> v(n);
    for (int i = 0; i < n; i++) {
        fin >> v[i];
        v[i] += max_num;
    }
    for (int i = 0; i < n; i++) {
        quests[v[i]] = 1;
    }
    //vector <bool> possible(2 * max_num, false);
    //possible[0] = true;
    possible[max_num] = 1;
    //cout << possible << '\n';
    //cout << quests << '\n';
    gen(possible, quests, 0, 0, 0, 0, 1, n);
    cout << best << '\n';
/*
    cout << best_mask1 << ' ' << best_mask2 << '\n';
    for (int i = 0; i < max_power; i++) {
        cout << (best_mask2 | (1 << i)) << ' ';
    }
    cout << '\n';
*/
    for (int i = 0; i < max_power; i++) {
        if ((best_mask1 | (1 << i)) == best_mask1) {
            cout << (1 << i) << ' ';
        }
        if ((best_mask2 | (1 << i)) == best_mask2) {
            cout << -(1 << i) << ' ';
        }
    }
    return 0;
}
