#include <bits/stdc++.h>

using namespace std;

//#define int int64_t

template<typename _T>
inline void _DBG(const char *s, _T x);

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a);

#ifdef LOCAL
#define DBG(...) _DBG(#__VA_ARGS__, __VA_ARGS__)
#else
#define endl "\n"
#define DBG(...) (true)
#define cerr if(0) cout
#endif

template<typename type>
istream &operator>>(istream &in, vector<type> &a);

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a);

ostream &operator<<(ostream &out, const vector<int> &a);

ostream &operator<<(ostream &out, const vector<double> &a);

ostream &operator<<(ostream &out, const vector<bool> &a);

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a);

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a);

template<typename T, typename... args>
T max(const T &, args...);

template<typename T>
T max(const T &, const T &, const T &);

template<typename T>
T pow2(const T &);

template<typename T>
T Power(const T &, int, const T &);


// ********************** CODE ********************** //

void dfs_topsort(int v, const vector<vector<int> > &gr, vector<int> &ans, vector<bool> &used) {
    if (used[v]) {
        return;
    }
    used[v] = 1;
    for (auto &x : gr[v]) {
        dfs_topsort(x, gr, ans, used);
    }
    ans.push_back(v);
}

void topsort(const vector<vector<int> > &gr, vector<int> &ans) {
    vector<bool> used(gr.size());
    for (int i = 0; i < (int) gr.size(); ++i) {
        if (!used[i]) {
            dfs_topsort(i, gr, ans, used);
        }
    }
    reverse(ans.begin(), ans.end());
}

void dfs(int v, const vector<vector<int> > &gr, vector<int> &used, int cc = 1) {
    if (used[v] && used[v] != -1) {
        return;
    }
    used[v] = cc;
    for (auto &x : gr[v]) {
        dfs(x, gr, used, cc);
    }
}

int zip(const vector<vector<int> > &gr, vector<int> &color, vector<vector<int> > &newgr) {
    color = vector<int>(gr.size(), -1);
    vector<int> order;
    topsort(gr, order);
    vector<vector<int> > transp(gr.size());
    for (int i = 0; i < (int) gr.size(); ++i) {
        for (auto x : gr[i]) {
            transp[x].push_back(i);
        }
    }
    int cc = 0;
    for (int i = 0; i < (int) gr.size(); ++i) {
        if (color[i] == -1) {
            dfs(i, transp, color, ++cc);
        }
    }
    newgr.clear();
    newgr.resize(cc);
    for (int i = 0; i < (int) gr.size(); ++i) {
        for (auto y : gr[i]) {
            if (color[y] != color[i]) {
                newgr[color[i] - 1].push_back(color[y] - 1);
            }
        }
    }
    for (auto &x : newgr) {
        sort(x.begin(), x.end());
        x.resize(unique(x.begin(), x.end()) - x.begin());
    }
    return cc;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
#ifndef LOCAL
    assert(n <= 10);
#endif
    vector<int> u(n);
    cin >> u;
    vector<pair<int, int> > c(m);
    cin >> c;
    for (auto &x : c) {
        --x.first;
        --x.second;
    }
    vector<vector<int> > gr(n);
    for (int i = 0; i < m; ++i) {
        if ((u[c[i].first] + 1) % h == u[c[i].second]) {
            gr[c[i].first].push_back(c[i].second);
        }
        if ((u[c[i].second] + 1) % h == u[c[i].first]) {
            gr[c[i].second].push_back(c[i].first);
        }
    }
    for (auto &x : gr) {
        sort(x.begin(), x.end());
        x.resize(unique(x.begin(), x.end()) - x.begin());
    }
    vector<vector<int> > newgr;
    vector<int> color;
    vector<int> sz(zip(gr, color, newgr));
    for (auto &x : color) {
        sz[x - 1]++;
    }
    int ans = INT_MAX, ansc = -1;
    for (int i = 0; i < (int)sz.size(); ++i) {
        if (newgr[i].empty() && sz[i] < ans) {
            ans = sz[i];
            ansc = i + 1;
        }
    }
    cout << ans << endl;
    for (int i = 0; i < n; ++i) {
        if (color[i] == ansc) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    return 0;
}


// ********************* END OF CODE ********************* //


template<typename T>
T Power(const T &a, int n, const T &mod) {
    if (n == 0) {
        return 1;
    }
    if (n % 2) {
        return (a * Power(a, n - 1, mod)) % mod;
    }
    T res = Power(a, n / 2, mod);
    return (res * res) % mod;
}

template<typename T>
T pow2(const T &a) {
    return a * a;
}

template<typename _T>
inline void _DBG(const char *s, _T x) {
    cout << s << " = " << x << "\n";
}

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a) {
    int b = 0;
    while (*s != ',' || b != 0) {
        b += (*s) == '(';
        b -= (*s) == ')';
        cout << *s++;
    }
    cout << " = " << x << ',';
    _DBG(s + 1, a...);
}

template<typename T>
T max(const T &a) {
    return a;
}


template<typename T>
T max(const T &a, const T &b, const T &c) {
    return max(max(a, b), c);
}


template<typename T, typename... args>
T max(const T &a, args... b) {
    T res = ::max(b...);
    return a > res ? a : res;
}

ostream &operator<<(ostream &out, const vector<bool> &a) {
    for (auto x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a) {
    out << a.first << " " << a.second;
    return out;
}

ostream &operator<<(ostream &out, const vector<double> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

template<typename type>
istream &operator>>(istream &in, vector<type> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

