#include <bits/stdc++.h>

using namespace std;

//#define int int64_t

template<typename _T>
inline void _DBG(const char *s, _T x);

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a);

#ifdef LOCAL
#define DBG(...) _DBG(#__VA_ARGS__, __VA_ARGS__)
#else
#define endl "\n"
#define DBG(...) (true)
#define cerr if(0) cout
#endif

template<typename type>
istream &operator>>(istream &in, vector<type> &a);

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a);

ostream &operator<<(ostream &out, const vector<int> &a);

ostream &operator<<(ostream &out, const vector<double> &a);

ostream &operator<<(ostream &out, const vector<bool> &a);

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a);

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a);

template<typename T, typename... args>
T max(const T &, args...);

template<typename T>
T max(const T &, const T &, const T &);

template<typename T>
T pow2(const T &);

template<typename T>
T Power(const T &, int, const T &);


// ********************** CODE ********************** //

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    if (p == 1) {
        vector<int> a(n);
        cin >> a;
        vector<int> psum(n + 1);
        for (int i = 0; i < n; ++i) {
            psum[i + 1] = psum[i] + a[i];
        }
        int cnt = 0, penalty = 0;
        int curr = 0;
        while (curr < d && curr < n) {
            cnt += a[curr++];
        }
        for (int i = 0; i < n; ++i) {
            while (curr < n && curr < i + d + d * i) {
                cnt += a[curr++];
            }
            if (cnt >= b) {
                cnt -= b;
            } else {
                ++penalty;
            }
        }
        cout << penalty << endl;
    }
    return 0;
}


// ********************* END OF CODE ********************* //


template<typename T>
T Power(const T &a, int n, const T &mod) {
    if (n == 0) {
        return 1;
    }
    if (n % 2) {
        return (a * Power(a, n - 1, mod)) % mod;
    }
    T res = Power(a, n / 2, mod);
    return (res * res) % mod;
}

template<typename T>
T pow2(const T &a) {
    return a * a;
}

template<typename _T>
inline void _DBG(const char *s, _T x) {
    cerr << s << " = " << x << "\n";
}

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a) {
    int b = 0;
    while (*s != ',' || b != 0) {
        b += (*s) == '(';
        b -= (*s) == ')';
        cerr << *s++;
    }
    cerr << " = " << x << ',';
    _DBG(s + 1, a...);
}

template<typename T>
T max(const T &a) {
    return a;
}


template<typename T>
T max(const T &a, const T &b, const T &c) {
    return max(max(a, b), c);
}


template<typename T, typename... args>
T max(const T &a, args... b) {
    T res = ::max(b...);
    return a > res ? a : res;
}

ostream &operator<<(ostream &out, const vector<bool> &a) {
    for (auto x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a) {
    out << a.first << " " << a.second;
    return out;
}

ostream &operator<<(ostream &out, const vector<double> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

template<typename type>
istream &operator>>(istream &in, vector<type> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

