#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

vector<vector<int>> edges;
vector<vector<int>> redges;
vector<int> times;
vector<bool> used;
int n, m, h;

void topsort(int v, vector<int> &vec) {
    used[v] = 1;
    for (auto &to: edges[v])
        if (!used[to])
            topsort(to, vec);
    vec.push_back(v);
}

void connect(int v, vector<int> &vec) {
    used[v] = 1;
    for (auto &to: redges[v])
        if (!used[to])
            connect(to, vec);
    vec.push_back(v);
}

void solve() {
    vector<int> ts;
    for (int i = 0; i < n; i++)
        if (!used[i])
            topsort(i, ts);
    used.assign(n, 0);
    vector<int> ans;
    for (int i = n - 1; i >= 0; i--) {
        vector<int> tans;
        if (!used[i]) {
            connect(i, tans);
            if (tans.size() < ans.size() || ans.empty())
                ans = move(tans);
        }
    }
    cout << ans.size() << '\n';
    for (auto &it: ans)
        cout << it + 1 << ' ';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    cin >> n >> m >> h;

    edges.resize(n);
    redges.resize(n);
    times.resize(n);
    used.resize(n, 0);

    for (auto &it: times)
        cin >> it;

    while (m--) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        if ((times[v] + 1) % h == times[u]) {
            edges[u].push_back(v);
            redges[v].push_back(u);
        }
        if ((times[u] + 1) % h == times[v]) {
            edges[v].push_back(u);
            redges[u].push_back(v);
        }
    }

    solve();

    return 0;
}