#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

vector<set<int>> edges;
vector<int> times;
vector<bool> used;
int n, m, h;

int count(int v, vector<int> &cnt) {
    if (used[v])
        return cnt[v];
    used[v] = 1;
    cnt[v] = 1;
    for (auto &to: edges[v])
        cnt[v] += count(to, cnt);
    return cnt[v];
}

void collect(int v, vector<int> &vec) {
    used[v] = 1;
    vec.push_back(v);
    for (auto &to: edges[v])
        if (!used[to])
            collect(to, vec);
}

void solve() {
    vector<int> cnt(n, 0);
    for (int i = 0; i < n; i++)
        if (!used[i])
            count(i, cnt);
    used.assign(n, 0);
    int minpos = 0;
    for (int i = 1; i < n; i++)
        if (cnt[minpos] > cnt[i])
            minpos = i;
    vector<int> ans;
    collect(minpos, ans);
    cout << ans.size() << '\n';
    for (auto &it: ans)
        cout << it + 1 << ' ';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    cin >> n >> m >> h;

    edges.resize(n);
    times.resize(n);
    used.resize(n, 0);

    for (auto &it: times)
        cin >> it;

    while (m--) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        if ((times[u] + 1) % h == times[v]) {
            edges[u].insert(v);
        }
        if ((times[v] + 1) % h == times[u]) {
            edges[v].insert(u);
        }
    }

    solve();

    return 0;
}