#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 1e5 + 10;

int n, m, h;
int u[SZ];
vector<int> graph[SZ];
vector<int> antigraph[SZ];

int tout[SZ];
int t = 1;
int used[SZ];

vector<pair<int, int> > top_sort;

vector<int> composes[SZ];
int color[SZ];
int cnt_now = 0;

void dfs_for_tout(int v)
{
    used[v] = 1;
    for (int u : graph[v]) {
        if (used[v] == 0)
            dfs_for_tout(u);
    }
    tout[v] = t++;
}

void dfs_for_me(int v)
{
    used[v] = 2;
    color[v] = cnt_now;
    composes[cnt_now].push_back(v);
    for (int u : antigraph[v]) {
        if (used[u] == 1)
            dfs_for_me(u);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if ((u[a] + 1) % h == u[b]) {
            graph[a].push_back(b);
            antigraph[b].push_back(a);
        }
        if ((u[b] + 1) % h == u[a]) {
            graph[b].push_back(a);
            antigraph[a].push_back(b);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (used[i] == 0)
            dfs_for_tout(i);
    }
    for (int i = 1; i <= n; i++)
        top_sort.push_back({tout[i], i});
    sort(top_sort.begin(), top_sort.end());
    for (auto v : top_sort) {
        if (used[v.second] == 1) {
            dfs_for_me(v.second);
            cnt_now++;
        }
    }
    int ind = -1;
    for (int i = 1; i <= n; i++) {
        int sons_now = 0;
        for (auto v : graph[i]) {
            if (color[i] != color[v])
                sons_now++;
        }
        if (sons_now != 0)
            continue;
        if (ind == -1 || composes[color[i]].size() < composes[ind].size())
            ind = color[i];
    }
    cout << composes[ind].size() << "\n";
    for (auto x : composes[ind])
        cout << x << ' ';
    return 0;
}
