#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 1e5 + 10;

int n, m, h;
int u[SZ];
vector<int> graph[SZ];
vector<int> antigraph[SZ];

bool used[SZ];

vector<pair<int, int> > topsort;
int tout[SZ];
int t = 1;

vector<int> composes[SZ];
int color[SZ];
int cnt_now = 0;

void build_graphs()
{
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if ((u[a] + 1) % h == u[b]) {
            graph[a].push_back(b);
            antigraph[b].push_back(a);
        }
        if ((u[b] + 1) % h == u[a]) {
            graph[b].push_back(a);
            antigraph[a].push_back(b);
        }
    }
}

void dfs_for_tout(int v)
{
    used[v] = true;
    for (int u : graph[v]) {
        if (!used[u])
            dfs_for_tout(u);
    }
    tout[v] = t++;
}

void build_topsort()
{
    for (int i = 1; i <= n; i++)
        used[i] = false;
    for (int i = 1; i <= n; i++) {
        if (!used[i])
            dfs_for_tout(i);
    }
    for (int i = 1; i <= n; i++)
        topsort.push_back({tout[i], i});
    sort(topsort.begin(), topsort.end());
    reverse(topsort.begin(), topsort.end());
}

void dfs_for_comps(int v, int c)
{
    used[v] = true;
    color[v] = c;
    composes[c].push_back(v);
    for (auto u : antigraph[v]) {
        if (!used[u])
            dfs_for_comps(u, c);
    }
}

void build_composes()
{
    for (int i = 1; i <= n; i++)
        used[i] = false;
    cnt_now = 0;
    for (auto v : topsort) {
        if (!used[v.second])
            dfs_for_comps(v.second, cnt_now++);
    }
}

int get_ind()
{
    int ind = -1;
    for (int v = 1; v <= n; v++) {
        int sons = 0;
        for (auto u : graph[v]) {
            if (color[v] != color[u])
                sons++;
        }
        if (sons)
            continue;
        if (ind == -1 || composes[ind].size() > composes[color[v]].size())
            ind = color[v];
    }
    return ind;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
        cin >> u[i];
    build_graphs();
    build_topsort();
    build_composes();
    int res_ind = get_ind();
    cout << composes[res_ind].size() << "\n";
    for (auto v : composes[res_ind])
        cout << v << ' ';
    return 0;
}
