#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const ll SZ = 1e5 + 10;

ll p, n, d, b;
ll arr[SZ];

ll tree[SZ * 4];
ll sz = 1;

void build_tree()
{
    while (sz < n)
        sz <<= 1;
    for (ll i = 0; i < n; i++)
        tree[sz + i] = arr[i];
    for (ll i = sz - 1; i > 0; i--)
        tree[i] = tree[i * 2] + tree[i * 2 + 1];
}

ll get_sum(ll L, ll R)
{
    L += sz;
    R += sz;
    ll res = 0;
    while (L <= R) {
        if (L & 1)
            res += tree[L++];
        if (~R & 1)
            res += tree[R--];
        L >>= 1;
        R >>= 1;
    }
    return res;
}

void upd_elem(ll ind, ll x)
{
    ind += sz;
    tree[ind] = x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

void add_to_elem(ll ind, ll x)
{
    ind += sz;
    tree[ind] += x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

void action_p1()
{
    for (ll i = 0; i < n; i++)
        cin >> arr[i];
    build_tree();
    ll ind_now = 0;
    ll res = 0;
    for (ll i = 0; i < n; i++) {
        ind_now = max(ind_now, i + 1);
        ll g = min(i + d, n - 1);
        if (tree[sz + i] >= b) {
            add_to_elem(g, tree[sz + i] - b);
            upd_elem(i, b);
            continue;
        }
        else if (get_sum(i, g) < b) {
            add_to_elem(g, tree[sz + i]);
            upd_elem(i, 0);
            res++;
            continue;
        }
        else {
            while (tree[sz + i] < b) {
                ll how = min(b - tree[sz + i], tree[sz + ind_now]);
                add_to_elem(i, how);
                add_to_elem(ind_now, -how);
                if (tree[sz + ind_now] == 0)
                    ind_now++;
            }
        }
        d = min(d * 2, n - 1);
    }
    cout << res;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> p >> n >> d >> b;
    if (p == 1)
        action_p1();
    return 0;
}
