#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const ll SZ = 1e5 + 10;

ll p, n, d, b;
ll arr[SZ];

ll tree[SZ * 4];
ll sz = 1;

void build_tree()
{
    while (sz < n)
        sz <<= 1;
    for (ll i = 0; i < n; i++)
        tree[sz + i] = arr[i];
    for (ll i = sz - 1; i > 0; i--)
        tree[i] = tree[i * 2] + tree[i * 2 + 1];
}

ll get_sum(ll L, ll R)
{
    L += sz;
    R += sz;
    ll res = 0;
    while (L <= R) {
        if (L & 1)
            res += tree[L++];
        if (~R & 1)
            res += tree[R--];
        L >>= 1;
        R >>= 1;
    }
    return res;
}

void upd_elem(ll ind, ll x)
{
    ind += sz;
    tree[ind] = x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

void add_to_elem(ll ind, ll x)
{
    ind += sz;
    tree[ind] += x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

ll elem(ll ind)
{
    return tree[sz + ind];
}

void action_p1()
{
    ll res = 0;
    ll ind_now = 0;
    for (ll i = 0; i < n; i++) {
        ind_now = max(ind_now, i + 1);
        ll g = min(i + d, n - 1);
        if (elem(i) > b) {
            add_to_elem(g, elem(i) - b);
            upd_elem(i, b);
            continue;
        }
        if (get_sum(i, g) < b) {
            add_to_elem(g, elem(i));
            upd_elem(i, 0);
            res++;
            continue;
        }
        while (elem(i) < b) {
            ll how = min(b - elem(i), elem(ind_now));
            add_to_elem(i, how);
            add_to_elem(ind_now, -how);
            if (elem(ind_now) == 0)
                ind_now++;
        }
        d *= 2;
        d = min(d, n - 1);
    }
    cout << res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> p >> n >> d >> b;
    for (ll i = 0; i < n; i++)
        cin >> arr[i];
    build_tree();
    if (p == 1)
        action_p1();
    return 0;
}
