#include <iostream>

using namespace std;

typedef long long ll;

const ll SZ = 1e5 + 10;

ll p, n, d, b;

ll tree[SZ * 4];
ll sz = 1;

void build_tree()
{
    while (sz < n)
        sz <<= 1;
    for (ll i = 0; i < n; i++)
        cin >> tree[sz + i];
    for (ll i = sz - 1; i > 0; i--)
        tree[i] = tree[i * 2] + tree[i * 2 + 1];
}

void upd_elem(ll ind, ll x)
{
    ind += sz;
    tree[ind] = x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

void add_to_elem(ll ind, ll x)
{
    ind += sz;
    tree[ind] += x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

ll get_sum(ll L, ll R)
{
    L += sz;
    R += sz;
    ll res = 0;
    while (L <= R) {
        if (L & 1)
            res += tree[L++];
        if (~R & 1)
            res += tree[R--];
        L >>= 1;
        R >>= 1;
    }
    return res;
}

ll elem(ll ind)
{
    return tree[sz + ind];
}

bool save_left(ll ind, ll &ind_L)
{
    ll L = max(0LL, ind - d);
    ll R = min(n - 1, ind + d);
    if (get_sum(L, R) < b)
        return false;
    ind_L = max(ind_L, L);
    while(elem(ind) < b) {
        if (ind_L == ind)
            ind_L++;
        ll how = min(b - elem(ind), elem(ind_L));
        add_to_elem(ind, how);
        add_to_elem(ind_L, -how);
        if (elem(ind_L) == 0)
            ind_L++;
    }
    add_to_elem(ind, -b);
    return true;
}

bool save_right(ll ind, ll &ind_R)
{
    ll L = max(0LL, ind - d);
    ll R = min(n - 1, ind + d);
    if (get_sum(L, R) < b)
        return false;
    ind_R = min(ind_R, R);
    while (elem(ind) < b) {
        if (ind_R == ind)
            ind_R--;
        ll how = min(b - elem(ind), elem(ind_R));
        add_to_elem(ind, how);
        add_to_elem(ind_R, -how);
        if (elem(ind_R) == 0)
            ind_R--;
    }
    add_to_elem(ind, -b);
    return true;
}

void action_p1()
{
    ll ans = 0;
    ll d_start = d;
    ll ind_now = 0;
    for (ll i = 0; i < n; i++) {
        if (!save_left(i, ind_now)) {
            ans++;
        }
        d += d_start;
    }
    cout << ans;
}

void action_p2()
{
    ll ans_L = 0, ans_R = 0;
    ll d_start = d;
    ll ind_L = 0, ind_R = n - 1;
    for (ll i = 0; i < n / 2; i++) {
        if (ans_L > ans_R) {
            if (!save_left(i, ind_L))
                ans_L++;
            if (!save_right(n - i - 1, ind_R))
                ans_R++;
        }
        else {
            if (!save_right(n - i - 1, ind_R))
                ans_R++;
            if (!save_left(i, ind_L))
                ans_L++;
        }
        d += d_start;
    }
    cout << max(ans_L, ans_R);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> p >> n >> d >> b;
    build_tree();
    if (p == 1)
        action_p1();
    else
        action_p2();
    return 0;
}
