#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 10;
const int inf = 1e9;

int t[maxn];
vector<vector<int> > g(maxn);

vector<int> top;
bool used1[maxn] = {};
void dfs1(int v) {
    used1[v] = 1;
    for (int to : g[v]) {
        if (!used1[to]) {
            dfs1(to);
        }
    }
    top.push_back(v);
}

int cnt = 0;
vector<int> mas(1, 0);
int color[maxn] = {};
void dfs2(int v, int & sz) {
    color[v] = cnt;
    sz++;
    for (int to : g[v]) {
        if (color[to] == 0) {
            dfs2(to, sz);
        }
    }
}

bool good[maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, m, h;
    cin >> n >> m >> h;
    assert(h > 1);
    for (int i = 1; i <= n; ++i) {
        cin >> t[i];
        assert(t[i] < h);
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        assert(a <= n && b <= n);
        if ((t[a] + 1) % h == t[b]) {
            g[a].push_back(b);
        }
        if ((t[b] + 1) % h == t[a]) {
            g[b].push_back(a);
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!used1[i]) {
            dfs1(i);
        }
    }
    for (int i : top) {
        if (color[i] == 0) {
            cnt++;
            int sz = 0;
            dfs2(i, sz);
            mas.push_back(sz);
            assert(cnt == (int)mas.size() - 1);
        }
    }
    for (int i = 0; i < maxn; ++i)
        good[i] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int to : g[i]) {
            if (color[i] != color[to])
                good[color[i]] = 0;
        }
    }
    pair<int, int> ans = {inf, 0};
    for (int i = 1; i < (int)mas.size(); ++i) {
        if (good[i] == 1) {
            ans = min(ans, {mas[i], i});
        }
    }
    assert(ans.first != inf);
    cout << ans.first << '\n';
    for (int i = 1; i <= n; ++i) {
        if (color[i] == ans.second) {
            cout << i << ' ';
        }
    }
    return 0;
}
/*
3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
