#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define endl '\n'

vector<int> used;
vector<vector<int> > grph;
vector<vector<int> > t_grph;
int n;
vector<vector<int> > comp;
vector<vector<int> > new_grph;
vector<int> comp_num;
int comp_kol = 0;


int dfs(int v) {
	used[v] = 1;;
	for (auto u : new_grph[v]) {
		if (!used[u]) {
			dfs(u);
		}
		used[v] += used[u];
	}
	return used[v];
}

vector<bool> used_kond;
vector<int> tout;
int timer = 0;

void dfs_kond(int v) {
	used_kond[v] = true;
	for (auto u : grph[v]) {
		if (!used_kond[v]) {
			dfs_kond(u);
		}
	}
	tout[v] = timer++;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
	return a.first > b.first || (a.first == b.first && a.first < b.first);
}

void dfs_kond2(int v, int num) {
	used_kond[v] = true;
	comp_num[v] = num;
	comp[num].push_back(v);
	for (auto u : t_grph[v]) {
		if (!used_kond[u]) {
			dfs_kond2(u, num);
		}
	}
	return;
}

void kond() {
	used_kond.resize(n);
	tout.resize(n);
	for (int i = 0; i < n; i++) {
		if (!used_kond[i]) {
			dfs_kond(i);
		}
	}

	vector<pair<int, int> > order;
	for (int i = 0; i < n; i++) {
		order.push_back({ tout[i], i });
	}

	sort(order.begin(), order.end(), cmp);
	used_kond.clear();
	used_kond.resize(n);
	comp_num.resize(n);
	for (int i = 0; i < order.size(); i++) {
		if (!used_kond[i]) {
			comp.resize(comp.size() + 1);
			dfs_kond2(i, comp_kol);
			comp_kol++;
		}
	}

	new_grph.resize(comp.size());
	for (int i = 0; i < comp.size(); i++) {
		for (auto v : comp[i]) {
			for (auto to : grph[v]) {
				if (comp_num[to] != i) {
					new_grph[i].push_back(comp_num[to]);
				}
			}
		}
	}
	return;
}

vector<int> ans;
vector<bool> used_last;

void dfs_last(int v) {
	used_last[v] = true;
	ans.push_back(v + 1);
	for (auto u : grph[v]) {
		if (!used_last[u]) {
			dfs_last(u);
		}
	}
	return;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int m, h;
	cin >> n >> m >> h;

	vector<int> hour(n);
	for (int i = 0; i < n; i++) {
		cin >> hour[i];
	}

	int a, b;
	grph.resize(n);
	t_grph.resize(n);
	for (int i = 0; i < m; i++) {
		cin >> a >> b;
		a--;
		b--;
		if ((hour[a] + 1) % h == hour[b]) {
			grph[a].push_back(b);
			t_grph[b].push_back(a);
		}
		if ((hour[b] + 1) % h == hour[a]) {
			grph[b].push_back(a);
			t_grph[a].push_back(b);
		}
	}

	kond();
	int mn = -1;
	int mn_comp;
	used.resize(n);
	for (int i = 0; i < comp.size(); i++) {
		auto tim = dfs(i);
		if (tim < mn || mn == -1) {
			mn = tim;
			mn_comp = i;
		}
	}

	used_last.resize(n);
	dfs_last(comp[mn_comp][0]);
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}
}