#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-6;

vector <int> a;
int n, m, h;
vector <vector <int> > gr, rev_gr;
vector <int> color;
vector <int> tout, used;

void dfs(int v) {
    if (used[v]) return;
    used[v] = 1;
    for (int u : gr[v]) {
        dfs(u);
    }
    tout.push_back(v);
}

void dfs(int v, int col) {
    if (color[v] != -1) return;
    color[v] = col;
    for (int u : rev_gr[v]) {
        dfs(u, col);
    }
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    cin >> n >> m >> h;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    rev_gr.resize(n);
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (a[v] == (a[u] + 1) % h) {
            gr[u].push_back(v);
            rev_gr[v].push_back(u);
        }
        if (a[u] == (a[v] + 1) % h) {
            gr[v].push_back(u);
            rev_gr[u].push_back(v);
        }
    }
    used.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        dfs(i);
    }
    reverse(tout.begin(), tout.end());
    color.resize(n, -1);
    int col = 0;
    for (int v : tout) {
        if (color[v] != -1) continue;
        dfs(v, col++);
    }
    vector <int> cntE(col, 0), cntV(col, 0);
    for (int v = 0; v < n; v++) {
        cntV[color[v]]++;
        for (int u : gr[v]) {
            if (color[v] == color[u]) continue;
            cntE[color[v]]++;
        }
    }
//    for (int i = 0; i < n; i++) {
//        cout << color[i] << " ";
//    }
//    cout << "\n";
    int res = INF, pos = -1;
    for (int i = 0; i < col; i++) {
        if (cntE[i]) continue;
        if (res > cntV[i]) {
            res = cntV[i];
            pos = i;
        }
    }
    cout << res << "\n";
    for (int i = 0; i < n; i++) {
        if (color[i] == pos) {
            cout << i + 1 << " ";
        }
    }
}
