#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e8 + 7;
const ll MAXN = 1e6 + 7;
const double EPS = 1e-6;

struct TNode {
    ll x, y;
    TNode *left, *right;
    ll val, sum;
};

TNode *new_node(ll x, ll val) {
    return new TNode({x, rand(), nullptr, nullptr, val, val});
}

ll safe_sum(TNode *root) {
    return (root ? root->sum : 0);
}

void relax(TNode *root) {
    root->sum = safe_sum(root->left) + safe_sum(root->right) + root->val;
}

TNode *merge(TNode *left, TNode *right) {
    if (!left) {
        return right;
    }
    if (!right) {
        return left;
    }
    if (left->y > right->y) {
        left->right = merge(left->right, right);
        relax(left);
        return left;
    } else {
        right->left = merge(left, right->left);
        relax(right);
        return right;
    }
}

pair <TNode*, TNode*> split(TNode *root, ll x) {
    if (!root) {
        return {nullptr, nullptr};
    }
    if (root->x > x) {
        auto p = split(root->left, x);
        root->left = p.second;
        relax(root);
        return {p.first, root};
    } else {
        auto p = split(root->right, x);
        root->right = p.first;
        relax(root);
        return {root, p.second};
    }
}

TNode *insert(TNode *root, ll x, ll val) {
    TNode *node = new_node(x, val);
    auto p = split(root, x);
    return merge(p.first, merge(node, p.second));
}

TNode *erase(TNode *root, ll x) {
    auto p1 = split(root, x);
    auto p2 = split(p1.first, x - 1);
    return merge(p2.first, p1.second);
}

ll find_left(TNode *root) {
    if (!root->left) {
        return root->x;
    }
    return find_left(root->left);
}

void print1(TNode *root) {
    if (!root) {
        return;
    }
    print1(root->left);
    cout << root->x << " ";
    print1(root->right);
}

void print(TNode *root) {
    print1(root);
    cout << "\n";
}

void solve() {
    ll n, d, b;
    cin >> n >> d >> b;
    vector <ll> a(n);
    TNode *root = nullptr;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        root = insert(root, i, a[i]);
    }
    ll res = 0;
    for (ll i = 0; i < n; i++) {
        ll mpos = (i + 1) * d + i;
        //print(root);
        auto t = split(root, mpos);
        if (safe_sum(t.first) < b) {
            res++;
            root = merge(t.first, t.second);
            continue;
        }
        root = merge(t.first, t.second);
        root = erase(root, i);
        if (a[i] >= b) {
            a[i] -= b;
            if (a[i]) {
                root = insert(root, i, a[i]);
            }
            continue;
        }
        while (true) {
            ll x = find_left(root);
            root = erase(root, x);
            if (a[x] + a[i] < b) {
                a[i] += a[x];
                a[x] = 0;
            } else {
                a[x] -= b - a[i];
                a[i] = b;
                if (a[x]) {
                    root = insert(root, x, a[x]);
                }
                break;
            }
        }
    }
    cout << res << "\n";
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    ll p;
    cin >> p;
    if (p == 1) {
        solve();
        return 0;
    }
}
