#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e8 + 7;
const ll MAXN = 1e6 + 7;
const double EPS = 1e-6;

struct TNode {
    ll L, R;
    TNode *left, *right;
    ll sum;
};

TNode *new_node(ll L, ll R) {
    return new TNode({L, R, nullptr, nullptr, 0});
}

ll safe_sum(TNode *root) {
    return (root ? root->sum : 0);
}

void relax(TNode *root) {
    if (!root) return;
    root->sum = safe_sum(root->left) + safe_sum(root->right);
}

vector <ll> a;

TNode *build_tree(ll L, ll R) {
    TNode *root = new_node(L, R);
    if (R - L == 1) {
        root->sum = a[L];
    } else {
        ll M = (L + R) / 2;
        root->left = build_tree(L, M);
        root->right = build_tree(M, R);
        relax(root);
    }
    return root;
}

void change(TNode *root, ll p, ll x) {
    if (root->L > p || root->R <= p) {
        return;
    }
    if (root->R - root->L == 1) {
        root->sum = x;
        return;
    }
    change(root->left, p, x);
    change(root->right, p, x);
    relax(root);
}

ll get_sum(TNode *root, ll L, ll R) {
    if (root->L >= R || L >= root->R) {
        return 0;
    }
    if (L <= root->L && root->R <= R) {
        return root->sum;
    }
    return get_sum(root->left, L, R) + get_sum(root->right, L, R);
}

ll find_left(TNode *root) {
    if (root->R - root->L == 1) {
        return root->L;
    }
    if (safe_sum(root->left) > 0) {
        return find_left(root->left);
    }
    return find_left(root->right);
}

ll find_right(TNode *root) {
    if (root->R - root->L == 1) {
        return root->L;
    }
    if (safe_sum(root->right) > 0) {
        return find_right(root->right);
    }
    return find_right(root->left);
}

ll n, d, b;

void go(TNode *root, ll i, bool left) {
    change(root, i, 0);
    if (a[i] >= b) {
        a[i] -= b;
        if (a[i]) {
            change(root, i, a[i]);
        }
        return;
    }
    while (true) {
        ll pos = (left ? find_left(root) : find_right(root));
        change(root, pos, 0);
        if (a[pos] + a[i] < b) {
            a[i] += a[pos];
            a[pos] = 0;
        } else {
            a[pos] -= b - a[i];
            a[i] = b;
            if (a[pos]) {
                change(root, pos, a[pos]);
            }
            break;
        }
    }
}

void solve() {
    cin >> n >> d >> b;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    TNode *root = build_tree(0, n);
    ll res = 0;
    for (ll i = 0; i < n; i++) {
        ll mpos = (i + 1) * d + i;
        if (get_sum(root, 0, mpos + 1) < b) {
            res++;
            continue;
        }
        go(root, i, true);
    }
    cout << res << "\n";
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    srand(time(0));
    ll p;
    cin >> p;
    if (p == 1) {
        solve();
        return 0;
    }
    cin >> n >> d >> b;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll res = 0;
    TNode *root = build_tree(0, n);
    for (ll i = 0; i < n / 2; i++) {
        ll pos1 = (i + 1) * d + i;
        ll pos2 = (n - 1 - i) - (i + 1) * d;
        if (pos1 < pos2) {
            if (get_sum(root, 0, pos1 + 1) < b || get_sum(root, pos2 + 1, INF) < b) {
                res++;
            } else {
                go(root, i, true);
                go(root, n - 1 - i, false);
            }
        } else {
            ll p1 = pos2 - 1;
            ll p2 = pos1 + 1;
            ll nd1 = max(b - get_sum(root, 0, p1 + 1), 0LL);
            ll nd2 = max(b - get_sum(root, p2, INF), 0LL);
            ll mid = get_sum(root, p1 + 1, p2);
            if (mid >= nd1 + nd2) {
                go(root, i, true);
                go(root, n - 1 - i, false);
                continue;
            } else {
                res++;
            }
        }
    }
    cout << res << "\n";
}
