#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

vector<vector<int> > g, gr;
vector<int> order, component;
vector<char> used;

void dfs1(int v) {
	used[v] = true;
	for (size_t i = 0; i<g[v].size(); ++i)
		if (!used[g[v][i]])
			dfs1(g[v][i]);
	order.push_back(v);
}

void dfs2(int v) {
	used[v] = true;
	component.push_back(v);
	for (size_t i = 0; i<gr[v].size(); ++i)
		if (!used[gr[v][i]])
			dfs2(gr[v][i]);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> pos(n);
	g.resize(n);
	gr.resize(n);
	used.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> pos[i];
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if ((pos[a] + 1) % h == pos[b]) {
			g[a].push_back(b);
			gr[b].push_back(a);
		}
		if ((pos[b] + 1) % h == pos[a]) {
			g[b].push_back(a);
			gr[a].push_back(b);
		}
	}
	used.assign(n, false);
	for (int i = 0; i<n; ++i)
		if (!used[i])
			dfs1(i);
	used.assign(n, false);
	vector<vector<int> > components;
	vector<int> color(n, 0);
	
	for (int i = 0; i < n; ++i) {
		int v = order[n - 1 - i];
		if (!used[v]) {
			dfs2(v);
			components.push_back(component);
			for (int a : component)
				color[a] = i;
			component.clear();
		}
	}

	int res = 0;
	for (int i = 1; i < components.size(); ++i) {
		char flag = 1;
		for (int v : components[i])
			for (int to : g[v])
				if (color[to] != color[v])
					flag = 0;
		if (flag && components[res].size() > components[i].size()) {
			res = i;
		}
	}
	cout << components[res].size() << '\n';
	for (int a : components[res])
		cout << a + 1 << ' ';

#ifndef ONLINE_JUDGE
	cout << '\n';
	cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

