#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

void build_pref(vector<ll> &v, vector<ll> &pref) {
	pref.resize(v.size() + 1);
	for (int i = 0; i < v.size(); ++i)
		pref[i + 1] = pref[i] + v[i];
}

ll get(int l, int r, vector<ll>& pref) {
	return pref[r + 1] - pref[l];
}

ll solve1(vector<ll>& v, int n, int b, int d, int spec = -1) {
	vector<ll> pref;
	build_pref(v, pref);
	ll res = 0;
	int pos = 0;
	ll sum = get(0, d, pref);
	int to = v.size();
	if (spec != -1)
		to = spec;
	for (int i = 0; i < to; ++i) {
		if (sum < b)
			res++;
		else
			sum -= b;
		pos = min(pos + d + 1, (int)v.size());
		sum += get(pos, min(pos + d, (int)v.size() - 1), pref);
	}
	return res;
}

void solve2() {
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	if (p == 1) {
		cout << solve1(v, n, b, d) << endl;
		return;
	}
	ll res = n;
	vector<ll> pref(n, 0), suf = v;
	reverse(suf.begin(), suf.end());
	for (int i = 0; i < n; ++i) {
		for (int val = 0; val <= v[i]; ++val) {
			pref[i] = val, suf[n - i - 1] = v[i] - val;
			ll e = solve1(pref, pref.size(), b, d, (n + 1) / 2);
			ll f = solve1(suf, suf.size(), b, d, n / 2);
			res = min((ll)res, max(e, f));
		}
	}
	cout << res;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve2();
#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

