#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

void build_pref(vector<ll> &v, vector<ll> &pref) {
	pref.resize(v.size() + 1);
	for (int i = 0; i < v.size(); ++i)
		pref[i + 1] = pref[i] + v[i];
}

ll get(int l, int r, vector<ll>& pref) {
	return pref[r + 1] - pref[l];
}

int p, n, d, b;
vector<ll> v;

ll solve1(vector<ll> &vec, int spec = -1) {
	vector<ll> pref;
	build_pref(vec, pref);
	ll res = 0;
	int pos = 0;
	ll sum = get(0, d, pref);
	int to = vec.size();
	if (spec != -1)
		to = spec;
	for (int i = 0; i < to; ++i) {
		if (sum < b)
			res++;
		else
			sum -= b;
		pos = min(pos + d + 1, (int)vec.size());
		sum += get(pos, min(pos + d, (int)vec.size() - 1), pref);
	}
	return res;
}


ll f(ll val) {
	vector<ll> pref(n), suf(n);
	ll cursum = val;
	for (int i = 0; i < n; ++i) {
		ll add = min(cursum, v[i]);
		pref[i] += add;
		cursum -= add;
		suf[n - i - 1] += (v[i] - add);
	}
	return max(solve1(pref, n / 2 + 1), solve1(suf, n / 2));
}

ll ter(ll l, ll r) {
	int it = 30;
	while (it != 0) {
		it--;
		ll m1 = l + (r - l) / 3;
		ll m2 = r - (r - l) / 3;
 		if (f(m1) > f(m2))
			l = m1;
		else
			r = m2;
	}
	ll res = f(r);
	while (l != r) {
		res = min(res, f(l));
		l++;
	}
	return res;
}


void solve2() {
	cin >> p >> n >> d >> b;
	v.resize(n);
	ll allsum = 0;
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
		allsum += v[i];
	}
	if (p == 1) {
		cout << solve1(v) << endl;
		return;
	}
	cout << ter(0, allsum);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve2();
#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

