#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <time.h>
#include <string>
#include <random>
#include <algorithm>
#include <bitset>

using namespace std;

const int MAXN = 1e5 + 7;

int t[MAXN];
bool used[MAXN];
vector <int> g[MAXN], ng[MAXN];

void dfs(int u) {
	used[u] = true;
	for (int v : ng[u]) {
		if (!used[v]) dfs(v);
	}
}

signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;

	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u - 1].push_back(v - 1);
		g[v - 1].push_back(u - 1);
	}

	for (int u = 0; u < n; ++u) {
		for (int v : g[u]) {
			if (t[v] == (t[u] + 1) % h) ng[u].push_back(v);
		}
	}

	vector <int> best;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) used[j] = false;

		dfs(i);

		vector <int> newans;
		for (int j = 0; j < n; ++j) {
			if (used[j]) newans.push_back(j);
		}

		if (best.empty() || newans.size() < best.size()) best = newans;
	}

	cout << best.size() << '\n';
	for (int elem : best) {
		cout << elem + 1 << ' ';
	}
	cout << '\n';

	return 0;
}