#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <time.h>
#include <string>
#include <random>
#include <algorithm>
#include <bitset>

using namespace std;

const int MAXN = 2e5 + 7;
const int INF = 1e9 + 7;

int t[MAXN];
set <int> mslgbt[MAXN];
vector <int> g[MAXN], ng[MAXN], rg[MAXN], lgbt[MAXN];
vector <int> comp[MAXN];

vector <int> topsort;
bool used1[MAXN];
void dfs1(int u) {
	used1[u] = true;
	for (int v : ng[u]) {
		if (!used1[v]) dfs1(v);
	}
	topsort.push_back(u);
}

int num = 0;
int color[MAXN];
bool used2[MAXN];
void dfs2(int u) {
	color[u] = num;
	used2[u] = true;
	comp[num].push_back(u);
	for (int v : rg[u]) {
		if (!used2[v]) dfs2(v);
	}
}

int cnt[MAXN];
bool used3[MAXN];
void dfs3(int u) {
	used3[u] = true;
	cnt[u] = comp[u].size();
	for (int v : lgbt[u]) {
		if (!used3[v]) dfs3(v);
		cnt[u] += cnt[v];
	}
}

vector <int> ans;
bool used4[MAXN];
void dfs4(int u) {
	used4[u] = true;
	for (int elem : comp[u]) ans.push_back(elem);
	for (int v : lgbt[u]) {
		if (!used4[v]) dfs4(v);
	}
}

signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;

	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u - 1].push_back(v - 1);
		g[v - 1].push_back(u - 1);
	}

	for (int u = 0; u < n; ++u) {
		for (int v : g[u]) {
			if (t[v] == (t[u] + 1) % h) {
				ng[u].push_back(v);
				rg[v].push_back(u);
			}
		}
	}

	for (int u = 0; u < n; ++u) {
		if (!used1[u]) dfs1(u);
	}
	reverse(topsort.begin(), topsort.end());

	for (int u : topsort) {
		if (!used2[u]) {
			dfs2(u);
			++num;
		}
	}

	for (int u = 0; u < n; ++u) {
		for (int v : ng[u]) {
			if (color[u] == color[v]) continue;
			mslgbt[color[u]].insert(color[v]);
		}
	}

	for (int u = 0; u < num; ++u) {
		for (int v : mslgbt[u]) {
			lgbt[u].push_back(v);
		}
	}

	for (int u = 0; u < num; ++u) {
		if (!used3[u]) dfs3(u);
	}

	int best = 0;
	for (int u = 0; u < num; ++u) {
		if (cnt[u] < cnt[best]) best = u;
	}

	dfs4(best);

	if (ans.size() != cnt[best]) return 1;

	cout << ans.size() << '\n';
	for (int elem : ans) {
		cout << elem + 1 << ' ';
	}
	cout << '\n';

	return 0;
}