#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>
#include <cstdio>

using namespace std;

const int MAXN = 2e5;
const int INF = 1e9;

int n, m, h;
int u[MAXN];

int get(int id) { return (u[id] + 1) % h; }

vector <int> gr[MAXN];
int tin[MAXN];
int c[MAXN];

vector <int> t;
vector <int> up;
void dfs(int v) {
    t.push_back(v);
    tin[v] = (int)t.size() - 1;
    up.push_back(tin[v]);
    c[v] = 1;
    for (int i = 0; i < (int)gr[v].size(); i++) {
        int to = gr[v][i];
        if (!c[to])
            dfs(to);
        if (c[to] == 1)
            up[tin[v]] = min(up[tin[v]], tin[to]);
    }
    c[v] = 2;
}

int color[MAXN], sz_[MAXN];
int deg[MAXN];

int main() {
    assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--, b--;
        assert(u[a] != u[b]);
        if (get(a) == u[b])
            gr[a].push_back(b);
        if (u[a] == get(b))
            gr[b].push_back(a);
    }

    fill(c, c + MAXN, 0);

    for (int i = 0; i < n; i++)
        if (!c[i])
            dfs(i);

    int lastcolor = 0;
    for (int i = (int)t.size() - 1; i >= 0; i--) {
        int u = i;
        int last = up[i];
        color[t[i]] = lastcolor++;
        int sz = 1;
        while (i > 0 && i - 1 >= last) {
            i--;
            last = min(last, up[i]);
            color[t[i]] = color[t[i + 1]];
            sz++;
        }
        sz_[color[t[i]]] = sz;
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < (int)gr[i].size(); j++)
            if (color[i] != color[gr[i][j]])
                deg[color[i]]++;

    int res = INF, resc = -1;
    for (int i = 0; i < lastcolor; i++)
        if (deg[i] == 0 && res > sz_[i]) {
            res = sz_[i];
            resc = i;
        }

    cout << res << endl;
    for (int i = 0; i < n; i++)
        if (color[i] == resc)
            cout << i + 1 << " ";
    cout << endl;

    return 0;
}
