#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>
#include <cstdio>

using namespace std;

const int MAXN = 2e5;
const int INF = 1e9;

int n, m, h;
int u[MAXN];

int get_(int id) { return (u[id] + 1) % h; }

vector <int> gr[MAXN];
int tin[MAXN];
int c[MAXN];

vector <int> t;

int parent[MAXN];
int sz[MAXN];

void init() {
    for (int i = 0; i < n; i++)
        parent[i] = i, sz[i] = 1;
}

int get(int v) {
    if (parent[v] == v)
        return v;
    return parent[v] = get(parent[v]);
}

void merge(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (sz[u] > sz[v])
        swap(u, v);
    parent[u] = v;
    sz[v] += sz[u];
}

void dfs(int v) {
    t.push_back(v);
    c[v] = 1;
    for (int i = 0; i < (int)gr[v].size(); i++) {
        int to = get(gr[v][i]);
        if (!c[to])
            dfs(to);
        if (c[to] == 1) {
            while (get(t.back()) != get(to)) {
                merge(t.back(), to);
                t.pop_back();
            }
        }
    }
    c[get(v)] = 2;
    t.pop_back();
}

int color[MAXN], sz_[MAXN];
int deg[MAXN];

int main() {
    assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    init();

    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--, b--;
        assert(u[a] != u[b]);
        if (get_(a) == u[b]) {
            gr[a].push_back(b);
        }
        if (u[a] == get_(b)) {
            gr[b].push_back(a);
        }
    }

    fill(c, c + MAXN, 0);

    for (int i = 0; i < n; i++)
        if (!c[i])
            dfs(i);

    for (int i = 0; i < n; i++) {
        color[i] = get(i);
        sz_[color[i]]++;
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < (int)gr[i].size(); j++)
            if (color[i] != color[gr[i][j]])
                deg[color[i]]++;

    int res = INF, resc = -1;
    for (int i = 0; i < n; i++)
        if (deg[color[i]] == 0 && res > sz_[color[i]]) {
            res = sz_[color[i]];
            resc = color[i];
        }

    cout << res << endl;
    for (int i = 0; i < n; i++)
        if (color[i] == resc)
            cout << i + 1 << " ";
    cout << endl;

    return 0;
}
