#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>
#include <cstdio>

using namespace std;

const int MAXN = 2e5;
const int INF = 1e9;

int n, m, h;
int u[MAXN];

int get_(int id) { return (u[id] + 1) % h; }

bool was[MAXN];
vector <int> t;
vector <int> gr[MAXN];

int dfs(int v) {
    was[v] = true;
    t.push_back(v);
    int res = 1;
    for (int i = 0; i < (int)gr[v].size(); i++)
        if (!was[gr[v][i]])
            res += dfs(gr[v][i]);
    return res;
}

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--, b--;
        assert(u[a] != u[b]);
        if (get_(a) == u[b])
            gr[a].push_back(b);
        if (u[a] == get_(b))
            gr[b].push_back(a);
    }

    int res = INF;
    vector <int> resv = {};
    for (int i = 0; i < n; i++) {
        fill(was, was + n, false);
        t.clear();
        int cur = dfs(i);
        if (cur < res) {
            res = cur, resv = t;
        }
    }

    cout << res << endl;
    for (int i = 0; i < (int)resv.size(); i++)
        cout << resv[i] + 1 << " ";
    cout << endl;

    return 0;
}
