#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>
#include <cstdio>

using namespace std;

const int MAXN = 2e5;
const int INF = 1e9;

int n, m, h;
int u[MAXN];

int get_(int id) { return (u[id] + 1) % h; }

vector <int> gr[MAXN];
int color[MAXN];
int sz[MAXN], deg[MAXN];

//
vector <int> t;
int tout[MAXN];
bool was[MAXN];
void dfs(int v) {
    was[v] = true;
    for (int i = 0; i < (int)gr[v].size(); i++) {
        int to = gr[v][i];
        if (!was[to])
            dfs(to);
    }
    t.push_back(v);
    tout[v] = (int)t.size() - 1;
}
//

int main() {
    assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--, b--;
        assert(u[a] != u[b]);
        if (get_(a) == u[b])
            gr[a].push_back(b);
        if (u[a] == get_(b))
            gr[b].push_back(a);
    }

    //
    fill(was, was + n, false);
    for (int i = 0; i < n; i++)
        if (!was[i])
            dfs(i);

    int up = 0;
    int c = 0;
    for (int i = 0; i < (int)t.size(); i++) {
        int v = t[i];
        if (up < i)
            c++;
        up = max(up, i);
        for (int j = 0; j < (int)gr[v].size(); j++) {
            int to = gr[v][j];
            up = max(up, tout[to]);
        }
        color[v] = c;
    }
    //

    for (int i = 0; i < n; i++)
        sz[color[i]]++;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < (int)gr[i].size(); j++) {
            if (color[i] != color[gr[i][j]])
                deg[color[i]]++;
        }

    int res = INF, resc = -1;
    for (int i = 0; i < n; i++)
        if (deg[color[i]] == 0 && sz[color[i]] < res) {
            res = sz[color[i]];
            resc = color[i];
        }

    cout << res << endl;
    for (int i = 0; i < n; i++)
        if (color[i] == resc)
            cout << i + 1 << " ";
    cout << endl;

    return 0;
}
