#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


vector<vector<int>> graph, depend;
vector<int> used;


void dfs(int n, vector<int> &comp) {
	used[n] = true;
	comp.push_back(n);

	for (int v : depend[n]) {
		if (!used[v]) {
			dfs(v, comp);
		}
	}
}


int main() {
	int n, m, h;
	cin >> n >> m >> h;

	vector<int> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	graph.resize(n);
	int from, to;
	for (int i = 0; i < m; ++i) {
		cin >> from >> to;
		--from;
		--to;

		graph[from].push_back(to);
		graph[to].push_back(from);
	}

	depend.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int v : graph[i]) {
			if ((t[i] + 1) % h == t[v]) {
				depend[i].push_back(v);
			}
		}

		if (depend.empty()) {
			cout << 1 << '\n' << i + 1;

			return 0;
		}
	}

	used.resize(n);

	vector<int> comp;

	int min_size = 1000000;
	vector<int> min_comp;

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i, comp);
		}

		if (comp.size() < min_size) {
			min_size = comp.size();
			min_comp = comp;
		}
	}

	cout << min_comp.size() << '\n';
	for (int i : min_comp) {
		cout << i + 1 << ' ';
	}

    return 0;
}