#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


vector<vector<int>> graph, depend, p;
vector<int> used;


void burn(int n) {
	used[n] = true;

	for (int v : depend[n]) {
		if (!used[v]) {
			bool to_burn = true;
			for (int pr : p[v]) {
				if (!used[pr]) {
					to_burn = false;
				}
			}

			if (to_burn) {
				burn(v);
			}
		}
	}
}


void dfs(int n, vector<int> &comp) {
	used[n] = true;

	comp.push_back(n);

	for (int v : depend[n]) {
		if (!used[v]) {
			dfs(v, comp);
		}
	}
}


int main() {
	int n, m, h;
	cin >> n >> m >> h;

	depend.resize(n);
	p.resize(n);
	int from, to;
	for (int i = 0; i < m; ++i) {
		cin >> from >> to;
		--from;
		--to;

		depend[from].push_back(to);
		p[to].push_back(from);
	}

	/*
	vector<int> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	
	graph.resize(n);
	int from, to;
	for (int i = 0; i < m; ++i) {
		cin >> from >> to;
		--from;
		--to;

		graph[from].push_back(to);
		graph[to].push_back(from);
	}

	depend.resize(n);
	p.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int v : graph[i]) {
			if ((t[i] + 1) % h == t[v]) {
				depend[i].push_back(v);
				p[v].push_back(i);
			}
		}

		if (depend[i].empty()) {
			cout << 1 << '\n' << i + 1;

			return 0;
		}
	}
	*/

	used.resize(n);

	vector<int> comp;

	int min_size = 1000000;
	vector<int> min_comp;

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			bool to_burn = true;
			for (int pr : p[i]) {
				if (!used[pr]) {
					to_burn = false;
				}
			}

			if (to_burn) {
				burn(i);
			}
		}
	}

	vector<int> fused = used;

	for (int i = 0; i < n; ++i) {
		if (!fused[i]) {
			used.assign(n, 0);
			dfs(i, comp);
		}

		if (comp.size() < min_size) {
			min_size = comp.size();
			min_comp = comp;
		}
	}

	cout << min_comp.size() << '\n';
	for (int i : min_comp) {
		cout << i + 1 << ' ';
	}

    return 0;
}