#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


vector<vector<int>> graph, depend;
vector<int> used;


void dfs(vector<vector<int>> &g, int n, vector<int> &res) {
	used[n] = true;

	for (int v : g[n]) {
		if (!used[v]) {
			dfs(g, v, res);
		}
	}

	res.push_back(n);
}


int main() {
	int n, m, h;
	cin >> n >> m >> h;

	vector<int> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	graph.resize(n);
	int from, to;
	for (int i = 0; i < m; ++i) {
		cin >> from >> to;
		--from;
		--to;

		graph[from].push_back(to);
		graph[to].push_back(from);
	}

	depend.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int v : graph[i]) {
			if ((t[i] + 1) % h == t[v]) {
				depend[i].push_back(v);
			}
		}

		if (depend[i].empty()) {
			cout << 1 << '\n' << i + 1;

			return 0;
		}
	}

	used.resize(n);
	vector<int> topsort;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(depend, i, topsort);
		}
	}

	used.assign(n, 0);
	vector<vector<int>> comps;
	for (int i : topsort) {
		if (!used[i]) {
			comps.emplace_back();
			dfs(depend, i, comps.back());
		}
	}

	int cn = comps.size();

	vector<int> match(n);
	for (int i = 0; i < cn; ++i) {
		for (int v : comps[i]) {
			match[v] = i;
		}
	}

	vector<vector<int>> comp_graph(cn);
	for (int i = 0; i < n; ++i) {
		for (int v : depend[i]) {
			if (match[i] != match[v]) {
				comp_graph[match[i]].push_back(match[v]);
			}
		}
	}

	int min_size = 1000000, min_comp;

	for (int i = 0; i < cn; ++i) {
		if (comp_graph[i].empty()) {
			if (comps[i].size() < min_size) {
				min_size = comps[i].size();
				min_comp = i;
			}
		}
	}

	cout << comps[min_comp].size() << '\n';
	for (int v : comps[min_comp]) {
		cout << v + 1 << ' ';
	}

	return 0;
}