#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > g;
vector<vector<int> > rg;
vector<int> ts;
vector<int> col;
vector<vector<int> > cont;
vector<char> used;

void ts_dfs(int v)
{
    if (used[v])
        return;
    used[v] = 1;
    for (auto u : g[v])
        ts_dfs(u);
    ts.push_back(v);
}

void col_dfs(int v, int tc)
{
    if (col[v] != -1)
        return;
    col[v] = tc;
    cont[tc].push_back(v);
    for (auto u : rg[v])
        col_dfs(u, tc);
}

int main()
{
    ifstream cin("input.txt");
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    rg.resize(n);
    col.resize(n, -1);
    used.resize(n);
    vector<int> h(n);
    for (int &i : h)
        cin >> i;
    vector<vector<int> > cl(n);
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        --x, --y;
        cl[x].push_back(y);
        cl[y].push_back(x);
    }
    for (int i = 0; i < n; i++)
        for (int j : cl[i])
            if ((h[i] + 1) % k == h[j])
            {
                g[i].push_back(j);
                rg[j].push_back(i);
            }
    for (int i = 0; i < n; i++)
        ts_dfs(i);
    reverse(ts.begin(), ts.end());
    for (int i : ts)
    {
        if (col[i] != -1)
            continue;
        cont.push_back({});
        col_dfs(i, cont.size() - 1);
    }
    int ans = n;
    int ans_cc = 0;
    for (int i = 0; i < cont.size(); i++)
    {
        bool f = 1;
        for (auto v : cont[i])
            for (auto u : g[v])
                if (col[u] != i)
                    f = 0;
        if (f && cont[i].size() < ans)
        {
            ans = cont[i].size();
            ans_cc = i;
        }
    }
    cout << ans << "\n";
    for (int i : cont[ans_cc])
        cout << i + 1 << " ";
    return 0;
}