import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Beta {

    static class Inreader {
        BufferedReader in;

        Inreader() {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        StringTokenizer st = new StringTokenizer("");

        void update() throws IOException {
            if (!st.hasMoreTokens()) {
                String a = in.readLine();
                if (a != null) st = new StringTokenizer(a);
            }
        }

        String next() throws IOException {
            update();
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }

        double nextDouble() throws IOException {
            return Double.parseDouble(next());
        }
    }

    static Inreader in = new Inreader();

    static class Decart {
        class node {
            node l;
            node r;
            long x;
            double y;
            int size;

            node(long x) {
                this.x = x;
                y = Math.random();
            }
        }

        Decart(int[] x) {
            tree = new node(x[0]);
            for (int i = 1; i < x.length; i++) {
                tree = merge(tree, new node(x[i]));
            }

        }

        void update(node t) {
            t.size = size(t.l) + size(t.r) + 1;
        }

        int size(node t) {
            if (t == null) return 0;
            return t.size;
        }

        node tree;

        node merge(node t1, node t2) {
            if (t1 == null) return t2;
            if (t2 == null) return t1;
            if (t1.y > t2.y) {
                t1.r = merge(t1.r, t2);
                update(t1.r);
                update(t1);
                return t1;
            }
            t2.l = merge(t1, t2.l);
            update(t2.l);
            update(t2);
            return t2;
        }

        node[] split(node t, int k) {
            if (t == null) return new node[]{null, null};
            int l = size(t.l);
            if (l >= k) {
                node[] d = split(t.l, k);
                t.l = d[1];
                update(t);
                return new node[]{d[0], t};
            }
            node[] d = split(t.r, k - l - 1);
            t.r = d[0];
            update(t);
            return new node[]{t, d[1]};
        }

        ArrayList<Long> print(node t) {
            if (t == null) return new ArrayList();
            ArrayList<Long> a = print(t.l);
            ArrayList<Long> b = print(t.r);
            ArrayList<Long> ans = a;
            ans.add(t.x);
            ans.addAll(b);
            return ans;
        }

        void del(int a, int b) {
            node[] t = split(tree, b);
            node[] d = split(t[0], a - 1);
            tree = merge(d[0], t[1]);
        }

    }

    long c2n(int n) {
        if (n % 2 == 0) return (n / 2) * (n - 1);
        else return (n - 1) / 2 * n;
    }

    static ArrayList<Integer>[] g;

    static boolean[] used;

//    static ArrayList gdf(int v, int f, boolean kek) {
//        used[v] = true;
//        if (v == f && kek) return new ArrayList<Integer>();
//        ArrayList<Integer> ans = null;
//        for (int to : g[v]) {
//            if (to == 0) {
//                ans = new ArrayList<>();
//                ans.add(v);
//                return ans;
//            }
//            if (used[to]) continue;
//            ArrayList<Integer> p = gdf(to, f, true);
//            if ((p != null) && (ans == null || p.size() < ans.size())) {
//                ans = p;
//            }
//        }
//        if (ans != null) ans.add(v);
//        return ans;
//    }

    public static void main(String args[]) throws IOException {
        int n = in.nextInt();
        int m = in.nextInt();
        int h = in.nextInt();
        g = new ArrayList[n];
        for (int i = 0; i < n; i++) g[i] = new ArrayList<>();
        int[] u = new int[n];
        for (int i = 0; i < n; i++) {
            u[i] = in.nextInt();
        }
        for (int i = 0; i < m; i++) {
            int a = in.nextInt() - 1;
            int b = in.nextInt() - 1;
            if ((u[a] + 1) % h == u[b]) g[a].add(b);
            if ((u[b] + 1) % h == u[a]) g[b].add(a);
        }

        for (int i = 0; i < n; i++) {
            if (g[i].size() == 0) {
                System.out.println(1);
                System.out.println(i + 1);
                return;
            }
        }
        System.out.println(h);
        used = new boolean[n];
        int[] ans = new int[h];
        for (int i = 0; i < n; i++) {
            ans[u[i]] = i;
        }
        for (int i = 0; i < n; i++) System.out.print((ans[i]+1)+" ");
    }
}
