import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Alpha {

    static class Inreader {
        BufferedReader in;

        Inreader() {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        StringTokenizer st = new StringTokenizer("");

        void update() throws IOException {
            if (!st.hasMoreTokens()) {
                String a = in.readLine();
                if (a != null) st = new StringTokenizer(a);
            }
        }

        String next() throws IOException {
            update();
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }

        double nextDouble() throws IOException {
            return Double.parseDouble(next());
        }
    }

    static Inreader in = new Inreader();

    static class Decart {
        class node {
            node l;
            node r;
            long x;
            double y;
            int size;

            node(long x) {
                this.x = x;
                y = Math.random();
            }
        }

        Decart(int[] x) {
            tree = new node(x[0]);
            for (int i = 1; i < x.length; i++) {
                tree = merge(tree, new node(x[i]));
            }

        }

        void update(node t) {
            t.size = size(t.l) + size(t.r) + 1;
        }

        int size(node t) {
            if (t == null) return 0;
            return t.size;
        }

        node tree;

        node merge(node t1, node t2) {
            if (t1 == null) return t2;
            if (t2 == null) return t1;
            if (t1.y > t2.y) {
                t1.r = merge(t1.r, t2);
                update(t1.r);
                update(t1);
                return t1;
            }
            t2.l = merge(t1, t2.l);
            update(t2.l);
            update(t2);
            return t2;
        }

        node[] split(node t, int k) {
            if (t == null) return new node[]{null, null};
            int l = size(t.l);
            if (l >= k) {
                node[] d = split(t.l, k);
                t.l = d[1];
                update(t);
                return new node[]{d[0], t};
            }
            node[] d = split(t.r, k - l - 1);
            t.r = d[0];
            update(t);
            return new node[]{t, d[1]};
        }

        ArrayList<Long> print(node t) {
            if (t == null) return new ArrayList();
            ArrayList<Long> a = print(t.l);
            ArrayList<Long> b = print(t.r);
            ArrayList<Long> ans = a;
            ans.add(t.x);
            ans.addAll(b);
            return ans;
        }

        void del(int a, int b) {
            node[] t = split(tree, b);
            node[] d = split(t[0], a - 1);
            tree = merge(d[0], t[1]);
        }

    }

    long c2n(int n) {
        if (n % 2 == 0) return (n / 2) * (n - 1);
        else return (n - 1) / 2 * n;
    }

    public static void main(String args[]) throws IOException {
        String s = in.next();
        s = s.concat("#");
        int n = s.length();
        int[] a = new int[n];
        int[] b = new int[n];
        int first = 0;
        int last = n - 1;
        int last1 = n;
        int last2 = n - 1;
        for (int i = n - 2; i >= 0; i--) {
            if (s.charAt(i) != s.charAt(i + 1)) {
                last1 = i + 1;
                b[i] = last2;
                last2 = i + 1;
            } else {
                b[i] = i + 1;
            }
            a[i] = last1;
        }
        a[n - 1] = -1;
        b[n - 1] = -1;
        boolean[] used = new boolean[n];
        ArrayList<ArrayList<Integer>> ans = new ArrayList<>();
        while (first < n-1) {
            if (s.charAt(first) == '1' || s.charAt(last) == '1') {
                System.out.println(-1);
                return;
            }
            ArrayList<Integer> now = new ArrayList<>();
            int next = first;
            while (s.charAt(next) != '#') {
                used[next] = true;
                now.add(next);
                int t = next;
                next = a[next];
                while (used[next]) {

                    next = b[next];
                }
                a[t] = next;
            }
            while (first < n && used[first])
                first++;
            while (last >= 0 && used[last]) {
                last--;
            }
            ans.add(now);
        }
        System.out.println(ans.size());
        for (ArrayList<Integer> now : ans) {
            System.out.print(now.size() + " ");
            for (int e : now) {
                System.out.print((e+1) + " ");
            }
            System.out.println();
        }
    }
}
