#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

const int inf = 2*1e9;
vector<int> g[100500];
vector<int> gT[100500];
int index[100500];
int out_deg[100500];
vector<vector<int> > storage;

bool used[100500];
vector<int> order;
void dfs(int v) {
    used[v] = 1;
    for (int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if (!used[to])
            dfs(to);
    }
    order.pb(v);
}

vector<int> comp;
void dfs2(int v) {
    used[v] = 1;
    comp.pb(v);
    for(int i=0; i<gT[v].size(); i++) {
        int to = gT[v][i];
        if (!used[to])
            dfs2(to);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n, m, h;
    int buf1, buf2;
    fin >> n >> m >> h;

    vector<int> arr;
    for (int i=0; i<n; i++) {
        fin >> buf1;
        arr.pb(buf1);
    }
    vector<pii> input;
    vector<pii> edge;
    for (int i=0; i<m; i++) {
        fin >> buf1 >> buf2;
        buf1--; buf2--;
        input.pb(mp(buf1, buf2));
        if (buf1 > buf2) swap(buf1, buf2);
    }

    /// build graph!
    int val1, val2;
    for (int i=0; i<input.size(); i++) {
        buf1 = input[i].fi;
        buf2 = input[i].se;

        val1 = arr[buf1];
        val2 = arr[buf2];

        if ((val1+1)%h == val2) {
            edge.pb(mp(buf1, buf2));
            g[buf1].pb(buf2);
            gT[buf2].pb(buf1);
        }
        if ((val2+1)%h == val1) {
            edge.pb(mp(buf2, buf1));
            g[buf2].pb(buf1);
            gT[buf1].pb(buf2);
        }
    }

    /// ------ debug ------- ////
    //for (int i=0; i<n; i++) {
    //    cout << i << ": ";
    //    for (int j=0; j<g[i].size(); j++)
    //        cout << g[i][j] << ' ';
    //    cout << endl;
    //}
    /// ------ debug ------- ////

    /// make order
    for (int i=0; i<n; i++) used[i] = 0;
    for (int i=0; i<n; i++)
        if (!used[i])
            dfs(i);

    int cnt = 0;
    for (int i=0; i<n; i++) used[i] = 0;
    for (int i=order.size()-1; i>=0; i--) {
        if (!used[order[i]]) {
            comp.clear();
            dfs2(order[i]);
            storage.pb(comp);
            for (int j=0; j<comp.size(); j++)
                index[comp[j]] = cnt;

            cnt++;
        }
    }

    /// ----- debug ---- ///
    //for (int i=0; i<cnt; i++) {
    //    cout << i << ": ";
    //    for (int j=0; j<storage[i].size(); j++)
    //        cout << storage[i][j] << ' ';
    //    cout << endl;
    //}
    /// ----- debug ---- ///

    for (int i=0; i<cnt; i++) out_deg[i] = 0;
    for (int i=0; i<edge.size(); i++) {
        buf1 = index[edge[i].fi];
        buf2 = index[edge[i].se];

        out_deg[buf1]++;
    }

    vector<int> ans = storage[0];
    for (int i=0; i<cnt; i++)
        if (out_deg[i]==0)
            ans = storage[i];

    fout << ans.size() << endl;
    for (int i=0; i<ans.size(); i++)
        fout << ans[i]+1 << ' ';

    fin.close();
    fout.close();
    return 0;
}
