#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

const int inf = 2*1e9;
vector<int> g[1000];
bool used[1000];
vector<int> cur; /// list of visited vertexes

void dfs(int v) {
    used[v] = 1;
    cur.pb(v);
    for (int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if (!used[to])
            dfs(to);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n, m, h;
    int buf1, buf2;
    fin >> n >> m >> h;

    vector<int> arr;
    for (int i=0; i<n; i++) {
        fin >> buf1;
        arr.pb(buf1);
    }
    map<pii, int> data;
    for (int i=0; i<m; i++) {
        fin >> buf1 >> buf2;
        buf1--; buf2--;
        if (buf1 > buf2) swap(buf1, buf2);
        data[mp(buf1, buf2)] = 1;
    }

    /// build graph
    int val;
    for (int i=0; i<n; i++) {
        val = (arr[i]+1)%h;
        for (int j=0; j<n; j++) {
            if (i==j) continue;
            if (val != arr[j]) continue;

            if (i < j) {buf1=i; buf2=j;}
            else {buf1=j; buf2=i;}
            if (data.count(mp(buf1, buf2)))
                g[i].pb(j);
        }
    }

    /// ------- debug ------- ///
    ///for (int i=0; i<n; i++) {
    ///    cout << i << ": ";
    ///    for (int j=0; j<g[i].size(); j++)
    ///        cout << g[i][j] << ' ';
    ///    cout << endl;
    ///}
    /// ------- debug ------- ///

    int best = inf;
    vector<int> ans;

    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) used[j] = 0;
        cur.clear();
        dfs(i);
        if (cur.size() < best) {
            best = cur.size();
            ans = cur;
        }
    }

    fout << best << endl;
    for (int i=0; i<best; i++)
        fout << ans[i]+1 << ' ';

    fin.close();
    fout.close();
    return 0;
}
