#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <ctime>
#include <string>
#include <cmath>
#include <algorithm>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cerr << #x << ": " << (x) << '\n'

std::vector<std::vector<int>>g, gr;
std::vector<int> order, used;
std::vector<int> comp;
void dfs1(int v) {
	used[v] = true;
	FOR(i, gr[v].size()) {
		if (!used[gr[v][i]]) {
			dfs1(gr[v][i]);
		}
	}
	order.push_back(v);
}
void dfs2(int v) {
	used[v] = 1;
	comp.push_back(v);
	FOR(i, g[v].size()) {
		if (!used[g[v][i]]) {
			dfs2(g[v][i]);
		}
	}
}

int popcount(int i) {
	int count = 0;
	FOR(q, 32) {
		if ((i >> q) & 1) {
			count++;
		}
	}
	return count;
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::srand(std::time(NULL));
	int n, m, h;
	std::cin >> n >> m >> h;
	g.resize(n);
	gr.resize(n);
	used.resize(n);
	std::vector<int>u(n);
	FOR(i, n) {
		std::cin >> u[i];
	}
	std::vector<std::pair<int, int>> cur;
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		cur.push_back({a, b});
	}
	int min = 1e9, minMask = 0;
	FOR(i, (1ll << n)) {
		if (i == 0) {
			continue;
		}
		std::vector<int> newU = u;
		FOR(j, n) {
			if ((i >> j) & 1) {
				newU[j]++;
			}
		}
		bool fl = false;
		FOR(j, m) {
			if (newU[cur[j].first] % h == newU[cur[j].second] % h) {
				fl = true;
				break;
			}
		}
		if (fl) {
			continue;
		}
		if (popcount(i) < min) {
			min = popcount(i);
			minMask = i;
		}
	}
	std::cout << min << '\n';
	FOR(j, n) {
		if ((minMask >> j) & 1) {
			std::cout << j + 1 << ' ';
		}
	}
	return 0;
}