#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <ctime>
#include <string>
#include <cmath>
#include <algorithm>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cerr << #x << ": " << (x) << '\n'

std::vector<std::vector<int>>g, gr;
std::vector<int> order, used;
std::vector<int> comp;
void dfs1(int v) {
	used[v] = true;
	FOR(i, gr[v].size()) {
		if (!used[gr[v][i]]) {
			dfs1(gr[v][i]);
		}
	}
	order.push_back(v);
}
void dfs2(int v) {
	used[v] = 1;
	comp.push_back(v);
	FOR(i, g[v].size()) {
		if (!used[g[v][i]]) {
			dfs2(g[v][i]);
		}
	}
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::srand(std::time(NULL));
	int n, m, h;
	std::cin >> n >> m >> h;
	g.resize(n);
	gr.resize(n);
	used.resize(n);
	std::vector<int>u(n);
	FOR(i, n) {
		std::cin >> u[i];
	}
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		if ((u[a] + 1) % h == u[b]) {
			g[a].push_back(b);
			gr[b].push_back(a);
		}
		if ((u[b] + 1) % h == u[a]) {
			g[b].push_back(a);
			gr[a].push_back(b);
		}
	}
	FOR(i, n) {
		if (!used[i]) {
			dfs1(i);
		}
	}
	std::reverse(order.begin(), order.end());
	used.assign(n, 0);
	int min = 1e9, minI = 0;
	FOR(i, n) {
		if (!used[order[i]]) {
			dfs2(order[i]);
			if (min > comp.size()) {
				min = comp.size();
				minI = order[i];
			}
		}
		comp.clear();
	}
	used.assign(n, 0);
	dfs2(minI);
	std::cout << min << '\n';
	for (auto d : comp) {
		std::cout << d + 1 << ' ';
	}
	return 0;
}