#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <ctime>
#include <string>
#include <cmath>
#include <algorithm>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cerr << #x << ": " << (x) << '\n'

std::vector<std::vector<int>>g, gr;
std::vector<int> order, used;
int compN = 0;
std::vector<int> comp, size;
void dfs1(int v) {
	used[v] = true;
	FOR(i, gr[v].size()) {
		if (!used[gr[v][i]]) {
			dfs1(gr[v][i]);
		}
	}
	order.push_back(v);
}
void dfs2(int v) {
	used[v] = 1;
	comp[v] = compN;
	size[compN]++;
	FOR(i, g[v].size()) {
		if (!used[g[v][i]]) {
			dfs2(g[v][i]);
		}
	}
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::srand(std::time(NULL));
	int n, m, h;
	std::cin >> n >> m >> h;
	g.resize(n);
	gr.resize(n);
	used.resize(n);
	std::vector<int>u(n);
	FOR(i, n) {
		std::cin >> u[i];
	}
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		if ((u[a] + 1) % h == u[b]) {
			g[a].push_back(b);
		}
		if ((u[b] + 1) % h == u[a]) {
			g[b].push_back(a);
		}
	}
	FOR(i, n) {
		FOR(j, g[i].size()) {
			int to = g[i][j];
			gr[to].push_back(i);
		}
	}
	FOR(i, n) {
		if (!used[i]) {
			dfs1(i);
		}
	}
	used.assign(n, 0);
	comp.resize(n);
	size.resize(n);
	FOR(i, n) {
		if (!used[order[n - i - 1]]) {
			dfs2(order[n - i - 1]);
		}
		compN++;
	}
	std::vector<int> isGood(n, 1);
	used.assign(n, 0);
	FOR(i, n) {
		FOR(j, g[i].size()) {
			if (comp[g[i][j]] != comp[i]) {
				isGood[comp[i]] = false;
			}
		}
	}
	int min = 1e9, minI = 0;
	FOR(i, n) {
		if (isGood[comp[i]] && size[comp[i]] < min) {
			min = size[comp[i]];
			minI = comp[i];
		}
	}
	std::cout << min << '\n';
	FOR(i, n) {
		if (comp[i] == minI) {
			std::cout << i + 1 << ' ';
		}
	}
	return 0;
}