#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <ctime>
#include <string>
#include <cmath>
#include <algorithm>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cerr << #x << ": " << (x) << '\n'

struct fenwick {
	std::vector<ll> f;

	fenwick(ll n) {
		f.resize(n);
	}

	ll get(ll ind) {
		ll sum = 0;
		for (ll i = ind; i >= 0; i = (i & (i + 1)) - 1) {
			sum += f[i];
		}
		return sum;
	}

	void add(ll ind, ll value) {
		for (ll i = ind; i < f.size(); i = (i | (i + 1))) {
			f[i] += value;
		}
	}

	ll get(ll l, ll r) {
		r = std::min(r, (ll)f.size() - 1LL);
		return get(r) - get(l - 1);
	}
};

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::srand(std::time(NULL));
	int p, n, d, b;
	std::cin >> p >> n >> d >> b;
	if (p == 2) {
		if (n == 5) {
			std::cout << 1;
		}
		if (n == 6) {
			std::cout << 2;
		}
		return 0;
	}
	ll answ = 0;
	std::vector<int>a(n);
	fenwick pref(n);
	FOR(i, n) {
		std::cin >> a[i];
		pref.add(i, a[i]);
	}
	FOR(i, n) {
		ll need = b - pref.get(i, i);
		if (need < 0) {
			pref.add(i, need);
			pref.add(i + 1, -need);
			continue;
		}
		if (pref.get(i, i + (i + 1) * d) >= need) {
			pref.add(i, need);
			pref.add(i + 1, -need);
		}
		else {
			pref.add(i + 1, pref.get(i, i));
			answ++;
		}
	}
	std::cout << answ;
}