#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


int df(int u, vector <bool> &used, vector <vector <int> > &List, int clr, vector <int> &col)
{
    used[u] = true;
    col[u] = clr;
    for (int i = 0; i < List[u].size(); ++i)
    {
        if (!used[List[u][i]])
        {
            df(List[u][i], used, List, clr, col);
        }
    }
    return 0;
}

int dfs(int u, vector <bool> &used, vector <vector <int> > &List, int &tim, vector <pair <int, int> > &top_sort)
{
    used[u] = true;
    ++tim;
    for (int i = 0; i < List[u].size(); ++i)
    {
        if (!used[List[u][i]])
        {
            dfs(List[u][i], used, List, tim, top_sort);
        }
    }
    top_sort.push_back({tim, u});
    ++tim;
    return 0;
}

int main() {
    int n, m, h;
    cin >> n >> m >> h;
    vector<vector<int> > List(n);
    vector <vector <int> > ListT(n);
    vector<int> H(n);
    for (int i = 0; i < n; ++i) {
        cin >> H[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (H[u] == (H[v] + 1) % h) {
            List[v].push_back(u);
            ListT[u].push_back(v);
        }
        if (H[v] == (H[u] + 1) % h) {
            List[u].push_back(v);
            ListT[v].push_back(u);
        }
    }
    vector<bool> used(n);
    vector <pair <int, int> > top_sort;
    for (int i = 0; i < n; ++i)
    {
        int tim = 0;
        if (!used[i])
            dfs(i, used, List, tim, top_sort);
    }
    sort(top_sort.rbegin(), top_sort.rend());
    used.assign(n, 0);
    vector <int> col(n, -1);
    int clr = 0;
    for (int i = 0; i < n; ++i)
    {
        if (!used[top_sort[i].second])
            df(top_sort[i].second, used, ListT, clr++, col);
    }
    vector <vector <int> > comp(clr);
    for (int i = 0; i < n; ++i)
    {
        comp[col[i]].push_back(i);
    }
    vector <bool> virg(clr, true);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < List[i].size(); ++j)
        {
            if (col[List[i][j]] != col[i])
            {
                virg[col[i]] = false;
                break;
            }
        }
    }
    int mini = -1;
    for (int i = 0; i < clr; ++i)
    {
        if (virg[i])
        {
            if (mini == -1 || comp[mini].size() > comp[i].size())
            {
                mini = i;
            }
        }
    }
    cout << comp[mini].size() << endl;
    for (int i = 0; i < comp[mini].size(); ++i)
    {
        cout << comp[mini][i] + 1 << " ";
    }
    cout << endl;
    return 0;
}