#include <bits/stdc++.h>

using namespace std;

void top_sorting(int v, vector<vector<int>> &g, vector<int> &top_sort, vector<int> &color) {
    color[v] = 1;
    for (size_t i = 0; i < g[v].size(); i++) {
        if (color[g[v][i]] == -1) {
            top_sorting(g[v][i], g, top_sort, color);
        }
    }
    top_sort.push_back(v);
}

void dfs(int v, vector<vector<int>> &g, vector<int> &color, int col) {
    color[v] = col;
    for (size_t i = 0; i < g[v].size(); i++) {
        if (color[g[v][i]] == -1) {
            dfs(g[v][i], g, color, col);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    vector<vector<int>> g(n), reg(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if ((h[u] + 1) % k == h[v]) {
            g[u].push_back(v);
            reg[v].push_back(u);
        }
        if ((h[v] + 1) % k == h[u]) {
            g[v].push_back(u);
            reg[u].push_back(v);
        }
    }
//    for (int i = 0; i < n; i++) {
//        cout << i << ": ";
//        for (int j = 0; j < g[i].size(); j++) {
//            cout << g[i][j] << " ";
//        }
//        cout << endl;
//    }
    vector<int> top_sort, color(n, -1);
    for (int i = 0; i < n; i++) {
        if (color[i] == -1) {
            top_sorting(i, reg, top_sort, color);
        }
    }
    for (int i = 0; i < n; i++) {
//        cout << top_sort[i] << " ";
        color[i] = -1;
    }
//    cout << endl;
    int c = 0;
    for (int j = n - 1; j >= 0; j--) {
        int i = top_sort[j];
//        cout << "v = " << i << endl;
//        cout << "c = " << c << endl;
        if (color[i] == -1) {
            dfs(i, g, color, c);
            c++;
        }

    }
//    cout << "color: ";
//    for (int i = 0; i < n; i++) {
//        cout << color[i] << " ";
//    }
//    cout << endl;
    vector<int> cp(c, 0);
    vector<int> stock_color(c, 1);
    for (int i = 0; i < n; i++) {
        for (size_t j = 0; j < g[i].size(); j++) {
//            cout << color[i] << "  to " << color[g[i][j]] << endl;
            if (color[i] != color[g[i][j]]) {
                stock_color[color[i]] = 0;
            }
        }
    }
//    cout << "stock: ";
//    for (int i = 0; i < c; i++) {
//        cout << stock_color[i] << " ";
//    }
//    cout << endl;
    for (int i = 0; i < n; i++) {
        cp[color[i]]++;
    }
    int ans = 1000000000, ans_color = -1;
    for (int i = 0; i < c; i++) {
        if (stock_color[i] && cp[i] < ans) {
            ans = cp[i];
            ans_color = i;
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < n; i++) {
        if (color[i] == ans_color) {
            cout << i + 1 << ' ';
        }
    }

    return 0;
}
