#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int SIZE = 1e5;
static vector<int> graph[SIZE], rev_graph[SIZE], clients[SIZE], sorted;
static set<int> coll_graph[SIZE];
int comp[SIZE], cnt[SIZE], comp_now;
bool checked[SIZE];

void topsort(int v)
{
    checked[v] = 1;
    for (int u : graph[v])
        if (!checked[u])
            topsort(u);
    sorted.push_back(v);
}

void rev_dfs(int v)
{
    checked[v] = 1;
    comp[v] = comp_now;
    for (int u : rev_graph[v])
        if (!checked[u])
            rev_dfs(u);
}

void collapse(int v)
{
    cnt[comp[v]]++;
    checked[v] = 1;
    for (int u : graph[v])
    {
        if (comp[v] != comp[u])
            coll_graph[comp[v]].insert(comp[u]);
        if (!checked[u])
            collapse(u);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    static int upd_hour[SIZE], n, m, h, beg, end, min_comp = -1;

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> upd_hour[i];
    for (int i = 0; i < m; i++)
    {
        cin >> beg >> end;
        clients[beg - 1].push_back(end - 1);
        clients[end - 1].push_back(beg - 1);
    }
    for (int i = 0; i < n; i++)
        for (int j : clients[i])
            if ((upd_hour[i] + 1) % h == upd_hour[j])
            {
                graph[i].push_back(j);
                rev_graph[j].push_back(i);
            }
    /*for (int i = 0; i < n; i++)
    {
        cout << i << " : ";
        for (int j : graph[i])
            cout << j << ' ';
        cout << endl;
    }*/
    /*cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        cin >> beg >> end;
        graph[beg].push_back(end);
        rev_graph[end].push_back(beg);
    }*/
    for (int i = 0; i < n; i++)
        if (!checked[i])
            topsort(i);
    reverse(sorted.begin(), sorted.end());
    for (int i = 0; i < n; i++)
        checked[i] = 0;
    for (int i = 0; i < n; i++)
        if (!checked[sorted[i]])
        {
            rev_dfs(sorted[i]);
            comp_now++;
        }
    for (int i = 0; i < n; i++)
        checked[i] = 0;
    for (int i = 0; i < n; i++)
        if (!checked[i])
            collapse(i);
    /*for (int i = 0; i < n; i++)
        cout << comp[i] << ' ';
    cout << endl;
    for (int v = 0; v < comp_now; v++)
    {
        cout << cnt[v] << ' ' << coll_graph[v].size() << " : ";
        for (int u : coll_graph[v])
            cout << u << ' ';
        cout << endl;
    }*/
    for (int i = 0; i < comp_now; i++)
        if (coll_graph[i].size() == 0)
            if (min_comp == -1 || cnt[min_comp] > cnt[i])
                min_comp = i;
    cout << cnt[min_comp] << endl;
    for (int i = 0; i < n; i++)
        if (comp[i] == min_comp)
            cout << i + 1 << ' ';
    //cin >> n;
}