// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

vector<vector<int>> g, rev_g;
vector<int> color, top_sort, tin, cnt, inp_cnt;
int timer = 0;

void init()
{
	int n = len(g);
	rev_g.resize(n);
	color.resize(n, -1);
	tin.resize(n, -1);
	for (int i = 0; i < n; ++i)
		for (auto &x : g[i])
			rev_g[x].pb(i);
}

void dfs1(int v)
{
	tin[v] = timer++;
	for (auto &x : g[v])
		if (tin[x] == -1)
			dfs1(x);
	top_sort.pb(v);
}

void dfs2(int v)
{
	color[v] = timer;
	for (auto &x : rev_g[v])
		if (color[x] == -1)
			dfs2(x);
}

void kasaray()
{
	reverse(all(top_sort));
	timer = 0;
	for (auto &x : top_sort)
		if (color[x] == -1)
		{
			dfs2(x);
			++timer;
		}
	cnt.resize(timer, 0);
	inp_cnt.resize(timer, 0);
	for (auto &x : color)
		++cnt[x];
	for (int i = 0; i < len(g); ++i)
		for (auto &x : g[i])
			if (color[i] != color[x])
				++inp_cnt[color[i]];
}

void run()
{
	int n, m, h;
	cin >> n >> m >> h;
	assert(h != 2);
	g.resize(n);
	vector<int> u(n);
	for (auto &x : u)
		cin >> x;
	vector<vector<int>> c(m, vector<int>(2));
	for (auto &x : c)
		for (auto &y : x)
		{
			cin >> y;
			--y;
		}
	vector<vector<int>> arr(h);
	for (int i = 0; i < n; ++i)
		arr[u[i]].pb(i);
	for (auto x : c)
	{
		if ((u[x[0]] + 1) % h == u[x[1]])
			g[x[0]].pb(x[1]);
		if ((u[x[1]] + 1) % h == u[x[0]])
			g[x[1]].pb(x[0]);
	}
	init();
	for (int i = 0; i < n; ++i)
		if (tin[i] == -1)
			dfs1(i);
	kasaray();
	int mn = 1000000000, idx = -1;
	for (int i = 0; i < len(cnt); ++i)
		if (inp_cnt[i] == 0 && cnt[i] < mn)
		{
			mn = cnt[i];
			idx = color[i];
		}
	vector<int> ans;
	for (int i = 0; i < n; ++i)
		if (color[i] == idx)
			ans.pb(i);
	cout << len(ans) << endl;
	for (auto &x : ans)
		cout << x + 1 << " ";
	cout << endl;
}