// t2.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

void dfs(long long v, vector<vector<long long> > &g, vector<bool> &used, vector<long long> &comp)
{
	used[v] = 1;
	comp.push_back(v);
	for (long long i = 0; i < g[v].size(); i++)
	{
		if (!used[g[v][i]])
		{
			dfs(g[v][i], g, used, comp);
		}
	}
}

void topsort(long long v, vector<vector<long long> > &g, vector<bool> &used, vector<long long> &ts)
{
	used[v] = 1;
	for (long long i = 0; i < g[v].size(); i++)
	{
		if (!used[g[v][i]])
		{
			topsort(g[v][i], g, used, ts);
		}
	}
	ts.push_back(v);
}

int main()
{
	long long n, m, h;
	cin >> n >> m >> h;
	vector<long long> upd(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> upd[i];
	}
	vector<vector<long long> > g(n), gr(n);
	for (long long i = 0; i < m; i++)
	{
		long long v1, v2;
		cin >> v1 >> v2;
		v1--, v2--;
		if (upd[v1] == (upd[v2] + 1) % h)
		{
			g[v2].push_back(v1);
			gr[v1].push_back(v2);
		}
		if (upd[v2] == (upd[v1] + 1) % h)
		{
			g[v1].push_back(v2);
			gr[v2].push_back(v1);
		}
	}
	vector<bool> used(n, 0);
	vector<long long> ts;
	for (long long i = 0; i < n; i++)
	{
		if (!used[i])
		{
			topsort(i, g, used, ts);
		}
	}
	reverse(ts.begin(), ts.end());
	used.assign(n, 0);
	vector<vector<long long> > comps;
	vector<long long> in_c(n);
	for (long long i = 0; i < n; i++)
	{
		if (!used[ts[i]])
		{
			comps.push_back(vector<long long>());
			dfs(ts[i], gr, used, comps.back());
			for (long long j = 0; j < comps.back().size(); j++)
			{
				in_c[comps.back()[j]] = comps.size() - 1;
			}
		}
	}
	vector<long long> used2(n);
	vector<long long> cnt(comps.size());
	vector<long long> zav(n);
	for (long long i = comps.size() - 1; i >= 0; i--)
	{
		used2[i] = i + 1;
		for (long long j = 0; j < comps[i].size(); j++)
		{
			long long v = comps[i][j];
			zav[v] = comps[i].size() + cnt[i];
			for (long long k = 0; k < gr[v].size(); k++)
			{
				long long u = gr[v][k];
				long long curc = in_c[u];
				if (used2[curc] != i + 1)
				{
					used2[curc] = i + 1;
					cnt[curc] += comps[i].size();
				}
			}
		}
	}
	long long answ = -1;
	for (long long i = 0; i < n; i++)
	{
		if (answ == -1 || zav[answ] > zav[i])
		{
			answ = i;
		}
	}
	cout << zav[answ] << endl;
	ts.clear();
	used.assign(n, 0);
	dfs(answ, g, used, ts);
	for (auto &x : ts)
		cout << x + 1 << " ";  
	cin >> n;
    return 0;
}

