import javafx.util.Pair;

import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

public class B {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }


    private static Set<Integer>[] blockedDC;
    private static int[] u;
    private static int n, m, h;

    public static void main(String[] args) throws IOException {
        InputStreamReader r = new InputStreamReader(System.in);
        int[] in = readArgsInt(r, 3);
        n = in[0];
        m = in[1];
        h = in[2];
        u = readArgsInt(r, n);


        //noinspection unchecked
        blockedDC = new Set[n];
        for (int i = 0; i < m; i++) {
            int[] c = readArgsInt(r, 2);
            c[0]--;
            c[1]--;
            if (blockedDC[c[0]] == null) {
                blockedDC[c[0]] = new HashSet<>();
            }
            if (blockedDC[c[1]] == null) {
                blockedDC[c[1]] = new HashSet<>();
            }

            blockedDC[c[0]].add(c[1]);
            blockedDC[c[1]].add(c[0]);

        }
        int minShift = Integer.MAX_VALUE;
        Set<Integer> shift = new HashSet<>();
        for (int i = 0; i < n; i++) {
            Set<Integer> ishift = shift(i, new HashSet<>());
            if (ishift.size() < minShift) {
                shift = ishift;
                minShift = ishift.size();
                if (minShift == 1) {
                    break;
                }
            }
        }
        System.out.println(minShift);

        //noinspection ConstantConditions
        shift.parallelStream().map(k -> String.valueOf(k + 1)).reduce((k1, k2) -> k1 + ' ' + k2).ifPresent(System.out::println);
    }

    private static Set<Integer> shift(int i, Set<Integer> shifted) {
        shifted.add(i);
        Set<Integer> blocked = blockedDC[i];
        int time = u[i];
        int shiftedTime = time == h - 1 ? 0 : time + 1;
        Set<Integer> collision = blocked.parallelStream().filter(x -> u[x] == shiftedTime && !shifted.contains(x)).collect(Collectors.toSet());
        if (collision.isEmpty()) {
            return shifted;
        }

        for (int j : collision) {
           shift(j, shifted);
        }
        return shifted;
    }


}
