import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class D {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    public static void main(String[] args) throws IOException {
        InputStreamReader r = new InputStreamReader(System.in);
        int n = readArgsInt(r, 1)[0];
        int[] a = readArgsInt(r, n);
        Arrays.sort(a);
        List<Integer> deck = new ArrayList<>();
        for(int i : a) {
            deck = fit(deck, i);
        }
        System.out.println(deck.size());
        deck.parallelStream().map(String::valueOf).reduce((s1, s2) -> s1 + ' ' + s2).ifPresent(System.out::print);
    }

    private static List<Integer> fit(List<Integer> deck, int i) {
        if(i == 0) return deck;
        int[] powTwo = findClosestPowTwo(i);
        if(powTwo.length == 1) {
            int pt = powTwo[0];
            if(!deck.contains(pt)) {
                deck.add(pt);
            }
            deck = fit(deck, i - pt);
            return deck;
        } else {
            List<Integer> d1 = new ArrayList<>(deck), d2 = new ArrayList<>(deck);
            int c1 = 0, c2 = 0;
            if(!deck.contains(powTwo[0])) {
                c1++;
            }
            if(!deck.contains(powTwo[1])) {
                c2++;
            }
            d1 = fit(d1, i - powTwo[0]);
            d2 = fit(d2, i - powTwo[1]);
            c1 += d1.size() - deck.size();
            c2 += d2.size() - deck.size();
            switch (Integer.compare(c1, c2)) {
                case 1: {
                    if(!d2.contains(powTwo[1])) {
                        d2.add(powTwo[1]);
                    }
                    return d2;
                }
                case 0:
                case -1: {
                    if(!d1.contains(powTwo[0])) {
                        d1.add(powTwo[0]);
                    }
                    return d1;
                }
            }
        }
        return deck;
    }

    private static int[] findClosestPowTwo(int i) {
        if (i == 0) return new int[]{i};

        boolean neg = i < 0;
        i = Math.abs(i);

        String s = Integer.toBinaryString(i);
        int bitLen = s.length();
        int oneCount = Integer.bitCount(i);
        if(oneCount == 1) return new int[]{neg ? -i : i}; //Already pow of two
        StringBuilder b = new StringBuilder();
        b.append('1');
        for (int j = 1; j < bitLen; j++) {
            b.append('0');
        }
        int low = Integer.parseInt(b.toString(), 2);
        int high = Integer.parseInt(b.append('0').toString(), 2);
        if(neg) {
            low = -low;
            high = -high;
        }
        switch (Integer.compare(i - low, high - i)) {
            case 1: return new int[]{high};
            case 0: return new int[]{low, high};
            case -1: return new int[]{low};
            default: return new int[]{}; //Should not happen
        }
    }
}
