import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class D {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static Queue<Integer> toFit = new LinkedList<>();

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }
    private static int n;
    public static void main(String[] args) throws IOException {
        InputStreamReader r = new InputStreamReader(System.in);
        n = readArgsInt(r, 1)[0];
        int[] a = readArgsInt(r, n);
        Arrays.sort(a);
        Set<Integer> deck = new HashSet<>();
        for (int i : a) {
            toFit.add(i);
        }
        while (!toFit.isEmpty()) {
            deck = fit(deck, toFit.poll());
        }
        System.out.println(deck.size());
        deck.parallelStream().map(String::valueOf).reduce((s1, s2) -> s1 + ' ' + s2).ifPresent(System.out::print);
    }
    private static int itercount = 0;
    private static Set<Integer> fit(Set<Integer> deck, int i) {
        itercount++;
        if (i == 0) return deck;
        int[] powTwo = findClosestPowTwo(i);
        if (powTwo.length == 1) {
            int pt = powTwo[0];
            deck.add(pt);
            toFit.add(i - pt);
            return deck;
        } else {
            Set<Integer> d1 = new HashSet<>(deck), d2 = new HashSet<>(deck);
            int c1 = 0, c2 = 0;
            if (!deck.contains(powTwo[0])) {
                c1++;
            }
            if (!deck.contains(powTwo[1])) {
                c2++;
            }
            d1 = fit(d1, i - powTwo[0]);
            d2 = fit(d2, i - powTwo[1]);
            c1 += d1.size() - deck.size();
            c2 += d2.size() - deck.size();
            switch (Integer.compare(c1, c2)) {
                case 1: {
                    d2.add(powTwo[1]);
                    return d2;
                }
                case 0: {
                    if(itercount > 2 * n) {
                        d1.add(powTwo[0]);
                        return d1;
                    }
                    toFit.add(i);
                    return deck;
                }
                case -1: {
                    d1.add(powTwo[0]);
                    return d1;
                }
            }
        }
        return deck;
    }

    private static int[] findClosestPowTwo(int i) {
        if (i == 0) return new int[]{i};

        boolean neg = i < 0;
        i = Math.abs(i);

        String s = Integer.toBinaryString(i);
        int bitLen = s.length();
        int oneCount = Integer.bitCount(i);
        if (oneCount == 1) return new int[]{neg ? -i : i}; //Already pow of two
        int low = 1 << (bitLen - 1);
        int high = 1 << bitLen;
        switch (Integer.compare(i - low, high - i)) {
            case 1:
                return new int[]{neg ? -high : high};
            case 0:
                return neg ? new int[]{-low, -high} : new int[]{low, high};
            case -1:
                return new int[]{neg ? -low : low};
            default:
                return new int[]{}; //Should not happen
        }
    }
}
