#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;

const long long inf = 1e15;

long long n, m, h;

vector < long long > pos;
vector < vector < long long > > g;
vector < long long > color;





void dfs(int v, set < int > &temp){
	temp.insert(v + 1);
	color[v] = 0;

	for (auto to : g[v]){
		if (color[to] == 0){
			dfs(to, temp);
		}
	}
	return;
}


int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> h;
	pos.assign(n, -1);
	g.assign(n, vector < long long >());
	

	for (int i = 0; i < n; i++){
		cin >> pos[i];
	}
	

	set < int > res;



	for (int i = 0; i < m; i++){
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		if ((pos[v] + 1) % h == pos[u]){
			g[v].push_back(u);
		}
		if ((pos[u] + 1) % h == pos[v]){
			g[u].push_back(v);
		}
	}
	long long ans = 1e15;


	for (int i = 0; i < n; i++){
		set < int > temp;
		color.assign(n, 0);

		dfs(i, temp);
		if (res.size() == 0 || res.size() > temp.size()){
			res = temp;
		}
	}

	cout << res.size() << endl;

	for (auto elem : res){
		cout << elem << " ";
	}





	system("pause");
	return 0;
}