#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cassert>

using namespace std;

const long long inf = 1e15;

long long n, m, h;

vector < long long > pos;
vector < vector < long long > > g;
vector < long long > color;


void dfs(int v, int time, long long &cnt, vector < long long > &temp) {
	temp.push_back(v + 1);
	color[v] = time;
	cnt++;

	for (auto to : g[v]) {
		if (color[to] != time) {
			dfs(to, time, cnt, temp);
		}
		
	}
	return;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> h;
	pos.assign(n, -1);
	g.assign(n, vector < long long >());
	color.assign(n, -1);

	for (int i = 0; i < n; i++) {
		cin >> pos[i];
	}


	vector < long long > res;

	vector < pair < long long, long long > > q;


	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		q.push_back({ v, u });
		if ((pos[v] + 1) % h == pos[u]) {
			g[v].push_back(u);
		}
		if ((pos[u] + 1) % h == pos[v]) {
			g[u].push_back(v);
		}
	}

	for (int i = 0; i < n; i++) {
		if (g[i].size() == 0) {
			cout << 1 << endl;
			cout << i + 1;
			system("pause");
			return 0;
		}
	}


	long long ans = 1e15;
	for (int i = 0; i < n; i++) {
		long long time = i + 1;
		long long cnt = 0;
		vector < long long > temp;

		dfs(i, time, cnt, temp);
		if (temp.size() < ans) {
			ans = temp.size();
			res = temp;
		}
	}

	cout << res.size() << endl;

	if (res.size() != n) {
		vector < long long > q;
		cout << q[0];
	}

	for (int i = 0; i < res.size(); i++) {
		cout << res[i] << " ";
	}





	system("pause");
	return 0;
}