#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<iomanip>

using namespace std;

const int inf = 1e9;

struct node{
	int left, right;
	long long sum;
	node * child_left, *child_right;
};

node* build(int left, int right, vector<long long> & values){
	if (left > right)
		return 0;
	node * res = new node;
	res->left = left;
	res->right = right;
	if (right == left){
		res->child_left = res->child_right = 0;
		res->sum = values[left];
	}
	else {
		int mid = (left + right) / 2;

		res->child_left = build(left, mid, values);
		res->child_right = build(mid + 1, right, values);

		res->sum = res->child_left->sum + res->child_right->sum;
	}
	return res;
}

long long query(node * root, int left, int right){
	if (right < root->left || left > root->right)
		return 0;
	if (left <= root->left && right >= root->right)
		return root->sum;
	long long ans1 = query(root->child_left, left, right);
	long long ans2 = query(root->child_right, left, right);
	return ans1 + ans2;
}

void update_one(node * root, int idx, int val) {
	if (idx < root->left || idx > root->right)
		return;
	if (root->left == root->right){
		root->sum = val;
		return;
	}
	update_one(root->child_left, idx, val);
	update_one(root->child_right, idx, val);
	root->sum = root->child_left->sum + root->child_right->sum;
	return;
}

long long p, n, d, b;
vector < long long > a;

void one(){
	long long border_l = 0;
	vector < long long > temp(n);

	for (int i = 0; i < n; i++){
		temp[i] = a[i] - b;
		temp[i] = max(temp[i], (long long)0);
	}

	node * root = build(0, n - 1, temp);

	long long ans = 0;
	
	for (int i = 0; i < n; i++){
		if (a[i] >= b)
			continue;
		long long delta = b - a[i];

		long long left = max(border_l, i - d*(i + 1));
		long long right = min(n - 1, i + d*(i + 1));
		long long pos = max(border_l, i - d*(i + 1));


		if (left > right){
			ans++;
			continue;
		}
		if (query(root, pos, right) < delta){
			ans++;
			continue;
		}

		while (left < right){
			long long mid = (left + right) / 2;
			long long get = query(root, pos, mid);
			if (get < delta){
				left = mid + 1;
			}
			else {
				right = mid;
			}
		}

		long long d1 = query(root, pos, left - 1);
		long long val = query(root, left, left);
		long long new_val = val - (b - a[i] - d1);
		update_one(root, left, new_val);
		border_l = left - 1;
	}
	cout << ans;
	system("pause");
}




int main(){
	cin >> p >> n >> d >> b;
	a.assign(n, 0);

	for (int i = 0; i < n; i++){
		cin >> a[i];
	}
	if (p == 1){
		one();
	}
}