#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<iomanip>

using namespace std;

const int inf = 1e9;

struct node{
	int left, right;
	long long sum;
	long long val = -1;
	node * child_left, *child_right;
};

node* build(int left, int right, vector<long long> & values){
	if (left > right)
		return 0;
	node * res = new node;
	res->left = left;
	res->right = right;
	if (right == left){
		res->child_left = res->child_right = 0;
		res->sum = values[left];
	}
	else {
		int mid = (left + right) / 2;

		res->child_left = build(left, mid, values);
		res->child_right = build(mid + 1, right, values);

		res->sum = res->child_left->sum + res->child_right->sum;
	}
	return res;
}

long long query(node * root, int left, int right){
	if (right < root->left || left > root->right)
		return 0;
	if (root->val == 0) {
		return 0;
	}
	if (left <= root->left && right >= root->right)
		return root->sum;
	long long ans1 = query(root->child_left, left, right);
	if (root->child_left->val == 0) {
		ans1 *= 0;
	}
	long long ans2 = query(root->child_right, left, right);
	if (root->child_right->val == 0) {
		ans2 *= 0;
	}
	return ans1 + ans2;
}

void update_zero(node * root, int left, int right) {
	if (left > right)
		return;

	if (right < root->left || left > root->right)
		return;

	if (left <= root->left && right >= root->right) {
		root->val = 0;
		return;
	}
	long long ans1 = root->child_left->sum;
	if (root->child_left->val == 0) {
		ans1 *= 0;
	}
	long long ans2 = root->child_right->sum;
	if (root->child_right->val == 0) {
		ans2 *= 0;
	}
	root->sum = ans1 + ans2;
}


void update_one(node * root, int idx, int val) {
	if (idx < root->left || idx > root->right)
		return;
	if (root->left == root->right){
		root->sum = val;
		return;
	}
	update_one(root->child_left, idx, val);
	update_one(root->child_right, idx, val);
	root->sum = root->child_left->sum + root->child_right->sum;
	return;
}

long long p, n, d, b;
vector < long long > a;


long long get_sum(long long l, long long r, vector < long long > &sum) {
	if (l == 0)
		return sum[r];
	return sum[r] - sum[l - 1];
}

void one() {

	long long suml = 0;

	vector < long long > temp(n);

	vector < long long > sum(n);


	for (int i = 0; i < n; i++) {
		temp[i] = a[i] - b;
		temp[i] = max(temp[i], (long long)0);
	}
	sum[0] = temp[0];
	for (int i = 1; i < n; i++) {
		sum[i] = sum[i - 1] + temp[i];
	}

	long long ans = 0;
	
	for (int i = 0; i < n; i++){
		if (a[i] >= b)
			continue;
		long long delta = b - a[i];

		long long left = max((long long) 0 , i - d * (i + 1));
		long long right = min(n - 1, i + d*(i + 1));
		
		if (get_sum(suml, right, sum) < delta) {
			ans++;
		}

		for (int i = suml; i < n; i++) {
			if (temp[i] > delta) {
				temp[i] -= delta;
				delta = 0;
				suml = i;
				break;
			}
			delta -= temp[i];
		}
	}
	cout << ans;
	system("pause");
}




int main(){
	cin >> p >> n >> d >> b;
	a.assign(n, 0);

	for (int i = 0; i < n; i++){
		cin >> a[i];
	}
	if (p == 1){
		one();
	}
}