import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class C {

	public static class Tree {
		int[] sum;
		
		public Tree(int n) {
			sum = new int[n];
		}
		
		public void add(int x, long delta) {
			for (; x < sum.length; x = x | (x + 1)) {
				sum[x] += delta;
			}
		}
		
		public int sum(int r) {
			if (r >= sum.length) {
				r = sum.length - 1;
			}
			int ans = 0;
			for (; r >= 0; r = (r & (r + 1)) - 1) {
				ans += sum[r];
			}
			return ans;
		}
		
		public int sum(int l, int r) {
			return sum(r) - sum(l - 1);
		}
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		StringTokenizer st = new StringTokenizer(in.readLine());
		int p = Integer.parseInt(st.nextToken());
		int n = Integer.parseInt(st.nextToken());
		int d = Integer.parseInt(st.nextToken());
		int b = Integer.parseInt(st.nextToken());
		int[] a = new int[n];
		st = new StringTokenizer(in.readLine());
		for (int i = 0; i < a.length; i++) {
			a[i] = Integer.parseInt(st.nextToken());
		}
		int[] sum = new int[n + 1];
		for (int i = 0; i < a.length; i++) {
			sum[i + 1] = sum[i] + a[i];
		}
		int l = -1;
		int r = n;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			boolean flag = true;
			for (int i = m; i < a.length; i++) {
				int right = Math.min(n - 1, i + (i + 1) * d);
//				System.out.println(m + " " + i + " " + right + " " + sum[right + 1]);
				if (sum[right + 1] < (i - m + 1) * b) {
					flag = false;
					break;
				}
			}
			if (flag) {
				r = m;
			} else {
				l = m;
			}
		}
		out.println(r);
		in.close();
		out.close();
	}

}
