#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("b.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}
void dfsTopsort(const vector<vector<int>>& g, vector<int>& out, vector<bool>& visited, int v) {
    visited[v] = true;
    for (auto w : g[v]) {
        if (visited[w]) continue;
        dfsTopsort(g, out, visited, w);
    }
    out.push_back(v);
}

void dfsPaint(const vector<vector<int>>& g_i, vector<int>& out, vector<bool>& visited, int v, int color, map<int, int>& m) {
    visited[v] = true;
    m[v] = color;
    for (auto w : g_i[v]) {
        if (visited[w]) continue;
        dfsPaint(g_i, out, visited, w, color, m);
    }
    out.push_back(v);
}

void $main(ll testId) {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    vector<int> c1(m), c2(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> g(n), g_i(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        for (int __j = 0; __j < 2; ++__j) {
            swap(u, v);
            if ((a[u] + 1) % h == a[v]) {
                g[u].push_back(v);
                g_i[v].push_back(u);
            }
        }
    }
    vector<int> ts;
    vector<bool> visited(n);
    for (int i = 0; i < n; ++i) {
        if (visited[i]) continue;
        dfsTopsort(g, ts, visited, i);
    }
    for (int i = 0; i < n; ++i) visited[i] = false;
    reverse(ts.begin(), ts.end());
    vector<vector<int>> components;
    map<int, int> color;
    for (int i = 0; i < n; ++i) {
        if (visited[i]) continue;
        int k = components.size();
        components.emplace_back();
        dfsPaint(g_i, components[k], visited, i, k, color);
    }
    set<int> wasted;
    for (int u = 0; u < n; ++u) {
        for (int v : g[u]) {
            if (color[v] != color[u]) {
                wasted.insert(color[u]);
            }
        }
    }
    vector<int> justAVec;
    vector<int>& best = justAVec;
    int bsize = 1e9;
    int t = -1;
    for (auto& c : components) {
        ++t;
        if (c.size() < bsize && wasted.count(t) == 0) {
            best = c;
            bsize = c.size();
        }
    }
    cout << best.size() << "\n";
    for (auto x : best) cout << x + 1 << " ";
    cout << "\n";
}
