#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#define endl '\n'

using namespace std;

typedef long long ll;

void dfs(vector<vector<int>> &g, vector<int> &used, int cv, int col, vector<int> &vs) {
    used[cv] = col;
    vs.back()++;
    for (int nv : g[cv]) {
        if (!used[nv]) {
            dfs(g, used, nv, col, vs);
        }
    }
}

void topsort(vector<vector<int>> &g, vector<int> &used, int cv, vector<int> &ts) {
    used[cv] = 1;
    for (int nv : g[cv]) {
        if (!used[nv]) {
            topsort(g, used, nv, ts);
        }
    }
    ts.push_back(cv);
}

int main() {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<vector<int>> g(n), negg(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        if ((t[a - 1] + 1) % h == t[b - 1]) {
            g[a - 1].push_back(b - 1);
            negg[b - 1].push_back(a - 1);
        }
        if ((t[b - 1] + 1) % h == t[a - 1]) {
            g[b - 1].push_back(a - 1);
            negg[a - 1].push_back(b - 1);
        }
    }

    vector<int> ts, used(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            topsort(g, used, i, ts);
        }
    }
    reverse(ts.begin(), ts.end());

    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
    vector<int> vs;
    int col = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[ts[i]]) {
            col++;
            vs.push_back(0);
            dfs(negg, used, ts[i], col, vs);
        }
    }
    vector<vector<int>> sumg(col);
    for (int i = 0; i < n; ++i) {
        for (int j : g[i]) {
            if (used[i] - 1 != used[j] - 1) {
                sumg[used[i] - 1].push_back(used[j] - 1);
            }
        }
    }
    int anscol = -1, anss = n + 1;
    for (int i = 0; i < col; ++i) {
        if (sumg[i].empty() && vs[i] < anss) {
            anscol = i;
            anss = vs[i];
        }
    }
    cout << anss << endl;
    for (int i = 0; i < n; ++i) {
        if (used[i] == anscol + 1) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
}