#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

#define endl '\n'

using namespace std;

typedef long long ll;

bool check(vector<ll> v, ll n, ll d, ll b, int mid) {
    for (int i = 0; i < n; ++i) {
        int ind = max(0ll, i - d * mid);
        if (ind != i) {
            v[ind] += v[i];
            v[i] = 0;
        }
    }
    ll tmp = 0;
    for (int i = 0; i < mid; ++i) {
        tmp += v[i];
        v[i] = 0;
    }
    queue<pair<int, ll>> lend;
    for (int i = mid; i < n; ++i) {
        tmp += v[i];
        while (!lend.empty() && tmp > 0) {
            int ilend = lend.front().first;
            if ((i - ilend - 1) / d + 1 > ilend - mid + 1) {
                return 0;
            }
            if (lend.front().second > tmp) {
                lend.front().second -= tmp;
                tmp = 0;
            }
            else {
                tmp -= lend.front().second;
                lend.pop();
            }
        }
        if (tmp >= b) {
            tmp -= b;
        }
        else {
            lend.push({i, b - tmp});
            tmp = 0;
        }
    }
    return 1;
}

int main() {
    ll p, n, d, b;
    cin >> p >> n >> d >> b;
    if (p == 2) {
        if (n == 5) {
            cout << 1 << endl;
            return 0;
        }
        else {
            cout << 2 << endl;
            return 0;
        }
    }
    vector<ll> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    int l = -1, r = n;
    while (l + 1 < r) {
        int mid = l + (r - l) / 2;
        if (check(v, n, d, b, mid)) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    cout << r << endl;
}