#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int MAXN = 1e5 + 10;
int times[MAXN];
vector<int> g[MAXN], rg[MAXN], ng[MAXN];
vector<int> p;
set<pair<int, int>> used_edges;
bool used[MAXN];
int clr = 0;
int color[MAXN];
int sz[MAXN];
vector<int> ans;
int best_end = -1;

void top_sort(int u) {
    used[u] = true;
    for (auto v : rg[u]) {
        if (!used[v])
            top_sort(v);
    }
    p.push_back(u);
}

void dfs(int u) {
    used[u] = true;
    color[u] = clr;
    sz[clr]++;
    for (auto v : g[u]) {
        if (!used[v])
            dfs(v);
    }
}

void find_ends(int u) {
    used[u] = true;
    if (ng[u].size() == 0) {
        if (best_end == -1 || (sz[u] < sz[best_end])) {
            best_end = u;
        }
    }
    for (auto v : ng[u])
        if (!used[v])
            find_ends(v);
}

int main() {
    //#undef KEK
    #ifdef KEK
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // KEK
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> times[i];
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if (times[u] == (times[v] + 1) % h) {
            g[v].push_back(u);
            rg[u].push_back(v);
            //cout << "add " << v << " " << u << "\n";
        }
        if (times[v] == (times[u] + 1) % h) {
            g[u].push_back(v);
            rg[v].push_back(u);
            //cout << "add " << u << " " << v << "\n";
        }
    }
    for (int i = 0; i < n; i++)
        if (!used[i])
            top_sort(i);
    memset(used, 0, sizeof(used));
    reverse(p.begin(), p.end());
    /*for (auto i : p)
        cout << i + 1 << " ";
    cout << "\n";*/
    for (auto u : p) {
        if (used[u])
            continue;
        dfs(u);
        clr++;
    }
    for (int u = 0; u < n; u++) {
        for (auto v : g[u]) {
            if (color[u] == color[v])
                continue;
            if (!used_edges.count({color[u], color[v]})) {
                used_edges.insert({color[u], color[v]});
                ng[color[u]].push_back(color[v]);
            }
        }
    }
    memset(used, 0, sizeof(used));
    for (int i = 0; i < clr; i++)
        if (!used[i])
            find_ends(i);
    for (int i = 0; i < n; i++)
        if (color[i] == best_end)
            ans.push_back(i);
    cout << ans.size() << "\n";
    for (auto i : ans)
        cout << i + 1 << " ";
    return 0;
}
