#include <bits/stdc++.h>

using namespace std;

vector<int> toprint;

bool isHere(vector<int>& a, int n) {
    int left = 0;
    int right = a.size();
    while (right - left > 1) {
        int mid = (right + left) / 2;
        if (a[mid] > n) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return a[left] == n;
}

bool fastCheck(vector<int>& a) {
    sort(a.begin(), a.end());
    for (size_t i = 0; i < a.size(); ++i) {
        if (isHere(a, -a[i]) && isHere(a, a[i] * 2)) {
            return false;
        }
    }
    return true;
}

bool check(vector<int>& res, vector<int>& a) {
    vector<bitset<4096>> dp(res.size() + 1);

    if (!fastCheck(res)) {
        return false;
    }

    dp[0][2048] = true;
    int mn = 2048;
    int mx = 2048;
    for (int i = 0; i < res.size(); ++i) {

        for (int j = mn; j <= mx; ++j) {
            if (dp[i][j]) {
                dp[i + 1][j] = dp[i + 1][j + res[i]] = true;
                mx = max(mx, j + res[i]);
                mn = min(mn, j + res[i]);
            }
        }
    }
    for (int i = 0; i < a.size(); ++i) {
        if (!dp[res.size()][a[i] + 2048]) {
            return false;
        }
    }
    return true;
}

void getRes(int n, vector<int>& tores, vector<int>& res, vector<int>& a) {
    if (n == res.size()) {
        if (tores.size() < toprint.size()) {
            if (check(tores, a)) {
                toprint.resize(tores.size());
                for (int i = 0; i < toprint.size(); ++i) {
                    toprint[i] = tores[i];
                }
            }
        }
    } else {
        getRes(n + 1, tores, res, a);
        tores.push_back(res[n]);
        getRes(n + 1, tores, res, a);
        tores.pop_back();
    }
}

int main() {
    toprint.resize(100);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> res;
    for (int i = 0; i <= 10; ++i) {
        res.push_back(1 << i);
        res.push_back(-(1 << i));
    }
    vector<int> tores;
    getRes(0, tores, res, a);
    cout << toprint.size() << endl;
    for (int i = 0; i < toprint.size(); ++i) {
        cout << toprint[i] << " ";
    }
    return 0;
}
