#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>

using namespace std;

typedef int64_t ll;

int main()
{
    string s;
    cin >> s;
    vector<int> left(s.length(), -1);
    vector<int> right(s.length(), -1);
    queue<int> q;
    for (int i = 0; i < (int)s.length(); ++i) {
        if (s[i] == '0') {
            q.push(i);
        } else {
            if (q.empty()) {
                cout << -1;
                return 0;
            }
            left[i] = q.front();
            right[q.front()] = i;
            q.pop();
        }
    }
    q = queue<int>();
    for (int i = (int)s.length() - 1; i >= 0; --i) {
        if (s[i] == '0') {
            q.push(i);
        } else {
            if (q.empty()) {
                cout << -1;
                return 0;
            }
            right[i] = q.front();
            left[q.front()] = right[i];
            q.pop();
        }
    }
    vector<bool> used(s.length());
    vector<vector<int>> res;
    for (int i = 0; i < (int)s.length(); ++i) {
        if (!used[i]) {
            res.push_back(vector<int>());
            res.back().push_back(i);
            used[i] = true;
            while (right[res.back().back()] != -1) {
                res.back().push_back(right[res.back().back()]);
                used[res.back().back()] = true;
            }
        }
    }
    cout << res.size() << endl;
    for (int i = 0; i < (int)res.size(); ++i) {
        cout << res[i].size() << " ";
        for (int j = 0; j < (int)res[i].size(); ++j) {
            cout << res[i][j] + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}
