#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()
#define sz(x) x.size()

vector <vector <int>> eNorm;
vector <vector <int>> eBack;
vector <int> costs;
int h;

void check_edge(int u, int v)
{
	if ((costs[u] + 1) % h == costs[v])
	{
		eNorm[u].push_back(v);
		eBack[v].push_back(u);
	}
}

vector <bool> used;
vector <int> arr;
void topsort(int now)
{
	used[now] = true;
	for (int i = 0; i < eNorm[now].size(); i++)
	{
		int v = eNorm[now][i];
		if (!used[v])
		{
			topsort(v);
		}
	}
	arr.push_back(now);
}

vector <vector <int>> Strong;
int times = 0;
vector <int> colors;
void backDfs(int now)
{
	used[now] = true;
	colors[now] = times;
	Strong[times].push_back(now);
	for (int i = 0; i < eBack[now].size(); i++)
	{
		int v = eBack[now][i];
		if(!used[v])
			backDfs(v);
	}
}
////

signed main()
{
#ifndef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(6);
	int n, m;
	cin >> n >> m >> h;
	costs.resize(n);
	eBack.resize(n);
	eNorm.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> costs[i];
	}
	set <pair<int, int>> allEdges;
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		check_edge(u, v);
		check_edge(v, u);
	}
	//Считал ребра и создал массив прямых и реверснутых ребер, которые влияют, не имеют значения дублированные ребра

	used.resize(n);
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
			topsort(i);
	}
	reverse(all(arr));

	/*
	cout << "topsort "<<endl;
	for (int i = 0; i < arr.size(); i++)
	{
		cout << arr[i]<<" ";
	}
	cout << endl << endl;
	*/
	//Сделал топсорт 
	used.assign(n, false);
	colors.resize(n);
	for (int i = 0; i < n; i++)
	{
		int now = arr[i];
		if (!used[now])
		{
			Strong.resize(times + 1);
			backDfs(now);
			times++;
		}
	}
	/*
	cout << "Вывод компонент сильной связности" << endl;
	for (int i = 0; i < Strong.size(); i++)
	{
		for (int j = 0; j < Strong[i].size(); j++)
		{
			cout << Strong[i][j] <<" "<<colors[Strong[i][j]]<<" | ";
		}
		cout << endl;
	}
	cout << endl;
	*/
	//Выделил вершины по их принадлежности к компонентам сильной связности
	
	int cNums = Strong.size();
	vector <vector <int>>colway(cNums);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < eNorm[i].size(); j++)
		{
			int u = eNorm[i][j];
			if (colors[i] != colors[u])
			{
				colway[colors[i]].push_back(colors[u]);
			}
		}
	}

	/*
	cout << "Пути из одного цвета в другой";
	for (int i = 0; i < cNums; i++)
	{
		cout << "from "<<i<<" to : ";
		for (int j = 0; j < colway[i].size(); j++)
		{
			cout << colway[i][j] <<" ";
		}
		cout << endl;
	}
	*/

	//Создал массив путей из одного цвета в другой, выгоднее всего брать цвета, 
	// размеры которых минимальны и из которых нет путей в другие цвета.
	int minColor = -1;
	for (int i = 0; i < cNums; i++)
	{
		if (colway[i].size() == 0)
		{
			if (minColor == -1)
				minColor = i;
			else
			{
				if (Strong[i].size() < Strong[minColor].size())
				{
					minColor = i;
				}
			}
		}
	}
	
	cout << Strong[minColor].size()<<endl;
	for (int i = 0; i < n; i++)
	{
		if(colors[i] == minColor)
		{
			cout << i + 1<<" ";
		}
	}
	return 0;
}