#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()
#define sz(x) x.size()

////

void fBig(int &x)
{
	x = x | (x + 1);
}

void fLess(int &x)
{
	x = (x & (x + 1)) - 1;
}

vector <int> tree;
void upd(int ind, int delta)
{
	for (int x = ind; x < tree.size(); fBig(x))
	{
		tree[x]+=delta;
	}
}

int get_s(int x0)
{
	int sum = 0;
	for (int x = x0; x >= 0; fLess(x))
	{
		sum += tree[x];
	}
	return sum;
}

int get(int l, int r)
{
	r = min(r, int(tree.size() - 1));
	l = min(l, int(tree.size()));
	if (l == 0)
		return get_s(r);
	else
		return get_s(r) - get_s(l - 1);
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(6);
	int p,n,d,b;
	cin >> p >> n >> d >> b;
	vector <int> A(n + 1);
	tree.resize(n+1);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
		upd(i, A[i]);
	}
	int lr = -1;
	for (int i = 0; i + d < n; i++)
	{
		A[i] += A[i + d];
		A[i + d] = 0;
	}
	for (int i = 0; i < n; i++)
	{
		int l = max(lr + 1, i);
		A[i] = get(l, i + (i + 1) * d);
		lr = i + (i + 1) * d;
	}
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (A[i] < b)
			cnt++;
		else
		{
			int notNeed = A[i] - b;
			A[i + 1] += notNeed;
			A[i] = b;
		}
	}

	/*for (int i = 0; i < n; i++)
	{
		cout << A[i] <<" ";
	}
	cout << endl;*/
	cout << cnt;
	return 0;
}