#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

//kandinsky

const int N = 100005;
int n, m, h;
int a[N];
vector <int> g[N], gr[N];
int sz[N];
int used[N];
bool used1[N];

int scc[N];
int scc_sz[N];
vector <int> vtx[N];
set <int> scc_g[N];
int sz2[N];
bool used3[N];

vector <int> ord;
void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    used[v] = 2;
    ord.pb(v);
}

void dfs1(int v, int s) {
    used1[v] = true;
    scc[v] = s;
    scc_sz[s]++;
    vtx[s].pb(v);
    for (auto u : gr[v]) {
        if (!used1[u]) dfs1(u, s);
    }
}

void dfs2(int v) {
    sz2[v] = scc_sz[v];
    for (auto u : scc_g[v]) {
        if (!sz2[u]) dfs2(u);
            sz2[v] += sz2[u];
    }
}

vector <int> ans;
void dfs3(int v) {
    used3[v] = true;
    for (auto el : vtx[v]) {
        ans.pb(el);
    }
    for (auto u : scc_g[v]) {
        if (!used3[u]) dfs3(u);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    cin >> n >> m >> h;
    rep(i, n) {
        cin >> a[i];
    }
    vector <pair <int, int>> edges;
    rep(i, m) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (a[v] == (a[u] + 1) % h) {
            g[u].pb(v);
            gr[v].pb(u);
            edges.pb(mp(u, v));
        } else if ((a[v] + 1) % h == a[u]) {
            g[v].pb(u);
            gr[u].pb(v);
            edges.pb(mp(v, u));
        }
    }

    rep(i, n) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(all(ord));
    int S = 0;
    for (int i = 0; i < n; ++i) {
        if (!used1[ord[i]]) {
            dfs1(ord[i], S);
            S++;
        }
    }

    for (auto e : edges) {
        int v = scc[e.f], u = scc[e.s];
        if (v != u) {
            scc_g[v].insert(u);
        }
    }

    for (int i = 0; i < S; ++i) {
        if (!sz2[i]) {
            dfs2(i);
        }
    }
    int mins = 0;
    for (int i = 0; i < S; ++i) {
        if (sz2[i] < sz2[mins]) mins = i;
    }

    cout << sz2[mins] << '\n';
    dfs3(mins);
    for (auto el : ans) {
        cout << el + 1 << ' ';
    }
    cout << endl;

    return 0;
}
/*

3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3

5 6 4
2 1 0 3 0
4 3
3 2
1 2
1 4
1 3
5 2

*/
