#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

int n, m, h;
int ans;

vector <int> u;
vector <pair <int, int>> c;
vector <vector <int>> ind;
vector <int> res;
vector <int> cur_time;

int inc(int x) {
    return (x + 1) % h;
}

int cnt = 0;
vector <int> tmp;

void try_inc(int i) {
    cur_time[i] = inc(cur_time[i]);
    ++cnt;
    tmp.push_back(i);
    for (auto v : ind[i]) {
        int fir = c[v].first;
        int sec = c[v].second;
        if (sec == i) swap(fir, sec);
        if (cur_time[i] == cur_time[sec]) {
            try_inc(sec);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    cin >> n >> m >> h;
    u.resize(n);
    for (int i = 0; i < n; ++i) cin >> u[i];
    c.resize(m);
    ind.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> c[i].first >> c[i].second;
        --c[i].first;
        --c[i].second;
        ind[c[i].first].push_back(i);
        ind[c[i].second].push_back(i);
    }
    ans = n;
    for (int i = 0; i < n; ++i) {
        res.push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cur_time = u;
        tmp.clear();
        cnt = 0;
        try_inc(i);
        if (cnt < ans) {
            ans = cnt;
            res = tmp;
        }
    }
    cout << ans << "\n";
    for (auto e : res) {
        cout << e + 1 << " ";
    }
}
