#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

int n, m, h;
int ans;

vector <int> u;
vector <pair <int, int>> c;
vector <vector <int>> ind;
vector <int> res;
vector <int> used;

int inc(int x) {
    return (x + 1) % h;
}

int cnt = 0;
bool flag = true;

void try_inc(int i, set <int> &was, vector <int> &tmp) {
    was.insert(i);
    if (used[i]) {
        flag = false;
        return;
    }
    ++cnt;
    tmp.push_back(i);
    for (auto v : ind[i]) {
        int fir = c[v].first;
        int sec = c[v].second;
        if (sec == i) swap(fir, sec);
        if (!was.count(sec)) {
            try_inc(sec, was, tmp);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    cin >> n >> m >> h;
    u.resize(n);
    for (int i = 0; i < n; ++i) cin >> u[i];
    c.resize(m);
    ind.resize(n);
    used.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> c[i].first >> c[i].second;
        --c[i].first;
        --c[i].second;
        int x = u[c[i].first];
        int y = u[c[i].second];
        if (inc(x) == y) {
            ind[c[i].first].push_back(i);
        }
        if (inc(y) == x) {
            ind[c[i].second].push_back(i);
        }
    }
    ans = n;
    for (int i = 0; i < n; ++i) {
        res.push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        set <int> was;
        vector <int> tmp;
        cnt = 0;
        flag = true;
        try_inc(i, was, tmp);
        if (flag && cnt < ans) {
            ans = cnt;
            res = tmp;
        }
        used[i] = 1;
    }
    cout << ans << "\n";
    for (auto e : res) {
        cout << e + 1 << " ";
    }
}
