#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)2e3 + 7;

typedef long long LL;

using namespace std;

int n, m, h, t[N];
bool ch[N] = {}, used[N];
vector <int> gr[N];

void read() {
	cin >> n >> m >> h;
	for (int i = 0; i < n; i++)
		cin >> t[i];
	for (int i = 0; i < m; i++) {
		int c1, c2;
		cin >> c1 >> c2;
		gr[i].push_back(m - 1 + c1);
		gr[i].push_back(m - 1 + c2);
		gr[m - 1 + c1].push_back(i);
		gr[m - 1 + c2].push_back(i);
	}
}

bool khun(int v) {
	int u1 = gr[v][0], u2 = gr[v][1];
	if (t[u1] != t[u2])
		return true;
	used[v] = true;
	if (!ch[u1]) {
		t[u1]++, ch[u1] = true;
		t[u1] %= h;
		bool fl = true;
		for (int i = 0; i < (int)gr[u1].size(); i++) {
			int to = gr[u1][i];
			int t1 = gr[to][0], t2 = gr[to][1];
			if (t[t1] == t[t2] && !khun(to)) {
				fl = false;
				break;
			}
		}
		if (fl)
			return true;
		t[u1]--, ch[u1] = false;
		if (t[u1] == -1)
			t[u1] = h - 1;
	}
	if (!ch[u2]) {
		t[u2]++, ch[u2] = true;
		t[u2] %= h;
		bool fl = true;
		for (int i = 0; i < (int)gr[u2].size(); i++) {
			int to = gr[u2][i];
			int t1 = gr[to][0], t2 = gr[to][1];
			if (t[t1] == t[t2] && !khun(to)) {
				fl = false;
				break;
			}
		}
		if (fl)
			return true;
		t[u2]--, ch[u2] = false;
		if (t[u2] == -1)
			t[u2] = h - 1;
	}
	return false;
}

/*void solve() {
	for (int i = 0; i < m; i++) {
		fill(used, used + N, false);
		khun(i);
	}
	vector <int> ans;
	for (int i = 0; i < n; i++)
		if (ch[i])
			ans.push_back(i + 1);
	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++)
		cout << ans[i] << ' ';
}*/

void sub(int &x) {
	if (x == 0)
		x = h - 1;
	else
		x--;
}

void sum(int &x) {
	if (x == h - 1)
		x = 0;
	else
		x++;
}

void solve() {
	vector <int> ans(n + 1);
 	for (int i = 1; i < (1 << n); i++) {
		vector <int> cur;
		for (int j = 0; j < n; j++)
			if (i & (1 << j)) {
				sum(t[j]);
				cur.push_back(j + 1);
			}
		bool fl = true;
		for (int j = 0; j < m; j++) {
			if (t[gr[j][0] - m] == t[gr[j][1] - m]) {
				fl = false;
				break;
			}
		}
		for (int j = 0; j < n; j++)
			if (i & (1 << j))
				sub(t[j]);
		if (!fl)
			continue;
		if (ans.size() > cur.size())
			ans = cur;
	}
	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++)
		cout << ans[i] << ' ';
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	read();
	solve();
}